<?php
	// always continue execution of the script even if the user has hit the stop
	// button in the browser. This is very important in cases where ftp
	// transfers are taking place. It would be very bad if the browser were to
	// be closed and a user's file were ruined when being published to the server
	ignore_user_abort();

	// Set the error checking levels
	ini_set('display_errors', $SET_DISPLAY_ERRORS);
	ini_set('html_errors', $SET_HTML_ERRORS);
	error_reporting($SET_ERROR_REPORTING);

	// Turn off page caching
	header("Expires: Mon, 26 Jul 1997 05:00:00 GMT"); // Date in the past
	header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT"); // always modified
	header("Cache-Control: no-store, no-cache, must-revalidate"); // HTTP/1.1
	header("Cache-Control: post-check=0, pre-check=0", false); // HTTP/1.1
	header("Pragma: no-cache"); // HTTP/1.0

	// Setup our session
	session_name($SESSION_NAME);
	session_start();

	// Define a utility funciton to recursively strip slashes
	function stripslashes_recursive($value){
		if(is_array($value)){
			foreach($value as $index => $val){
				$value[$index] = stripslashes_recursive($val);
			}
			return $value;
		}else{ return stripslashes($value); }
	}

	// Define a utility funciton to recursively replace double ticks with a single tick 
	function stripticks_recursive($value){
		if(is_array($value)){
			foreach($value as $index => $val){
				$value[$index] = stripticks_recursive($val);
			}
			return $value;
		}else{ return str_replace("''", "'", $value); }
	}

	// Turn off magic quotes and recursively fix any incoming data by stripping slash escaped characters (quotes, etc)
	set_magic_quotes_runtime(0);
	if(get_magic_quotes_gpc()) {
		$_GET = stripslashes_recursive($_GET);
		$_POST = stripslashes_recursive($_POST);
		$_COOKIE = stripslashes_recursive($_COOKIE);
		$_REQUEST = stripslashes_recursive($_REQUEST);
	}
	ini_set("magic_quotes_gpc",0);

	// Turn off sybase magic quotes and recursively fix any incoming data by replacing double ticks with single ticks 
	if(ini_get("magic_quotes_sybase")) {
		$_GET = stripticks_recursive($_GET);
		$_POST = stripticks_recursive($_POST);
		$_COOKIE = stripticks_recursive($_COOKIE);
		$_REQUEST = stripticks_recursive($_REQUEST);
	}
	ini_set("magic_quotes_sybase",0);

	// Make sure that each name/val pair in POST,GET,REQUEST gets their own PHP variable
	// Basically we're forcing register globals behavior
	foreach($_REQUEST as $var => $val){ if(isset($_REQUEST[$var])){ $$var = $val; } }
	foreach($_POST    as $var => $val){ if(isset($_POST[$var])){ $$var = $val; } }
	foreach($_GET     as $var => $val){ if(isset($_GET[$var])){ $$var = $val; } }

	// seed RNG with microseconds
	list($usec, $sec) = explode(' ', microtime());
	srand((float) $sec + ((float) $usec * 100000));

	// make sure the database settings have been set
	if(!isset($DB_SERVER_NAME) || !isset($DB_NAME) || !isset($DB_USER_NAME) || !isset($DB_PASSWORD)){
		echo "Could not connect to the database.<br>\n";
		echo "The settings file is either missing or incomplete. Please check the 'settings/settings.php'.<br>\n";
		exit();
	}
	else{
		// attempt to connect to the database
		$DBH = DB::connect("$DB_TYPE://$DB_USER_NAME:$DB_PASSWORD@$DB_SERVER_NAME/$DB_NAME", $DB_OPTIONS);
		if(DB::isError($DBH)) {
			echo "Could not connect to database<br>\n";
			echo "Please make sure the database settings in the 'settings/settings.php' file are correct.<br>\n";
			echo $DBH->getMessage() . "\n";
			exit();
		}

		$DBH->setFetchMode(DB_FETCHMODE_ASSOC);
	} // end else
?>
