<?php
	// ---------------------------------------------------------------------------
	// this function attempts to find all of the information associated with a
	// user by looking them up in the database with the $user_name and $password
	// supplied. On success, an associative array storing the user data is
	// returned. On error, a boolean FALSE is returned
	function get_user_struct_by_user_pw($user_name, $password){
		global $DBH;
		$user_struct = FALSE;

		// try to find the user's information in the database
		$query = "SELECT * FROM esy_users WHERE user_name = '${user_name}' AND user_password = '${password}' AND rec_status_id = 1";
		$db_result = $DBH->query($query);
		if(DB::isError($db_result)){ die($db_result->message.'<br>'.$db_result->userinfo); }
		if($db_result->numRows() > 0){
			$db_row = $db_result->fetchRow();
			extract($db_row);
			$user_struct = Array(
				'user_id' => $user_id, 'user_type_id' => $user_type_id, 'user_name' => $user_name, 'user_password' => $user_password,
				'full_name' => $full_name, 'last_login_timestamp' => $last_login_timestamp
			);
		} // end if

		return $user_struct;
	}
	// ---------------------------------------------------------------------------
	// this function is very similar to the one above. The only difference is
	// that the user data structure is looked up by their $user_id. On success, an 
	// associative array storing the user data is returned. On error, a boolean FALSE is returned
	function get_user_struct_by_user_id($user_id){
		global $DBH;
		$user_struct = FALSE;

		// try to find the user's information in the database
		$query = "SELECT * FROM esy_users WHERE user_id = '${user_id}' AND rec_status_id = 1";
		$db_result = $DBH->query($query);
		if(DB::isError($db_result)){ die($db_result->message.'<br>'.$db_result->userinfo); }
		if($db_result->numRows() > 0){
			$db_row = $db_result->fetchRow();
			extract($db_row);
			$user_struct = Array(
				'user_id' => $user_id, 'user_type_id' => $user_type_id, 'user_name' => $user_name, 'user_password' => $user_password,
				'full_name' => $full_name, 'last_login_timestamp' => $last_login_timestamp, 'email_address' => $email_address
			);
		} // end if

		return $user_struct;
	}
	// ---------------------------------------------------------------------------
	// this function takes an associative array containing all of the user's
	// data and attempts to set the user_id and user_password as session
	// variables. This of course assumes that the session has already been
	// registered (in loader). Boolean TRUE on success, FALSE on failure.
	function set_login_session($user_struct){
		$return_val = FALSE;

		if(isset($user_struct['user_id']) && is_numeric($user_struct['user_id']) && isset($user_struct['user_password']) && strlen($user_struct['user_password']) > 0){
			$_SESSION['user_id'] = $user_struct['user_id'];
			// for security reasons, don't store the raw password in the session. 
			$_SESSION['user_password'] = strrev(md5($user_struct['user_password']));
			#$_SESSION['trialexpiry'] = "$unmesk_f";
			$return_val = TRUE;
		}

		return $return_val;
	}
	// ---------------------------------------------------------------------------
	// this function unsets any session variables that get set during
	// the login process. very important when logging out
	function clear_login_session(){
		if(isset($_SESSION['user_id'])){ unset($_SESSION['user_id']); }
		if(isset($_SESSION['user_password'])){ unset($_SESSION['user_password']); }
	}
	// ---------------------------------------------------------------------------
	// this function first attempts to find any user data stored in the session.
	// Then, using that data, it attempts to retrieve the user struct from the
	// database which matches the session data found. The success of the
	// function is returned as the user struct array. On failure, a boolean FALSE. This function
	// assumes that the session has already been registered (in the loader)
	function get_login_status(){

		$return_val = FALSE;
		// check the format of the user id stored in the session
		if(isset($_SESSION['user_id']) && is_numeric($_SESSION['user_id']) && isset($_SESSION['user_password']) && strlen($_SESSION['user_password']) > 0){
			// try to get the details about the user
			$user_struct = get_user_struct_by_user_id($_SESSION['user_id']);
			if($user_struct !== FALSE){
				// generate the encrypted password string from the one found in the database
				$user_password = strrev(md5($user_struct['user_password']));
				// compare the session stored password with the one generated from the database
				if($user_password === $_SESSION['user_password']){
					$return_val = $user_struct;
				} // end if
			} // end if
		} // end if

		return $return_val;
	}
	// ---------------------------------------------------------------------------
	// this function updates the user's last login timestamp with the current
	// time.
	function set_user_last_login_timestamp($user_id){
		global $DBH;
		$return_val = FALSE;

		// make sure the user_id is a valid format
		if(is_numeric($user_id)){
			// make sure the user_id appears in the database
			$user_struct = get_user_struct_by_user_id($user_id);
			if($user_struct !== FALSE){
				$query = "UPDATE esy_users SET last_login_timestamp = ".time()." WHERE user_id = ${user_id}";
				$db_result = $DBH->query($query);
				if(DB::isError($db_result)){ die($db_result->message.'<br>'.$db_result->userinfo); }
				$return_val = TRUE;
			} // end if
		} // end if 
		return $return_val;
	}
	// ---------------------------------------------------------------------------
	// this function attempts to find a user's password based on the $user_name
	// supplied and email it to them. On success, a boolean TRUE is returned,
	// otherwise an array of error messages is returned.
	function send_forgot_password_email($user_name){
		global $DBH;

		$error_log = Array();

		if(strlen($user_name) > 0){
			$query = "SELECT full_name, email_address, user_password FROM esy_users WHERE user_name = '${user_name}' AND rec_status_id = 1";

			$db_result = $DBH->query($query);
			if(DB::isError($db_result)){ die($db_result->message.'<br>'.$db_result->userinfo); }
			if($db_result->numRows() > 0){
				$db_row = $db_result->fetchRow();
				extract($db_row);
				$full_name = ucwords(trim($full_name));
				$email_address = trim(strtolower($email_address));

				$to 		= "${full_name} <${email_address}>"; 
				$subject 	= "eSurvey Password Reminder";
				$message	= "${full_name},\n";
				$message	.= "eSurvey has successfully retrieved your password. It is:\n\n";
				$message	.= "${user_password}\n\n";

				// very important! the mail command will fail to deliver a complete
				// message if there are any occurences of \r\r. So we convert all \n and \r to \r\n.
				$message = str_replace("\r\n","\r",$message);
				$message = str_replace("\n","\r",$message);
				$message = str_replace("\r","\r\n",$message);

				$sendmail_from = ini_get('sendmail_from');

				$headers  = "MIME-Version: 1.0\r\n";
				$headers .= "Content-type: text; charset=iso-8859-1\r\n";
				$headers .= "To: ${full_name} <${email_address}>\r\n";
				if(strlen($sendmail_from) > 0){
					$headers .= "From: eSurvey <${sendmail_from}>\r\n";
				}

				// get any supplied smtp_server from the eSurvey settings
				$settings_struct = get_settings_struct();
				$old_smtp_server = ini_get('SMTP');
				$smtp_server = $settings_struct['smtp_server'];

				$email_sent = 0;
				$used_default_smtp = 0; // flag whether we've resorted to using PHP's default smtp config
				if(strlen($smtp_server) > 0){
					ini_set('SMTP', $smtp_server);
					// send the email, capture and return the success/failure code (1 or 0)
					$email_sent = @mail($email_address, $subject, $message, $headers);
					// remember that we need to try to default smtp config
					if(!$email_sent){ $used_default_smtp = 1; }
				} // end if

				// if we haven't sent an email, try try again
				if(!$email_sent){ 
					// if we've failed to send the email with the user specified smtp server
					// and no smtp server was found in php.ini, then PHP isn't configured to send email
					if($used_default_smtp && strlen($old_smtp_server) == 0){
						$error_log[] = "Could not send forgot password email.\nThe SMTP server connection specified under System Options\nfailed and PHP is not configured to send email.";
					}
					else{
						// try sending it using the existing PHP smtp settings 
						ini_set('SMTP',$old_smtp_server);
						// send the email, capture and return the success/failure code (1 or 0)
						$email_sent = @mail($email_address, $subject, $message, $headers);
						if(!$email_sent){ 
							$error_log[] = "Could not send the forgot password email. Make sure that PHP is configured to send email."; 
						}
					} // end else
				} // end if
			} // end if
			else{ $error_log[] = "The User Name '${user_name}' could not be found in the database."; }
		} // end if
		else{ $error_log[] = "The User Name '' is not valid."; }

		return (count($error_log) > 0) ? $error_log : TRUE; 
	}
	// ---------------------------------------------------------------------------
?>
