<?php
	// --------------------------------------------------------------------------
	// This function echos out the JavaScript code necessary to initialize the
	// edit survey form to a blank state
	function echo_survey_new_js(){
		// create a new question object
		echo "var curr_question = new Survey_Question();\n";
		// give it some default text
		echo "curr_question.question_text = 'Enter your question here';\n"; 
		// push it onto our internal database
		echo "ql_database.push(curr_question);\n";
		// update the html entries text
		echo "set_ql_entry_text(active_ql_entry, curr_question.question_text);\n";
		// hilite it
		echo "hilite_ql_entry(active_ql_entry);\n";
		// render the question details to the page
		echo "curr_question.render_to_page();\n";
		return;
	}
	// --------------------------------------------------------------------------
	// This function takes a valid survey id and creates the JavaScript code
	// necessary to populate the edit survey form with the data pulled from the database
	function echo_survey_load_js($survey_id){
		global $DBH;
		$query = "SELECT * FROM esy_surveys WHERE survey_id = $survey_id AND rec_status_id = 1";
		$db_result = $DBH->query($query);
		if(!DB::isError($db_result) && $db_result->numRows() == 1){ 
			$db_row = $db_result->fetchRow();
			extract($db_row);

			echo "document.getElementById('survey_name').value = \"".to_js_str($survey_name)."\";\n";
			echo "document.getElementById('user_instructions').innerHTML = \"".to_js_str(to_html_attrib_str($instructions))."\";\n";
			echo "document.getElementById('confirmation_msg').innerHTML = \"".to_js_str(to_html_attrib_str($confirmation))."\";\n";
			echo "document.getElementById('start_time_hour').value = \"".date('h', $start_timestamp)."\";\n";
			echo "document.getElementById('start_time_min').value = \"".date('i', $start_timestamp)."\";\n";
			echo "document.getElementById('start_time_ampm').innerHTML = \"".date('a', $start_timestamp)."\";\n";
			echo "document.getElementById('end_time_hour').value = \"".date('h', $end_timestamp)."\";\n";
			echo "document.getElementById('end_time_min').value = \"".date('i', $end_timestamp)."\";\n";
			echo "document.getElementById('end_time_ampm').innerHTML = \"".date('a', $end_timestamp)."\";\n";
			echo "select_radio_button(\"is_draft\",".($is_draft == 1 ? 0 : 1).");\n";

			// set up the start date calendar
			echo "with(start_calendar){\n";
			echo "	view_year = sel_year = ".date('Y',$start_timestamp).";\n";
			echo "	view_mon = sel_mon = ".date('n',$start_timestamp).";\n";
			echo "	view_day = sel_day = ".date('j',$start_timestamp).";\n";
			echo "}\n";
			echo "start_cal_onmouseout();\n";

			// set up the end date calendar
			echo "with(end_calendar){\n";
			echo "	view_year = sel_year = ".date('Y',$end_timestamp).";\n";
			echo "	view_mon = sel_mon = ".date('n',$end_timestamp).";\n";
			echo "	view_day = sel_day = ".date('j',$end_timestamp).";\n";
			echo "}\n";
			echo "end_cal_onmouseout();\n";
		}
		
		// retrieve all of the questions associated with this survey
		$cnt = 0;
		$query = "SELECT question_id, question_type_id, question_text, is_required, is_inc_stats, error_message 
				  FROM esy_questions 
				  WHERE survey_id = $survey_id AND rec_status_id = 1
				  ORDER BY order_number";
		$db_result = $DBH->query($query);
		if(!DB::isError($db_result) && $db_result->numRows() > 0){ 
			echo "var cq;\n";
			while($db_row = $db_result->fetchRow()){
				extract($db_row);

				// generate more html past the first entry
				if($cnt > 0){ echo "append_ql_html();\n"; }

				// create an instance of the JS Survey_Question class and populate it's attributes
				echo "cq = new Survey_Question(\"".$question_id."\",\"".to_js_str(to_html_attrib_str($question_text))."\",\"$is_inc_stats\",\"$is_required\",\"".to_js_str(to_html_attrib_str($error_message))."\",\"$question_type_id\");\n";

				// if the question has options, find them
				$query = "SELECT option_id, option_text 
						  FROM esy_options
						  WHERE question_id = $question_id AND rec_status_id = 1
						  ORDER BY order_number";
				$db_options_result = $DBH->query($query);
				if(!DB::isError($db_options_result) && $db_options_result->numRows() > 0){ 
					echo "cq.option_list = new Array();\n";
					while($db_row = $db_options_result->fetchRow()){
						extract($db_row);
						$option_text = to_js_str($option_text);
						echo "cq.option_list.push(new Survey_Option(\"$option_id\",\"$option_text\"));\n";
					}
				}

				// add the question entry to the JS database
				echo "ql_database.push(cq);\n";

				// set the text for the entry in the question list
				echo "set_ql_entry_text($cnt, cq.question_text);\n";

				$cnt++;
			}

			// hilite the active (first) entry
			echo "ql_database.gotoHead();\n";
			echo "hilite_ql_entry(active_ql_entry);\n";
			// render the active question details to the page
			echo "ql_database.getCursor().render_to_page();\n";
		}
		return;
	}
	// --------------------------------------------------------------------------
?>
