<?php
	// --------------------------------------------------------------------------
	// this function attempts to take the smtp_server and valid_file_ext
	// supplied by the user and save them to the settings table. 
	function save_settings($smtp_server,$valid_file_ext){
		global $DBH;
		global $DB_SERVER_NAME, $DB_NAME, $DB_USER_NAME, $DB_PASSWORD;
		global $DEF_PP_FILE_EXT;

		$ret_value = FALSE;

		// the first step is to make sure that at least one row exists in the settings table
		$query = "SELECT COUNT(*) AS settings_count FROM esy_settings WHERE rec_status_id = 1";
		$db_result = $DBH->query($query);
		if(DB::isError($db_result)){ die($db_result->message.'<br>'.$db_result->userinfo); }
		$db_row = $db_result->fetchRow();

		// if no settings row was found, insert a new row
		if($db_row['settings_count'] == 0){
			// prep the settings data for insert
			$db_server 			= to_db_str($DB_SERVER_NAME);
			$db_name 			= to_db_str($DB_NAME);
			$db_user_name 		= to_db_str($DB_USER_NAME);
			$db_password		= to_db_str($DB_PASSWORD);
			$pub_point_file_ext = to_db_str($DEF_PP_FILE_EXT);
			$query = "INSERT INTO esy_settings 
					  (db_server,db_name,db_user_name,db_password,smtp_server,pub_point_file_ext,rec_status_id) 
					  VALUES ('$db_server','$db_name','$db_user_name','$db_password','','$pub_point_file_ext',1);";
			$db_result = $DBH->query($query);
			if(DB::isError($db_result)){ die($db_result->message.'<br>'.$db_result->userinfo); }
		}

		// now find the highest setting_id so we know which row to update
		$query = "SELECT setting_id FROM esy_settings WHERE rec_status_id = 1 ORDER BY setting_id DESC";
		$db_result = $DBH->query($query);
		if(DB::isError($db_result)){ die($db_result->message.'<br>'.$db_result->userinfo); }
		if($db_result->numRows() > 0){
			$db_row = $db_result->fetchRow();
			$setting_id = $db_row['setting_id'];

			// prep our settings data
			$smtp_server = to_db_str($smtp_server);
			$valid_file_ext = to_db_str($valid_file_ext);

			// construct our query for updating the settings
			$query = "UPDATE esy_settings SET smtp_server = '$smtp_server', pub_point_file_ext = '$valid_file_ext' WHERE setting_id = $setting_id AND rec_status_id = 1";
			// save the settings data
			$db_result = $DBH->query($query);
			if(DB::isError($db_result)){ die($db_result->message.'<br>'.$db_result->userinfo); }
			$ret_value = TRUE;
		}

		return $ret_value;
	}
	// --------------------------------------------------------------------------
?>
