<?php
	// ---------------------------------------------------------------------------
	// this function finds all of the publish points in the database and
	// generates the html necessary to render them. 
	function get_pub_point_list_html($active_pub_point_id){
		global $DBH;
		$out_html = "";
		$rgb_array = Array("#ffffff","#e2edef");
		$active_rgb = "#fff7b2";
		$rgb_idx = 0;

		$query = 'SELECT publish_point_id, server_name, user_name FROM esy_publish_points WHERE rec_status_id = 1;';
		$db_result = $DBH->query($query);
		if(!DB::isError($db_result) && $db_result->numRows() > 0){
			while($db_row = $db_result->fetchRow()){ 
				extract($db_row);
				$display_name = "$user_name@$server_name";
				$entry_rgb = ($publish_point_id == $active_pub_point_id) ? $active_rgb : $rgb_array[$rgb_idx];
				$link_class = ($publish_point_id == $active_pub_point_id) ? "l_pp_active_link" : "l_pp_link";
				$out_html .= "
					<table cellspacing='0' cellpadding='0' border='0' style='background-color:${entry_rgb};'>
					<tr>
						<td width='263' height='21' align='left' valign='middle'>
							<div class='l_pp_item'><nobr>&#160;&#160;<a href='system_pub_points.php?page_action=load_pub_point&publish_point_id=${publish_point_id}' class='${link_class}' title='".to_html_attrib_str($display_name)."'>${display_name}</a></nobr></div>
						</td>
						<td width='44' height='21' align='left' valign='middle'>
							<a href='system_pub_points.php?page_action=load_pub_point&publish_point_id=${publish_point_id}'><img onmouseover='this.src=icon_pencil_on.src;' onmouseout='this.src=icon_pencil_off.src;' align='left' width='17' height='17' src='./images/global/icon/icon_pencil_off.gif' alt='Edit' title='Edit' hspace='2' vspace='0' border='0'></a>
							<a href='JavaScript:void(0);' onmouseup='delete_pub_point_onmouseup(${publish_point_id});'><img onmouseover='this.src=icon_trash_can_on.src;' onmouseout='this.src=icon_trash_can_off.src;' align='left' width='17' height='17' src='./images/global/icon/icon_trash_can_off.gif' alt='Delete' title='Delete' hspace='2' vspace='0' border='0'></a>
						</td>
					</tr>
					</table>
				";
				$rgb_idx = ($rgb_idx == (count($rgb_array)-1)) ? 0 : ++$rgb_idx;
			} // end while
		} // end if

		return $out_html;
	}
	// ---------------------------------------------------------------------------
	// this function attempts to save publish points details to the database. If
	// a publish point is provided, and UPDATE is attempted. If the publish
	// point id is blank, then the record is INSERTed. This function returns the
	// publish_point_id of the db record that was created/updated.
	function save_publish_point($publish_point_id,$ftp_server_name,$ftp_user_name,$ftp_user_password,$ftp_port_num,$ftp_is_passive,$ftp_default_dir){
		global $DBH;
		$return_val = FALSE;

		// prep all of our variables for db operations
		$ftp_server_name = to_db_str($ftp_server_name);
		$ftp_user_name = to_db_str($ftp_user_name);
		$ftp_user_password = to_db_str($ftp_user_password);
		$ftp_port_num = to_db_str($ftp_port_num);
		$ftp_is_passive = to_db_str($ftp_is_passive); 
		$ftp_default_dir = to_db_str($ftp_default_dir);

		// if a publish point id has been given, update the record
		if(strlen($publish_point_id) > 0 && is_numeric($publish_point_id)){
			$query = "UPDATE esy_publish_points SET 
					  server_name = '${ftp_server_name}', user_name = '${ftp_user_name}', 
					  password = '${ftp_user_password}',port_num = '${ftp_port_num}', 
					  is_passive = '${ftp_is_passive}', default_dir = '${ftp_default_dir}' 
					  WHERE publish_point_id = ${publish_point_id} AND rec_status_id = 1";
		} // end if
		// otherwise, do a fresh insert into the db
		else{
			$query = "INSERT INTO esy_publish_points (server_name,user_name,password,port_num,is_passive,default_dir,rec_status_id) 
					  VALUES ('".to_db_str($ftp_server_name)."','".to_db_str($ftp_user_name)."','".to_db_str($ftp_user_password)."',
					  '".to_db_str($ftp_port_num)."','".to_db_str($ftp_is_passive)."','".to_db_str($ftp_default_dir)."',1)";
		} // end else
		$db_result = $DBH->query($query);
		if(DB::isError($db_result)){ die($db_result->message.'<br>'.$db_result->userinfo); }

		// find the publish point id that was just generated in the database
		if(strlen($publish_point_id) ==  0 || !is_numeric($publish_point_id)){
			$query = "SELECT MAX(publish_point_id) AS publish_point_id FROM esy_publish_points WHERE 
					  server_name = '${ftp_server_name}' AND user_name = '${ftp_user_name}' AND 
					  password = '${ftp_user_password}' AND port_num = '${ftp_port_num}' AND 
					  is_passive = '${ftp_is_passive}' AND default_dir = '${ftp_default_dir}';";
			$db_result = $DBH->query($query);
			
######################################################
### Commented on 9/28 due to errors generated - ko ###
/*
			// if publish_point_id was found, return it
			if($db_result->numRows() > 0)
			{
				$db_row = $db_result->fetchRow();
				$return_val = $db_row['publish_point_id'];
			}
*/
#######################################################
		} // end if
		else{ $return_val = $publish_point_id; }

		return $return_val;
	}
	// ---------------------------------------------------------------------------
?>
