<?php
	// ---------------------------------------------------------------------------
	// this function finds all of the users in the database and
	// generates the html necessary to render them. If the user's user_type_id is an
	// Admin, then all users are displayed in the system, otherwise, only the
	// user's own account is displayed
	function get_user_list_html($curr_user_id, $active_user_id){
		global $DBH, $UID_ADMIN, $UID_USER;
		$out_html = "";
		$rgb_array = Array("#ffffff","#e2edef");
		$active_rgb = "#fff7b2";
		$rgb_idx = 0;

		// based on the current user's type id, figure out which users to display
		$user_struct = get_user_struct_by_user_id($curr_user_id);
		if($user_struct !== FALSE){
			if($user_struct['user_type_id'] == $UID_ADMIN){
				$query = 'SELECT user_id, full_name, user_name FROM esy_users WHERE rec_status_id = 1 ORDER BY full_name ASC;';
			}
			else{
				$query = 'SELECT user_id, full_name, user_name FROM esy_users WHERE rec_status_id = 1 AND user_id = '.$user_struct['user_id'].'ORDER BY full_name ASC;';
			}
			$db_result = $DBH->query($query);
			if($db_result->numRows() > 0){
				while($db_row = $db_result->fetchRow()){ 
					extract($db_row);
					$display_name = "$full_name ($user_name)";
					$entry_rgb = ($user_id == $active_user_id) ? $active_rgb : $rgb_array[$rgb_idx];
					$link_class = ($user_id == $active_user_id) ? "l_user_active_link" : "l_user_link";
					$out_html .= "
						<table cellspacing='0' cellpadding='0' border='0' style='background-color:${entry_rgb};'>
						<tr>
							<td width='263' height='21' align='left' valign='middle'>
								<div class='l_user_item'><nobr>&#160;&#160;<a href='system_user_management.php?page_action=load_user&mgt_user_id=${user_id}' class='${link_class}' title='".to_html_attrib_str($display_name)."'>${display_name}</a></nobr></div>
							</td>
							<td width='44' height='21' align='left' valign='middle'>
								<a href='system_user_management.php?page_action=load_user&mgt_user_id=${user_id}'><img onmouseover='this.src=icon_pencil_on.src;' onmouseout='this.src=icon_pencil_off.src;' align='left' width='17' height='17' src='./images/global/icon/icon_pencil_off.gif' alt='Edit' title='Edit' hspace='2' vspace='0' border='0'></a>
								<a href='JavaScript:void(0);' onmouseup='delete_user_onmouseup(${user_id});'><img onmouseover='this.src=icon_trash_can_on.src;' onmouseout='this.src=icon_trash_can_off.src;' align='left' width='17' height='17' src='./images/global/icon/icon_trash_can_off.gif' alt='Delete' title='Delete' hspace='2' vspace='0' border='0'></a>
							</td>
						</tr>
						</table>
					";
					$rgb_idx = ($rgb_idx == (count($rgb_array)-1)) ? 0 : ++$rgb_idx;
				} // end while
			} // end if
		} // end if

		return $out_html;
	}
	// ---------------------------------------------------------------------------
	// this function attempts to save user details to the database. If
	// a user id is provided, an UPDATE is attempted. If the user id 
	// is blank, then the record is INSERTed. This function returns the
	// user_id of the db record that was created/updated.
	function save_user($user_id,$user_type_id,$user_name,$user_password,$full_name,$email_address){
		global $DBH;
		$return_val = FALSE;

		// prep all of our variables for db operations
		$user_id = to_db_str($user_id);
		$user_type_id = to_db_str($user_type_id);
		$user_name = to_db_str($user_name);
		$user_password = to_db_str($user_password);
		$full_name = to_db_str($full_name);
		$email_address = to_db_str($email_address);
		$last_login_timestamp = time();

		// if a user id has been given, update the record
		if(strlen($user_id) > 0 && is_numeric($user_id)){
			$query = "UPDATE esy_users SET 
					  user_type_id = '${user_type_id}', user_name = '${user_name}', 
					  user_password = '${user_password}', full_name = '${full_name}', 
					  email_address = '${email_address}' 
					  WHERE user_id = ${user_id} AND rec_status_id = 1";
		} // end if
		// otherwise, do a fresh insert into the db
		else{
			$query = "INSERT INTO esy_users (user_type_id,user_name,user_password,full_name,email_address,last_login_timestamp,rec_status_id) 
					  VALUES ('${user_type_id}','${user_name}','${user_password}','${full_name}','${email_address}','$last_login_timestamp',1)";
		} // end else
		$db_result = $DBH->query($query);
		if(DB::isError($db_result)){ die($db_result->message.'<br>'.$db_result->userinfo); }

		// find the user id that was just generated in the database
		if(strlen($user_id) == 0 || !is_numeric($user_id)){
			$query = "SELECT MAX(user_id) AS user_id FROM esy_users WHERE 
					  user_type_id = '${user_type_id}' AND user_name = '${user_name}' AND 
					  user_password = '${user_password}' AND full_name = '${full_name}' AND 
					  email_address = '${email_address}' AND last_login_timestamp = '${last_login_timestamp}';";
			$db_result = $DBH->query($query);
			// if user_id was found, return it
			if($db_result->numRows() > 0){
				$db_row = $db_result->fetchRow();
				$return_val = $db_row['user_id'];
			}
		} // end if
		else{ $return_val = $user_id; }

		return $return_val;
	}
	// ---------------------------------------------------------------------------
	// this function returns the number of administrative users found in the
	// database.
	function get_admin_user_count(){
		global $DBH, $UID_ADMIN;
		$admin_count = 0;
		$query = "SELECT COUNT(*) AS admin_count FROM esy_users WHERE user_type_id = $UID_ADMIN AND rec_status_id = 1";
		$db_result = $DBH->query($query);
		if($db_result->numRows() > 0){
			$db_row = $db_result->fetchRow();
			$admin_count = $db_row['admin_count'];
		}
		return $admin_count;
	}
	// ---------------------------------------------------------------------------
?>
