<?php 
	require_once('./pear/DB.php');
	include_once('./settings/settings.php');
	include_once('./include/globals.php');
	include_once('./include/loader.php');
	include_once('./include/login_functions.php');
	// make sure the user has logged in before accessing this page
	if(($user_struct = get_login_status()) === FALSE){ header("Location: login.php"); exit(0); }

	include_once('./include/functions.php');
	include_once('./include/ftp_functions.php');

	// place to store all error messages
	$error_log = Array();
	$info_log = Array();

	$ftp_handle = FALSE;

	// make sure all variables that may be passed in get declared
	$survey_id = isset($_REQUEST['survey_id']) ? $_REQUEST['survey_id'] : '';
	$survey_tab = isset($_REQUEST['survey_tab']) ? $_REQUEST['survey_tab'] : '0';
	$page_action = isset($_REQUEST['page_action']) ? $_REQUEST['page_action'] : '';
	$publish_point_id = isset($_REQUEST['publish_point_id']) ? $_REQUEST['publish_point_id'] : '';
	$remote_file = isset($_REQUEST['remote_file']) ? $_REQUEST['remote_file'] : '';
	$orig_code = isset($_REQUEST['orig_code']) ? $_REQUEST['orig_code'] : '';
	$client_code_textarea = isset($_REQUEST['client_code_textarea']) ? $_REQUEST['client_code_textarea'] : '';
	$display_path = isset($_REQUEST['display_path']) ? $_REQUEST['display_path'] : '';

	// see if a valid survey id was passed in. Redirect back to survey list page if not
	if(get_survey_hash($survey_id) === FALSE){ header("Location: survey_list.php"); exit(0); }

	// get the details about the survey, so we can display the name
	$survey_data_struct = get_survey_data_struct($survey_id);

	// construct the javascript injection code snippet
	$injection_url = ereg_replace("insert_survey\.php.*","",get_curr_url());
	$injection_url = "http://${injection_url}client_modules/render_survey.php?survey_id=${survey_id}";
	$injection_js_code = "<script language='JavaScript' src='${injection_url}'></script>";

	// a lot of the page functionality should be disabled if no publish point
	// file has been loaded. See if the page is active, and use this data to
	// disable various form fields and buttons
	$page_is_active = ($page_action == 'load_file' || $page_action == 'write_file') ? TRUE : FALSE;

	// see if we'll need to open an ftp connection
	if($page_action == 'load_file' || $page_action == 'write_file'){
		// try to get the details about the publish point
		$pub_point_struct = get_pub_point_struct($publish_point_id);
		if($pub_point_struct !== FALSE){
			// load it's data into our variables
			$ftp_server_name 	= $pub_point_struct['server_name'];
			$ftp_username 		= $pub_point_struct['user_name'];
			$ftp_password 		= $pub_point_struct['password'];
			$ftp_port_num 		= $pub_point_struct['port_num'];
			$ftp_passive_mode 	= $pub_point_struct['is_passive'];
			$ftp_default_dir	= $pub_point_struct['default_dir'];

			$ftp_handle = get_ftp_connection($ftp_server_name, $ftp_username, $ftp_password, $ftp_port_num, $ftp_passive_mode);

			// if we couldn't connect, collect the error messages
			if(is_array($ftp_handle)){
				foreach($ftp_handle as $idx => $error_msg){ $error_log[] = $error_msg; }
			}
		} // end if

		// find the path to our temp_file directory
		$temp_file_path = dirname(__FILE__) . "\\temp_files";
	} // end if

	// LOAD_FILE STATE ACTIONS 
	if($page_action == 'load_file'){
		// try to load a file from the ftp server into our page
		if(!is_array($ftp_handle)){
			// construct the path string that the user sees
			$display_path = "$ftp_username@$ftp_server_name$remote_file";

			// try to get the contents of the file
			$client_code_textarea = get_ftp_file_contents($ftp_handle, $temp_file_path, $remote_file, "ascii");

			// if we couldn't get the file contents, collect the errors
			if(is_array($client_code_textarea)){
				foreach($client_code_textarea as $idx => $error_msg){ $error_log[] = $error_msg; }
				$client_code_textarea = '';
			}
			// keep track of the original code for doing reverts
			else{ $orig_code = $client_code_textarea; }
		} // end if
	} // end if 
	// WRITE_FILE STATE ACTIONS 
	elseif($page_action == 'write_file'){
		// try to load a file from the ftp server into our page
		if(!is_array($ftp_handle)){

			// undo our conversion of tabs to 4 spaces before we write the file
			$file_contents = str_replace("    ","\t", $client_code_textarea);
			// do the same for the orignal code that was loaded
			$orig_contents = str_replace("    ","\t", $orig_code);

			// just to be safe, store the file contents to our file archive
			store_contents_to_file_archive($publish_point_id, $remote_file, $orig_contents);

			// try to publish the new file contents
			$return_data = put_ftp_file_contents($ftp_handle, $temp_file_path, $remote_file, "ascii", $file_contents);
			if(!is_array($return_data)){
				// update what we consider the original code is
				$orig_code = $client_code_textarea;
				$write_file_success = 1;
			}
			else{
				// collect any errors that were generated
				foreach($return_data as $idx => $error_msg){ $error_log[] = $error_msg; }
			}
		} // end if
	} // end if 

	// if an ftp_handle is open, make sure to close it
	if(($page_action == 'load_file' || $page_action == 'write_file') && !is_array($ftp_handle)){
		// close the ftp connection
		@ftp_close($ftp_handle);
	}

	// define some template specific variables
	$PAGE_TITLE = "Webupdate | eSurvey 2.0 :: Insert Survey";
	$PAGE_HEADER_TEXT = "INSERT SURVEY &#160;<span style='font-size:10px;'>(".$survey_data_struct['survey_name'].")</span>";
	include_once('./include/header.php'); 
	include_once('./include/section_header.php'); 
?>
<!-- MAIN PAGE CONTENT [start] -->				
					<style type='text/css'>
					<!--
						.l_client_code_textarea {
							width: 680px;
							height: 320px;
							padding: 4px;
							margin: 0px;
							overflow: auto;
							font: normal normal normal 10px 'Lucida Console','Courier New',Courier,Monaco,Monospace,monospace;
							line-height: 12px;
							color: #000000;
						}
						.l_client_code_active {
							background-color: #ffffff;
							border: 1px solid #4f5161;
						}
						.l_client_code_inactive {
							background-color: #e7f0f2;
							border: 1px solid #8e98a2;
						}
						.l_code_snippet {
							width: 680px;
							height: 18px;
							padding: 2px 2px 0px 2px;
							margin: 0px;
							overflow: hidden;
							font: normal normal normal 9px verdana,tahoma,helvetica,arial,Sans-serif,sans-serif;
							line-height: 11px;
							color: #000000;
						}
						.l_curr_file_path {
							width: 590px;
							font: normal normal normal 9px verdana,tahoma,helvetica,arial,Sans-serif,sans-serif;
							color: #ffc600;
							line-height: 11px;
							overflow: hidden;
							text-overflow: ellipsis;
							white-space: nowrap;
						}
					-->
					</style>
					<script language='JavaScript'>
					<!--
						// the actual javascript code that is used to render the current survey
						var injection_js_code = "<?php echo to_js_str($injection_js_code); ?>";
						// the js string up to the part where the specific survey_id is passed in. This allows us to find all instances of survey code on a page
						var generic_js_code =  "<?php echo to_js_str(ereg_replace("survey_id=.*","survey_id=",$injection_js_code));?>";
					//-->
					</script>
					<script language='JavaScript' src='./js/page_specific/insert_survey.js'></script>

					<img width='1' height='8' src='./images/global/other/other_clear_spacer.gif' hspace='0' vspace='0' border='0'><br>
					<center>
					<form name='insert_survey_form' id='insert_survey_form' method='POST' action='<?php echo $_SERVER['PHP_SELF']; ?>'>

					<table cellspacing='0' cellpadding='0' border='0'>
					<tr>
						<td width='696' colspan='3' height='20' align='left' valign='middle' bgcolor='#4f5161'>
							<table cellspacing='0' cellpadding='0' border='0'>
							<tr>
								<td><span class='g_sub_section_header'><b>Current File</b></span></td>
								<td width='20' ><a href='JavaScript:void(0);' onclick='popup_context_help("./help/publishing_a_survey.html");'><img onmouseover='this.src=icon_context_help_on.src;' onmouseout='this.src=icon_context_help_off.src;' width='13' height='13' src='./images/global/icon/icon_context_help_off.gif' alt='Help' title='Help' hspace='0' vspace='0' border='0'></a><br></td>
								<td align='left' valign='middle'><span class='l_curr_file_path' title='<?php echo to_html_attrib_str($display_path); ?>'><?php echo $display_path; ?><br></span></td>
							</tr>
							</table>
						</td>
					</tr>
					<tr>
						<td width='1' bgcolor='#4f5161'><img width='1' height='1' src='./images/global/other/other_clear_spacer.gif' hspace='0' vspace='0' border='0'><br></td>
						<td width='694' height='20' align='right' valign='bottom' bgcolor='#cfe1e5'>
							<table cellspacing='0' cellpadding='0' border='0'>
							<tr>
<?php if($page_is_active){ ?>
								<td width='78' align='left' valign='middle'><a href='javascript:void(0);' onmouseup='revert_bttn_onmouseup();'><img width='76' height='19' onmouseover='this.src=bttn_revert_on.src;' onmouseout='this.src=bttn_revert_off.src;' src='./images/global/button/bttn_revert_off.gif' alt='Revert' title='Revert' hspace='0' vspace='0' border='0'></a><br></td>
								<td width='78' align='left' valign='middle'><a href='javascript:void(0);' onmouseup='insert_survey_onmouseup();'><img width='76' height='19' onmouseover='this.src=bttn_insert_survey_on.src;' onmouseout='this.src=bttn_insert_survey_off.src;' src='./images/insert_survey/button/bttn_insert_survey_off.gif' alt='Insert Survey' title='Insert Survey' hspace='0' vspace='0' border='0'></a><br></td>
<?php }else{ ?>
								<td width='78' align='left' valign='middle'><a href='javascript:void(0);' onmouseup='pre_file_load_onmouseup();'><img width='76' height='19' onmouseover='this.src=bttn_revert_on.src;' onmouseout='this.src=bttn_revert_off.src;' src='./images/global/button/bttn_revert_off.gif' alt='Revert' title='Revert' hspace='0' vspace='0' border='0'></a><br></td>
								<td width='78' align='left' valign='middle'><a href='javascript:void(0);' onmouseup='pre_file_load_onmouseup();'><img width='76' height='19' onmouseover='this.src=bttn_insert_survey_on.src;' onmouseout='this.src=bttn_insert_survey_off.src;' src='./images/insert_survey/button/bttn_insert_survey_off.gif' alt='Insert Survey' title='Insert Survey' hspace='0' vspace='0' border='0'></a><br></td>
<?php } ?>
								<td width='83' align='left' valign='middle'><a href='javascript:void(0);' onmouseup='open_bttn_onmouseup();'><img width='76' height='19' onmouseover='this.src=bttn_open_page_on.src;' onmouseout='this.src=bttn_open_page_off.src;' src='./images/insert_survey/button/bttn_open_page_off.gif' alt='Open Page' title='Open Page' hspace='0' vspace='0' border='0'></a><br></td>
							</tr>
							</table>
						</td>
						<td width='1' bgcolor='#4f5161'><img width='1' height='1' src='./images/global/other/other_clear_spacer.gif' hspace='0' vspace='0' border='0'><br></td>
					</tr>
					<tr>
						<td width='1' bgcolor='#4f5161'><img width='1' height='1' src='./images/global/other/other_clear_spacer.gif' hspace='0' vspace='0' border='0'><br></td>
						<td width='694' align='center' valign='top' bgcolor='#cfe1e5'>
<?php if($page_is_active){ ?>
							<textarea name='client_code_textarea' id='client_code_textarea' class='l_client_code_textarea l_client_code_active' wrap='off'><?php echo htmlspecialchars(str_replace("\t","    ",$client_code_textarea)); ?></textarea>
<?php }else{ ?>
							<textarea readonly name='client_code_textarea' id='client_code_textarea' class='l_client_code_textarea l_client_code_inactive' wrap='off'></textarea>
<?php } ?>
							<textarea class='g_hidden_form_field' name='orig_code' id='orig_code'><?php echo htmlspecialchars(str_replace("\t","    ",$orig_code)); ?></textarea>
							<textarea class='g_hidden_form_field' style='visibility:hidden;' name='injection_code' id='injection_code'><?php echo htmlspecialchars($injection_js_code); ?></textarea>
							<input type='hidden' name='survey_id' id='survey_id' value='<?php echo $survey_id; ?>'>
							<input type='hidden' name='page_action' id='page_action' value=''>
							<input type='hidden' name='publish_point_id' id='publish_point_id' value='<?php echo $publish_point_id; ?>'>
							<input type='hidden' name='remote_file' id='remote_file' value='<?php echo to_html_attrib_str($remote_file); ?>'>
							<input type='hidden' name='display_path' id='display_path' value='<?php echo to_html_attrib_str($display_path); ?>'>
							<img width='1' height='8' src='./images/global/other/other_clear_spacer.gif' hspace='0' vspace='0' border='0'><br>
						</td>
						<td width='1' bgcolor='#4f5161'><img width='1' height='1' src='./images/global/other/other_clear_spacer.gif' hspace='0' vspace='0' border='0'><br></td>
					</tr>
					<tr>
						<td width='696' colspan='3' height='1' bgcolor='#4f5161'><img width='1' height='1' src='./images/global/other/other_clear_spacer.gif' hspace='0' vspace='0' border='0'><br></td>
					</tr>
					</table>

					<img width='1' height='8' src='./images/global/other/other_clear_spacer.gif' hspace='0' vspace='0' border='0'><br>

					<table cellspacing='0' cellpadding='0' border='0'>
					<tr>
						<td width='696' colspan='3' height='20' align='left' valign='middle' bgcolor='#4f5161'>
							<table cellspacing='0' cellpadding='0' border='0'>
							<tr>
								<td><span class='g_sub_section_header'><b>Survey JavaScript Code</b></span></td>
								<td><a href='JavaScript:void(0);' onclick='popup_context_help("./help/publishing_a_survey.html");'><img onmouseover='this.src=icon_context_help_on.src;' onmouseout='this.src=icon_context_help_off.src;' width='13' height='13' src='./images/global/icon/icon_context_help_off.gif' alt='Help' title='Help' hspace='0' vspace='0' border='0'></a><br></td>
							</tr>
							</table>
						</td>
					</tr>
					<tr>
						<td width='1' bgcolor='#4f5161'><img width='1' height='1' src='./images/global/other/other_clear_spacer.gif' hspace='0' vspace='0' border='0'><br></td>
						<td width='694' height='22' align='center' valign='middle' bgcolor='#cfe1e5'>
							<input readonly type='text' class='l_code_snippet l_client_code_inactive' name='snippet' id='snippet' value='<?php echo to_html_attrib_str($injection_js_code); ?>'><br>
						</td>
						<td width='1' bgcolor='#4f5161'><img width='1' height='1' src='./images/global/other/other_clear_spacer.gif' hspace='0' vspace='0' border='0'><br></td>
					</tr>
					<tr>
						<td width='696' colspan='3' height='1' bgcolor='#4f5161'><img width='1' height='1' src='./images/global/other/other_clear_spacer.gif' hspace='0' vspace='0' border='0'><br></td>
					</tr>
					</table>

					<img width='1' height='8' src='./images/global/other/other_clear_spacer.gif' hspace='0' vspace='0' border='0'><br>

					<table cellspacing='0' cellpadding='0' border='0'>
					<tr>
						<td width='696' align='right' valign='middle'>
							<a align='right' href='survey_list.php?active_tab_idx=<?php echo $survey_tab; ?>'><img width='73' height='19' onmouseover='this.src=bttn_cancel_on.src;' onmouseout='this.src=bttn_cancel_off.src;' src='./images/global/button/bttn_cancel_off.gif' alt='Cancel' title='Cancel' hspace='2' vspace='0' border='0'></a>
<?php if($page_is_active){ ?>
							<a align='right' href='JavaScript:void(0);' onmouseup='save_bttn_onmouseup();'><img width='73' height='19' onmouseover='this.src=bttn_save_on.src;' onmouseout='this.src=bttn_save_off.src;' src='./images/global/button/bttn_save_off.gif' alt='Save' title='Save' hspace='0' vspace='0' border='0'></a><br>
<?php }else{ ?>
							<a align='right' href='JavaScript:void(0);' onmouseup='pre_file_load_onmouseup();'><img width='73' height='19' onmouseover='this.src=bttn_save_on.src;' onmouseout='this.src=bttn_save_off.src;' src='./images/global/button/bttn_save_off.gif' alt='Save' title='Save' hspace='0' vspace='0' border='0'></a><br>
<?php } ?>
						</td>
					</tr>
					</table>

					<img width='1' height='5' src='./images/global/other/other_clear_spacer.gif' hspace='0' vspace='0' border='0'><br>

					</form>
					</center>

					<script language='JavaScript'>
					<!--
<?php
	// if the page was succesfully written, alert the user
	if($page_action == 'write_file' && count($error_log) == 0){
		echo "alert('[ SUCCESS ]\\nThe page has been successfully saved to the publish point.');\n";
	}

	// if errors were found, format them for display in a single alert box
	if(count($error_log) > 0){ 
		$error_alert = "[ ERROR ]\n";
		foreach($error_log as $idx => $error_msg){
			$error_alert .= "* $error_msg\n";
		}
		echo "alert('".to_js_str($error_alert)."');\n";
	}
?>
						// copy the injection code to the clipboard
						copy_injection_code();
						// set the document to capture user key strokes
						document.onkeyup = document_onkeyup;
					//-->
					</script>
<!-- MAIN PAGE CONTENT [end] -->				
<?php include_once('./include/footer.php'); ?>
