<?php
	require_once('../pear/DB.php');
	include_once('../settings/settings.php');
	include_once('../include/globals.php');
	include_once('../include/loader.php');
	include_once('../include/login_functions.php');
	// make sure the user has logged in before accessing this page
	if(($user_struct = get_login_status()) === FALSE){ header("Location: ../login.php"); exit(0); }

	include_once('../include/functions.php');
?>
<html>
<head></head>
<body onload='if(window.parent._io_callback){ setTimeout("window.parent._io_callback(\""+document.URL+"\",document);", 1); }'><?php

	// TODO check session for valid login

	foreach($_POST as $var => $val){
		// retrieve our data from POST
		$$var = (isset($_POST[$var])) ? $val : '';

		// prep all POST data for database insertion (fix single ticks)
		$$var = to_db_str($val);
	}

	// create a 32 char MD5 hash of the variable parts of our survey details. 
	$survey_hash = md5($survey_name.$start_timestamp.$end_timestamp.$is_draft.$instructions.$confirmation);

	// try to find the existing survey and get it's hash
	$curr_survey_hash = get_survey_hash($survey_id);

	// if no existing survey hash exists, then neither does the record, so we insert instead of update
	$insertion_type = ($curr_survey_hash === FALSE) ? 'insert' : 'update';

	// if an update is occuring, we must mark any existing questions/options as
	// being deleted that are not accounted for in the new post data
	if($insertion_type == 'update'){
		$valid_question_ids = Array(); // for tracking question_id's passed in
		// gather all of the valid question id's passed in
		for($i = 0; $i < $question_count; $i++){
			$q_id = ${'q'.$i.'_id'};
			if(is_numeric($q_id)){ array_push($valid_question_ids, $q_id); }
		}

		// find any existing invalid questions
		$query = "SELECT question_id FROM esy_questions WHERE question_id NOT IN (".join(",",$valid_question_ids).") AND survey_id = $survey_id AND rec_status_id = 1";
		$db_result = $DBH->query($query);
		if(DB::isError($db_result)){ die($db_result->message.'<br>'.$db_result->userinfo); }
		$invalid_question_ids = Array(); // for tracking old question_id's found in DB
		while($db_row = $db_result->fetchRow()){
			extract($db_row);
			array_push($invalid_question_ids, $question_id);
		}

		if(count($invalid_question_ids) > 0){
			// mark all of these questions as deleted in DB
			$query = "UPDATE esy_questions SET rec_status_id = 0 WHERE question_id IN (".join(",",$invalid_question_ids).") AND survey_id = $survey_id AND rec_status_id = 1 ";
			$db_result = $DBH->query($query);
			if(DB::isError($db_result)){ die($db_result->message.'<br>'.$db_result->userinfo); }

			// mark all of these questions' options as deleted in DB
			$query = "UPDATE esy_options SET rec_status_id = 0 WHERE question_id IN (".join(",",$invalid_question_ids).") AND rec_status_id = 1 ";
			$db_result = $DBH->query($query);
			if(DB::isError($db_result)){ die($db_result->message.'<br>'.$db_result->userinfo); }
		}

		// next, we look at each valid question, and see if there are any
		// options that are not accounted for in the post data and mark them for deletion
		for($i = 0; $i < $question_count; $i++){
			$question_id = ${'q'.$i.'_id'};

			if(is_numeric($question_id)){
				$option_count = ${'q'.$i.'_opt_cnt'};

				// gather all of the option_id's passed in for this question
				$valid_option_ids = Array(); // for tracking option_id's passed in 
				for($j = 0; $j < $option_count; $j++){
					$option_id = ${'q'.$i.'_o'.$j.'_id'};
					if(is_numeric($option_id)){ array_push($valid_option_ids, $option_id); } 
				}

				// if existing option_id's found for the question, tailor query so as to not remove them
				$and_id_not_in_set = (count($valid_option_ids) > 0) ? "AND option_id NOT IN (".join(",",$valid_option_ids).")" : "";
				$query = "UPDATE esy_options SET rec_status_id = 0 WHERE question_id = $question_id $and_id_not_in_set AND rec_status_id = 1 ";
				$db_result = $DBH->query($query);
				if(DB::isError($db_result)){ die($db_result->message.'<br>'.$db_result->userinfo); }
			}
		}
	}

	// perform a fresh insert of the base survey data
	if($insertion_type == 'insert'){
		$query = "INSERT INTO esy_surveys 
				  (survey_hash,survey_name,start_timestamp,end_timestamp,is_draft,instructions,confirmation)
				  VALUES
				  ('$survey_hash','$survey_name',$start_timestamp,$end_timestamp,$is_draft,'$instructions','$confirmation');
		";
		$db_result = $DBH->query($query);
		if(DB::isError($db_result)){ die($db_result->message.'<br>'.$db_result->userinfo); }

		// get the newly created survey_id
		$survey_id = get_last_insert_id('survey_id','esy_surveys','survey_hash',$survey_hash);
	}

	// if the survey exists already and has a different hash we need to update the record
	if($insertion_type == 'update' && $survey_hash != $curr_survey_hash){
		$query = "UPDATE esy_surveys SET
				  survey_hash = '$survey_hash',	survey_name = '$survey_name', start_timestamp = $start_timestamp, 
				  end_timestamp = $end_timestamp, is_draft = $is_draft, instructions = '$instructions', confirmation = '$confirmation'
				  WHERE survey_id = $survey_id;
		";
		$db_result = $DBH->query($query);
		if(DB::isError($db_result)){ die($db_result->message.'<br>'.$db_result->userinfo); }
	}

	// look through all of the question data that came in through post and
	// insert/update the records as needed.
	for($i = 0; $i < $question_count; $i++){
		$question_id 		= ${'q'.$i.'_id'};
		$question_type_id 	= ${'q'.$i.'_type'};
		$question_text 		= ${'q'.$i.'_text'};
		$order_number 		= $i;
		$is_required 		= ${'q'.$i.'_required'};
		$is_inc_stats 		= ${'q'.$i.'_inc_stats'};
		$error_message		= ${'q'.$i.'_err_msg'};
		$question_hash		= md5($question_type_id.$question_text.$order_number.$is_required.$is_inc_stats.$error_message);

		// if we have a question_id, update the record
		if(is_numeric($question_id)){
			$query = "UPDATE esy_questions SET
					  question_hash = '$question_hash', question_type_id = $question_type_id, question_text = '$question_text', order_number = $order_number,
					  is_required = $is_required, is_inc_stats = $is_inc_stats, error_message = '$error_message', rec_status_id = 1
					  WHERE question_id = $question_id AND survey_id = $survey_id
			";
			$db_result = $DBH->query($query);
			if(DB::isError($db_result)){ die($db_result->message.'<br>'.$db_result->userinfo); }
		}
		// otherwise, do a fresh insert
		else{
			$query = "INSERT INTO esy_questions
					  (survey_id,question_hash,question_type_id,question_text,order_number,is_required,is_inc_stats,error_message,rec_status_id)
					  VALUES
					  ($survey_id,'$question_hash',$question_type_id,'$question_text',$order_number,$is_required,$is_inc_stats,'$error_message',1)
			";
			$db_result = $DBH->query($query);
			if(DB::isError($db_result)){ die($db_result->message.'<br>'.$db_result->userinfo); }

			// record the id that was inserted in the DB
			${'q'.$i.'_id'} = get_last_insert_id('question_id','esy_questions','question_hash',$question_hash);
			$question_id = ${'q'.$i.'_id'};
		}

		// look through all (if any) of the options associated with this
		// question and insert/update the records as needed.
		$option_count = ${'q'.$i.'_opt_cnt'};
		for($j = 0; $j < $option_count; $j++){
			$option_id 		= ${'q'.$i.'_o'.$j.'_id'};
			$option_text	= ${'q'.$i.'_o'.$j.'_text'};
			$order_number 	= $j;
			$option_hash	= md5($option_text.$order_number);

			// if we have a question_id, update the record
			if(is_numeric($option_id)){
				$query = "UPDATE esy_options SET
						  option_hash = '$option_hash', option_text = '$option_text', order_number = $order_number, rec_status_id = 1
						  WHERE option_id = $option_id AND question_id = $question_id
				";
				$db_result = $DBH->query($query);
				if(DB::isError($db_result)){ die($db_result->message.'<br>'.$db_result->userinfo); }
			}
			// otherwise, do a fresh insert
			else{
				$query = "INSERT INTO esy_options
						  (question_id,option_hash,option_text,order_number,rec_status_id)
						  VALUES
						  ($question_id,'$option_hash','$option_text',$order_number,1)
				";
				$db_result = $DBH->query($query);
				if(DB::isError($db_result)){ die($db_result->message.'<br>'.$db_result->userinfo); }

				// record the option id that was inserted in the DB
				${'q'.$i.'_o'.$j.'_id'} = get_last_insert_id('option_id','esy_options','option_hash',$option_hash);
				$option_id = ${'q'.$i.'_o'.$j.'_id'};
			}
		} // end for loop
	} // end for loop


	// The very last step is to ouput the javascript code that will get eval'd
	// by the io callback function. This code will update the interface with the
	// survey_id, question_id's, and the associated option_id's. This is very
	// important for subsequent saves to the DB, because the interface must know
	// and resend the id's to maintain DB integrity
	echo "survey_id = $survey_id;\n";
	echo "ql_database.gotoHead();\n";

	// loop through questions and options and generate JS code to update their id's
	for($i = 0; $i < $question_count; $i++){
		$question_id = ${'q'.$i.'_id'};
		$option_count = ${'q'.$i.'_opt_cnt'};

		echo "qst = ql_database.getCursor();\n";
		echo "qst.id = $question_id;\n";

		for($j = 0; $j < $option_count; $j++){
			$option_id 		= ${'q'.$i.'_o'.$j.'_id'};

			echo "qst.option_list[$j].option_id = $option_id;\n";
		} 
		echo "ql_database.gotoNext();\n";
	} // end for loop

	echo '/*';
	print_r($_POST);
	echo '*/';

?></body>
</html>
