// ===========================================================================
// ||||||||||||||||||||||||||| GLOBAL VARIABLES ||||||||||||||||||||||||||||||
// ===========================================================================
var _CLW_DATABASE = new Object(); // allows us to get a reference to an instance of the class from it's ID
// ===========================================================================
// ||||||||||||||||||||||||||| CALENDAR WIDGET CLASS |||||||||||||||||||||||||
// ===========================================================================
function Calendar_Widget(){
	this.id				= Calendar_Widget.prototype.next_id++;
	this.is_rendered	= 0; // keep track if we've rendered the necessary html

	// store quick references to the calendar's main DOM objects
	this.day_objs		= new Array(); // array to store dom objects for each day in the calendar
	this.dom			= null;
	this.dom_mon		= null;
	this.dom_year		= null;
	this.dom_prev_nav	= null;
	this.dom_next_nav	= null;

	// set the currently selected date to today
	var now = new Date();
	this.sel_day		= now.getDate();
	this.sel_mon		= now.getMonth()+1;
	this.sel_year		= now.getFullYear();

	// the month and year being viewed isn't the same as which date is selcted.
	this.view_mon		= this.sel_mon;
	this.view_year		= this.sel_year;

	// in the array of days that are displayed in the calendar, keep track of where the current month begins and ends
	this.mon_start_idx	= 0;
	this.mon_end_idx	= 0;

	// keep track of the current time increment
	this.time_inc		= 'mon'; // [mon,year]

	// track the instance in the Calendar Widget database
	_CLW_DATABASE[this.id] = this;
}
// ---------------------------------------------------------------------------
Calendar_Widget.prototype.next_id = 0;
// ---------------------------------------------------------------------------
// this method can only be called once. It generates the HTML necessary to
// display the calendar widget and adds it to the body.
Calendar_Widget.prototype.create_html = function(){
	var html_str = "";
	var day_array = new Array('S','M','T','W','T','F','S');
	var block_style = "margin:0px; padding:0px; border:0px; overflow:hidden; cursor:default;";
	var x,y = 0;
	var cnt = 0;
	var id = '';

	if(!this.is_rendered){
		html_str += "<div id='cl"+this.id+"_base' class='clw_canvas_border' style='"+block_style+" width:144px; height:163px;'>";
		html_str += 	"<div class='clw_canvas' style='position:absolute; "+block_style+" top:0px; left:2px; width:140px; height:161px;'>";
		html_str += 		"<div class='clw_block' style='position:absolute; "+block_style+" top:0px; left:0px; width:140px; height:20px;'>";
		html_str += 			"<div id='cl"+this.id+"_prev_nav' class='clw_header_nav' style='position:absolute; "+block_style+" top:0px; left:0px; width:20px; height:20px; line-height:20px; cursor:pointer;'>&lt;&lt;</div>";
		html_str += 			"<div class='clw_header' style='position:absolute; "+block_style+" top:0px; left:20px; width:100px; height:20px; line-height:20px;'>";
		html_str += 				"<span id='cl"+this.id+"_mon' style='text-decoration:underline; cursor:pointer;'></span> - <span id='cl"+this.id+"_year' style='cursor:pointer;'></span>";
		html_str += 			"</div>";
		html_str += 			"<div id='cl"+this.id+"_next_nav' class='clw_header_nav' style='position:absolute; "+block_style+" top:0px; left:120px; width:20px; height:20px; line-height:20px; cursor:pointer;'>&gt;&gt;</div>";
		html_str += 		"</div>";
		html_str += 		"<div class='clw_block' style='position:absolute; "+block_style+" top:20px; left:0px; width:140px; height:20px;'>";
		for(x = 0; x < 7; x++){
			html_str += 		"<div class='clw_day_label' style='position:absolute; "+block_style+" top:0px; left:"+(x*20)+"px; width:20px; height:20px; line-height:20px;'>"+day_array[x]+"</div>";
		}
		html_str += 		"</div>";
		html_str += 		"<div class='clw_spacer' style='position:absolute; "+block_style+" top:41px; left:0px; width:140px; height:1px;'><br></div>";
		html_str += 		"<div class='clw_block' style='position:absolute; "+block_style+" top:42px; left:0px; width:140px; height:140px;'>";
		for(y = 0; y < 6; y++){
			for(x = 0; x < 7; x++){
				id = "cl"+this.id+"_day"+(cnt++);
				html_str += 	"<div id='"+id+"' class='clw_day' style='position:absolute; "+block_style+" top:"+(y*20)+"px; left:"+(x*20)+"px; width:20px; height:20px; line-height:20px; cursor:pointer;'> </div>";
			}
		}
		html_str += 		"</div>";
		html_str += 	"</div>";
		html_str += "</div>";

		if(document.body){
			document.write(html_str);
			this.is_rendered = 1;
			this.init();
		}
	}
}
// ---------------------------------------------------------------------------
Calendar_Widget.prototype.init = function(){
	var evt_str = '';
	var i = 0;
	if(this.is_rendered){

		// store quick references to our major dom objects
		this.dom 			= document.getElementById('cl'+this.id+"_base");
		this.dom_mon 		= document.getElementById('cl'+this.id+"_mon");
		this.dom_year 		= document.getElementById('cl'+this.id+"_year");
		this.dom_prev_nav	= document.getElementById('cl'+this.id+"_prev_nav");
		this.dom_next_nav	= document.getElementById('cl'+this.id+"_next_nav");

		// loop through all of the days in the calendar
		for(i = 0; i < 42; i++){
			// store references to each of the days in the calendar
			this.day_objs[i] = document.getElementById(('cl'+this.id+"_day"+i));

			// setup the event handlers for each day
			evt_str = '_CLW_DATABASE['+this.id+'].day_objs['+i+'].onmouseover = function(){ clw_day_onmouseover('+this.id+','+i+'); };';
			eval(evt_str);
			evt_str = '_CLW_DATABASE['+this.id+'].day_objs['+i+'].onmouseout = function(){ clw_day_onmouseout('+this.id+','+i+'); };';
			eval(evt_str);
			evt_str = '_CLW_DATABASE['+this.id+'].day_objs['+i+'].onmouseup = function(){ clw_day_onmouseup('+this.id+','+i+'); };';
			eval(evt_str);

			// setup the event handlers for the calendar navigation 
			evt_str = '_CLW_DATABASE['+this.id+'].dom_prev_nav.onmouseup = function(){ clw_nav_onmouseup('+this.id+',-1); };';
			eval(evt_str);
			evt_str = '_CLW_DATABASE['+this.id+'].dom_next_nav.onmouseup = function(){ clw_nav_onmouseup('+this.id+',1); };';
			eval(evt_str);

			// setup the event handlers for the calendar's time increment selection 
			evt_str = '_CLW_DATABASE['+this.id+'].dom_mon.onmouseup = function(){ clw_mon_onmouseup('+this.id+'); };';
			eval(evt_str);
			evt_str = '_CLW_DATABASE['+this.id+'].dom_year.onmouseup = function(){ clw_year_onmouseup('+this.id+'); };';
			eval(evt_str);
		}

		// display the selected month
		this.display_month();
	}
}
// ---------------------------------------------------------------------------
// this method looks at the objects current view month (1-12) and year and
// renders the appropriate calendar month to the html interface
Calendar_Widget.prototype.display_month = function(){
	var t,i,day
	var month_names = Array('Jan','Feb','Mar','Apr','May','June','July','Aug','Sept','Oct','Nov','Dec');

	if(this.is_rendered){
		// display the date in the calendar's header
		this.dom_mon.innerHTML = month_names[this.view_mon-1];
		this.dom_year.innerHTML = this.view_year;

		// find the new month start index
		this.mon_start_idx = new Date(this.view_year,this.view_mon-1,1).getDay();
			
		// find the new month start index
		t = new Date(this.view_year,this.view_mon,1);
		t.setDate(0);
		this.mon_end_idx = this.mon_start_idx + t.getDate() - 1;

		// find the last day of the previous month
		t = new Date(this.view_year,this.view_mon-1,1);
		t.setDate(0);
		// render any days before the viewed month
		day = t.getDate();
		for(i = this.mon_start_idx-1; i >= 0; i--){
			this.day_objs[i].className = 'clw_day_disabled';
			this.day_objs[i].innerHTML = day--;
		}

		// render the currently viewed month
		day = 1;
		for(i = this.mon_start_idx; i <= this.mon_end_idx; i++){
			// if we're rendering the selected day, hilite it 
			if(this.sel_year == this.view_year && this.sel_mon == this.view_mon && day == this.sel_day){ this.day_objs[i].className = 'clw_day_active'; }
			else{ this.day_objs[i].className = 'clw_day'; }
			this.day_objs[i].innerHTML = day++;
		}

		// render any days that are displayed that are disabled and after the active month
		day = 1;
		for(i = this.mon_end_idx+1; i < 42; i++){
			this.day_objs[i].className = 'clw_day_disabled';
			this.day_objs[i].innerHTML = day++;
		}
	}
}
// ---------------------------------------------------------------------------
Calendar_Widget.prototype.hide = function(){
	if(this.is_rendered){ this.dom.style.display = 'none'; }
}
// ---------------------------------------------------------------------------
Calendar_Widget.prototype.show = function(){
	if(this.is_rendered){ this.dom.style.display = ''; }
}
// ===========================================================================
// ||||||||||||||||||||||||||| EVENT HANDLER FUNCTIONS |||||||||||||||||||||||
// ===========================================================================
function clw_day_onmouseover(_id,_idx){
	var _this = _CLW_DATABASE[_id]; // a reference to the Calendar Widget instance
	var div = _this.day_objs[_idx]; // a reference to the day's dom object
	// hilite a day if it is within the current month's day range, and it isn't
	// the selected day (taking into account select month and year)
	if(_idx <= _this.mon_end_idx && _idx >= _this.mon_start_idx && !(_this.sel_mon == _this.view_mon && _this.sel_year == _this.view_year && (_idx - _this.mon_start_idx + 1) == _this.sel_day)){ 
		div.className = 'clw_day_over'; 
	}
}
// ---------------------------------------------------------------------------
function clw_day_onmouseout(_id,_idx){
	var _this = _CLW_DATABASE[_id]; // a reference to the Calendar Widget instance
	var div = _this.day_objs[_idx]; // a reference to the day's dom object
	// lolite a day if it is within the current month's day range, and it isn't
	// the selected day (taking into account select month and year)
	if(_idx <= _this.mon_end_idx && _idx >= _this.mon_start_idx && !(_this.sel_mon == _this.view_mon && _this.sel_year == _this.view_year && (_idx - _this.mon_start_idx + 1) == _this.sel_day)){ 
		div.className = 'clw_day'; 
	}
}
// ---------------------------------------------------------------------------
function clw_day_onmouseup(_id,_idx){
	var _this = _CLW_DATABASE[_id]; // a reference to the Calendar Widget instance
	var div = _this.day_objs[_idx]; // a reference to the day's dom object
	if(_idx <= _this.mon_end_idx && _idx >= _this.mon_start_idx && !(_this.sel_mon == _this.view_mon && _this.sel_year == _this.view_year && (_idx - _this.mon_start_idx + 1) == _this.sel_day)){ 
		// lolite the active day if we're choosing a new day on the currently active month
		if(_this.sel_mon == _this.view_mon && _this.sel_year == _this.view_year){
			_this.day_objs[(_this.mon_start_idx + _this.sel_day - 1)].className = 'clw_day';
		}
		// hilite the newly active day
		_this.day_objs[_idx].className = 'clw_day_active';

		// store the newly selected day
		_this.sel_day = _idx - _this.mon_start_idx + 1;
		_this.sel_mon = _this.view_mon;
		_this.sel_year = _this.view_year;
	}
}
// ---------------------------------------------------------------------------
function clw_nav_onmouseup(_id,_dir){
	var _this = _CLW_DATABASE[_id]; // a reference to the Calendar Widget instance
	if(_this.time_inc == 'mon'){ _this.view_mon += _dir; }
	else{ _this.view_year += _dir; }
	// wrap to the next year if necessary
	if(_this.view_mon > 12){
		_this.view_mon = 1;
		_this.view_year += _dir;
	}
	// wrap to the prev year if necessary
	else if(_this.view_mon < 1){
		_this.view_mon = 12;
		_this.view_year += _dir;
	}
	_this.display_month();
}
// ---------------------------------------------------------------------------
function clw_mon_onmouseup(_id){
	var _this = _CLW_DATABASE[_id]; // a reference to the Calendar Widget instance
	_this.dom_year.style.textDecoration = 'none';
	_this.dom_mon.style.textDecoration = 'underline';
	_this.time_inc = 'mon';
}
// ---------------------------------------------------------------------------
function clw_year_onmouseup(_id){
	var _this = _CLW_DATABASE[_id]; // a reference to the Calendar Widget instance
	_this.dom_mon.style.textDecoration = 'none';
	_this.dom_year.style.textDecoration = 'underline';
	_this.time_inc = 'year';
}
// ===========================================================================
