	// ==========================================================================
	// ||||||||||||||||||||||||| GLOBAL VARIABLES |||||||||||||||||||||||||||||||
	// ==========================================================================
	// prepare all of the page's rollover graphics
	if(document.images){
		var icon_field_error_off = new Image(); icon_field_error_off.src = './images/global/icon/icon_field_error_off.gif';
		var icon_field_error_on = new Image(); icon_field_error_on.src = './images/global/icon/icon_field_error_on.gif';
		var icon_field_error_none = new Image(); icon_field_error_none.src = './images/global/other/other_clear_spacer.gif';
	}
	// ==========================================================================
	// ||||||||||||||||||||||||| HELPER FUNCTIONS |||||||||||||||||||||||||||||||
	// ==========================================================================
	// this function takes the standardized base field name of a form section and
	// changes the color of the label, and turns on the error icon with
	// associated link and error message (via tooltip and javascript alert)
	function set_field_error(_field_name,_error_msg){
		// get references to the form label, and it's error icon image
		var form_label = document.getElementById(_field_name+'_label');
		var form_err_img = document.getElementById(_field_name+'_err_img');
		if(form_label && form_err_img){
			form_label.style.color = '#ff0000';
			form_err_img.src = icon_field_error_off.src;
			form_err_img.alt = _error_msg.replace('\r','&#13;');
			form_err_img.title = _error_msg.replace('\r','&#13;');
			form_err_img.style.cursor = 'hand';
			form_err_img.onmouseover = function(){ this.src = icon_field_error_on.src; };
			form_err_img.onmouseout = function(){ this.src = icon_field_error_off.src; };
			form_err_img.onclick = function(){ alert(_error_msg); };
			// we need to give the browser a split second to recognize the image's source has changed, and then we hide/show it to ensure it gets rendered
			var hide_obj_code = 'document.getElementById("'+_field_name+'_err_img").style.display = "none";';
			var show_obj_code = 'document.getElementById("'+_field_name+'_err_img").style.display = "";';
			setTimeout(hide_obj_code+' '+show_obj_code,10);
		}
	}
	// --------------------------------------------------------------------------
	// this function takes the standardized base field name of a form section and
	// changes the color of the label, and turns off the error icon and associated message 
	function clear_field_error(_field_name){
		// get references to the form label, and it's error icon image
		var form_label = document.getElementById(_field_name+'_label');
		var form_err_img = document.getElementById(_field_name+'_err_img');
		if(form_label && form_err_img){
			form_label.style.color = '#297181';
			form_err_img.src = icon_field_error_none.src;
			form_err_img.alt = form_err_img.title = '';
			form_err_img.style.cursor = '';
			form_err_img.onmouseover = form_err_img.onmouseout = form_err_img.onclick = null;
			// we need to give the browser a split second to recognize the image's source has changed, and then we hide/show it to ensure it gets rendered
			var hide_obj_code = 'document.getElementById("'+_field_name+'_err_img").style.display = "none";';
			var show_obj_code = 'document.getElementById("'+_field_name+'_err_img").style.display = "";';
			setTimeout(hide_obj_code+' '+show_obj_code,10);
		}
	}
	// --------------------------------------------------------------------------
	// this function takes a string and trims off any white space at the
	// beginning and end of the string
	function trim(_str){
		if(_str != null && _str != void(0) && _str != ''){ _str = _str.replace(/^\s*/,'').replace(/\s*$/,''); }
		return _str;
	}
	// --------------------------------------------------------------------------
	function urlencode(_str){
		var ret_val = '';
		if(_str != null && _str != void(0) && _str != ''){
			// Javascript's builtin escape function almost does a proper url encoding,
			// but plus sign characters must go to their character code equivalents
			// (%2B), and the character codes for spaces (%20) must go to the plus character (+),
			ret_val = escape(_str).replace(/\+/g,'|').replace(/%20/g,'+').replace(/\|/g,'%2B');
		}
		return ret_val;
	}
	// --------------------------------------------------------------------------
