	// ==========================================================================
	// ||||||||||||||||||||||||| GLOBAL VARIABLES |||||||||||||||||||||||||||||||
	// ==========================================================================
	var ql_entry_count 		= 1; // number of question list html entries (not all are necessarily visible)
	var ql_entries_visible	= 1; // number of question list html entries that are currently visible
	var ql_database			= new List(); // a circular doubly linked list of Survey_Question objects
	var active_ql_entry		= 0; // keep track of which question list entry is active/hilited
	var is_busy 			= 0; // prevent event functions from being called before other critical events are finished

	var start_calendar		= new Calendar_Widget();
	var start_time_hour		= null; // text input dom ref
	var start_time_min		= null; // text input dom ref
	var start_timestamp		= null; // timestamp extracted from form
	var end_calendar		= new Calendar_Widget();
	var end_time_hour		= null;
	var end_time_min		= null;
	var end_timestamp		= null;

	// set up and IO API handle for handling survey save processing
	var io_api 				= new IO();
	io_api.set_POST();
	io_api.set_url('./io_modules/save_survey.php');
	io_api.set_blank_url('./io_modules/io_blank.html');
	io_api.set_callback(save_survey_callback);

	var survey_id			= '';
	var qst 				= null;

	// prepare all of the page's rollover graphics
	if(document.images){
		var icon_arrow_down_off = new Image(); icon_arrow_down_off.src = './images/global/icon/icon_arrow_down_off.gif';
		var icon_arrow_down_on = new Image(); icon_arrow_down_on.src = './images/global/icon/icon_arrow_down_on.gif';
		var icon_arrow_up_off = new Image(); icon_arrow_up_off.src = './images/global/icon/icon_arrow_up_off.gif';
		var icon_arrow_up_on = new Image(); icon_arrow_up_on.src = './images/global/icon/icon_arrow_up_on.gif';
		var icon_trash_can_off = new Image(); icon_trash_can_off.src = './images/global/icon/icon_trash_can_off.gif';
		var icon_trash_can_on = new Image(); icon_trash_can_on.src = './images/global/icon/icon_trash_can_on.gif';
		var icon_pencil_off = new Image(); icon_pencil_off.src = './images/global/icon/icon_pencil_off.gif';
		var icon_pencil_on = new Image(); icon_pencil_on.src = './images/global/icon/icon_pencil_on.gif';
		var icon_calendar_off = new Image(); icon_calendar_off.src = './images/global/icon/icon_calendar_off.gif';
		var icon_calendar_on = new Image(); icon_calendar_on.src = './images/global/icon/icon_calendar_on.gif';
		var icon_field_error_off = new Image(); icon_field_error_off.src = './images/global/icon/icon_field_error_off.gif';
		var icon_field_error_on = new Image(); icon_field_error_on.src = './images/global/icon/icon_field_error_on.gif';
		var icon_field_error_none = new Image(); icon_field_error_none.src = './images/global/other/other_clear_spacer.gif';

		var bttn_save_off = new Image(); bttn_save_off.src = './images/global/button/bttn_save_off.gif';
		var bttn_save_on = new Image(); bttn_save_on.src = './images/global/button/bttn_save_on.gif';
		var bttn_cancel_off = new Image(); bttn_cancel_off.src = './images/global/button/bttn_cancel_off.gif';
		var bttn_cancel_on = new Image(); bttn_cancel_on.src = './images/global/button/bttn_cancel_on.gif';
		var bttn_new_question_off = new Image(); bttn_new_question_off.src = './images/edit_survey/button/bttn_new_question_off.gif';
		var bttn_new_question_on = new Image(); bttn_new_question_on.src = './images/edit_survey/button/bttn_new_question_on.gif';
		var bttn_add_option_off = new Image(); bttn_add_option_off.src = './images/edit_survey/button/bttn_add_option_off.gif';
		var bttn_add_option_on = new Image(); bttn_add_option_on.src = './images/edit_survey/button/bttn_add_option_on.gif';

		var other_busy_bar_off = new Image(); other_busy_bar_off.src = './images/global/other/other_busy_bar_off.gif';
		var other_busy_bar_on = new Image(); other_busy_bar_on.src = './images/global/other/other_busy_bar_on.gif';
	}
	// ==========================================================================
	// ||||||||||||||||||||||||| IO CALLBACK FUNCTIONS ||||||||||||||||||||||||||
	// ==========================================================================
	function save_survey_callback(_doc,_args){
		// the body should contain the js code to update the id's in our
		// interface, so grab it
		var eval_code = _doc.body.innerHTML;
		eval(eval_code);

		// clean the data from the IO api for subsequent saves
		io_api.flush_name_vals();

		// we need to update the current question details interface with the
		// newly recieved id's, otherwise the ql_database may get corrupted and
		// the current question's id's will be lost
		get_ql_db_entry_by_idx(active_ql_entry);
		ql_database.getCursor().render_to_page();

		stop_busy_animation();

		alert('[ SUCCESS ]\nYour survey has been saved.');
	}
	// ==========================================================================
	// ||||||||||||||||||||||||| SURVEY OPTION CLASS ||||||||||||||||||||||||||||
	// ==========================================================================
	function Survey_Option(_id,_text){
		this.option_id		= _id ? _id : '';
		this.option_text 	= _text ? _text : '';
	}
	// ==========================================================================
	// ||||||||||||||||||||||||| SURVEY QUESTION CLASS ||||||||||||||||||||||||||
	// ==========================================================================
	function Survey_Question(_id,_text,_inc_stats,_req_quest,_err_msg,_quest_type){
		this.id				= _id ? _id : '';
		this.question_text 	= _text ? _text : '';
		this.include_stats 	= _inc_stats ? _inc_stats : 0;
		this.req_question 	= _req_quest ? _req_quest : 0;
		this.error_message 	= _err_msg ? _err_msg : '';
		this.question_type 	= _quest_type ? _quest_type : 1;
		this.option_list	= new Array();
	}
	// --------------------------------------------------------------------------
	// this method takes the data stored in the class object and renders it to
	// the Question Details section of the edit survey application
	Survey_Question.prototype.render_to_page = function(){
		var f = document.forms['edit_survey_form'];
		var t,i;

		document.getElementById('question_text').innerHTML = this.question_text;

		if(this.include_stats == 1){ f['include_stats_report'][0].checked = true; }
		else{ f['include_stats_report'][1].checked = true; }

		t = document.getElementById('error_message_section');
		if(this.req_question == 1){ 
			f['required_question'][0].checked = true; 
			t.style.display = '';
		}
		else{ 
			f['required_question'][1].checked = true; 
			t.style.display = 'none';
		}

		document.getElementById('error_message').innerHTML = this.error_message;

		document.getElementById('option_list_section').style.display = (this.question_type > 2) ? '' : 'none';

		var type_mapping = new Array(null,0,2,4,1,3,5); // maps question types to radio button indexes
		select_radio_button('question_type',type_mapping[this.question_type]);

		if(this.question_type > 2){
			for(i = 0; i < this.option_list.length; i++){ 
				f['option_list'][i] = new Option(this.option_list[i].option_text,this.option_list[i].option_id);
			}
		}
	}
	// --------------------------------------------------------------------------
	// this method examines the form fields of the Question Details section of
	// the application and stores it's contents into our class
	Survey_Question.prototype.extract_page_data = function(){
		var f = document.forms['edit_survey_form'];

		this.question_text = document.getElementById('question_text').innerHTML;
		this.include_stats = (f['include_stats_report'][0].checked) ? 1 : 0;
		this.req_question = (f['required_question'][0].checked) ? 1 : 0;
		this.error_message = document.getElementById('error_message').innerHTML;
		this.question_type = get_curr_question_type();
		this.option_list = new Array();

		var t = f['option_list'];
		if(this.question_type > 2){
			for(var i = 0; i < t.length; i++){ 
				this.option_list.push(new Survey_Option(t[i].value,t[i].text) ); 
			}
		}
	}
	// ==========================================================================
	// ||||||||||||||||||||||||| HELPER FUNCTIONS |||||||||||||||||||||||||||||||
	// ==========================================================================
	function start_busy_animation(){
		var busy_img = document.getElementById('busy_bar_img');
		if(busy_img){ busy_img.src = other_busy_bar_on.src; }
	}
	// ---------------------------------------------------------------------------
	function stop_busy_animation(){
		var busy_img = document.getElementById('busy_bar_img');
		if(busy_img){ busy_img.src = other_busy_bar_off.src; }
	}
	// ---------------------------------------------------------------------------
	// once the form has been rendered, the calling of this function sets up a
	// series of javascript variables and objects that we can use to manage the survey data 
	function init_edit_survey_app(){
		// set up the New Option text input so that when the user hits the Enter key, the
		// option is automatically added to the list without having to click the 'Add Option' button
		document.getElementById('new_option').onkeypress = function(e){
			var jEvent = e ? e : event;
			var nCharCode = jEvent.which ? jEvent.which : jEvent.keyCode;
			if(nCharCode == 13){ add_option_onclick(); }
		}

		// get a reference to the calendar time inputs
		start_time_hour = document.getElementById('start_time_hour');
		start_time_min = document.getElementById('start_time_min');
		end_time_hour = document.getElementById('end_time_hour');
		end_time_min = document.getElementById('end_time_min');

		// set up the start calendar widget
		start_calendar.hide();
		start_calendar.dom.style.zIndex = 10000;
		start_calendar.dom.onmouseover = function(){ start_calendar.is_active = 1; }
		start_calendar.dom.onmouseout = function(){ 
			start_calendar.is_active = 0;
			setTimeout('if(!start_calendar.is_active){ start_cal_onmouseout(); }',100);
		}
		start_cal_onmouseout(); // render the calendar to the screen

		// set up the end calendar widget
		end_calendar.hide();
		end_calendar.dom.style.zIndex = 10000;
		end_calendar.dom.onmouseover = function(){ end_calendar.is_active = 1; }
		end_calendar.dom.onmouseout = function(){ 
			end_calendar.is_active = 0;
			setTimeout('if(!end_calendar.is_active){ end_cal_onmouseout(); }',100);
		}
		end_cal_onmouseout(); // render the calendar to the screen

		// set the onkeydown event handler for the time inputs 
		start_time_hour.onkeydown = cal_time_onkeydown;
		start_time_min.onkeydown = cal_time_onkeydown;
		end_time_hour.onkeydown = cal_time_onkeydown;
		end_time_min.onkeydown = cal_time_onkeydown;
	}
	// --------------------------------------------------------------------------
	// this function appends the html necessary to render an entry in the question list.
	function append_ql_html(){
		var new_idx, entry_rgb, html_str = null;
		var ql_area_div = document.getElementById('ql_area_div');
		if(ql_area_div){
			new_idx = ql_area_div.childNodes.length;
			entry_rgb = (new_idx % 2 == 0) ? '#ffffff' : '#e2edef';

			html_str = "<table id='q"+new_idx+"_table' cellspacing='0' cellpadding='0' border='0' style='background-color:"+entry_rgb+";'>\n";
			html_str +="<tr>\n";
			html_str +="	<td width='243' height='21' align='left' valign='middle'>\n";
			html_str +="		<div class='l_question_item'><nobr>&#160;("+(new_idx+1)+")&#160;<a id='q"+new_idx+"_link' href='JavaScript:void(0);' onmouseup='edit_question_onclick("+new_idx+"); this.blur();' class='l_question_link'></a></nobr></div>\n";
			html_str +="	</td>\n";
			html_str +="	<td width='86' height='21' align='left' valign='middle'>\n";
			html_str +="		<a href='JavaScript:void(0);' onmouseup='move_question_down_onclick("+new_idx+"); this.blur();'><img onmouseover='this.src=icon_arrow_down_on.src;' onmouseout='this.src=icon_arrow_down_off.src;' align='left' width='17' height='17' src='./images/global/icon/icon_arrow_down_off.gif' alt='Move Down' title='Move Down' hspace='2' vspace='0' border='0'></a>\n";
			html_str +="		<a href='JavaScript:void(0);' onmouseup='move_question_up_onclick("+new_idx+"); this.blur();'><img onmouseover='this.src=icon_arrow_up_on.src;' onmouseout='this.src=icon_arrow_up_off.src;' align='left' width='17' height='17' src='./images/global/icon/icon_arrow_up_off.gif' alt='Move Up' title='Move Up' hspace='2' vspace='0' border='0'></a>\n";
			html_str +="		<a href='JavaScript:void(0);' onmouseup='edit_question_onclick("+new_idx+"); this.blur();'><img onmouseover='this.src=icon_pencil_on.src;' onmouseout='this.src=icon_pencil_off.src;' align='left' width='17' height='17' src='./images/global/icon/icon_pencil_off.gif' alt='Edit' title='Edit' hspace='2' vspace='0' border='0'></a>\n";
			html_str +="		<a href='JavaScript:void(0);' onmouseup='delete_question_onclick("+new_idx+"); this.blur();'><img onmouseover='this.src=icon_trash_can_on.src;' onmouseout='this.src=icon_trash_can_off.src;' align='left' width='17' height='17' src='./images/global/icon/icon_trash_can_off.gif' alt='Delete' title='Delete' hspace='2' vspace='0' border='0'></a>\n";
			html_str +="	</td>\n";
			html_str +="</tr>\n";
			html_str +="</table>\n";

			ql_area_div.innerHTML += html_str;

			ql_entry_count++;
			ql_entries_visible++;
		}
	}
	// --------------------------------------------------------------------------
	// this function takes an index of one of the html entries (tables) in the question list
	// and sets its link text to the string provided
	function set_ql_entry_text(_idx,_text){
		var qn_link = document.getElementById('q'+_idx+'_link');
		if(qn_link){ qn_link.innerHTML = _text; }
	}
	// --------------------------------------------------------------------------
	// this function takes an index of one of the html entries (tables) in the question list
	// and hilites it by changing the background color and font style.
	function hilite_ql_entry(_idx){
		var qn_table = document.getElementById('q'+_idx+'_table');
		var qn_link = document.getElementById('q'+_idx+'_link');
		if(qn_table && qn_link){
			qn_table.style.backgroundColor = '#fff7b2';
			qn_link.style.color = '#297181';
			qn_link.style.fontWeight = 'bold';
		}
	}
	// --------------------------------------------------------------------------
	// this function takes an index of one of the html entries (tables) in the question list
	// and hilites it by changing the background color and font style.
	function lolite_ql_entry(_idx){
		var qn_table = document.getElementById('q'+_idx+'_table');
		var qn_link = document.getElementById('q'+_idx+'_link');
		if(qn_table && qn_link){
			qn_table.style.backgroundColor = (_idx % 2 == 0) ? '#ffffff' : '#e2edef';
			qn_link.style.color = '#000000';
			qn_link.style.fontWeight = 'normal';
		}
	}
	// --------------------------------------------------------------------------
	// this function takes an integer index of one of the html ql entries and uses that index to look
	// up the appropriate entry ID in the ql_database list
	function get_ql_db_entry_by_idx(_idx){
		var i = 0;
		ql_database.gotoHead();
		while(i != _idx){ ql_database.gotoNext(); i++; }
		return ql_database.getId();
	}
	// --------------------------------------------------------------------------
	// this function cycles through all of the questions stored in the ql_database and renders
	// the contents of this list into the html ql entries on the page
	function render_ql_entries(){
		var i = 0;
		var ql_entry = null;
		ql_database.gotoHead();
		do{
			ql_entry = ql_database.getCursor();
			set_ql_entry_text(i,ql_entry.question_text);
			ql_database.gotoNext();
			i++;
		}while(!ql_database.atHead());
	}
	// --------------------------------------------------------------------------
	// this function turns off all errors in the Survey Details section of the app
	function clear_survey_details_errors(){
		var field_label_array = new Array('survey_name','user_instructions','confirmation_msg','start_date_time','end_date_time');
		for(var i in field_label_array){ clear_field_error(field_label_array[i]); }
	}
	// --------------------------------------------------------------------------
	// this function turns off all errors in the Survey Details section of the app
	function clear_question_details_errors(){
		var field_label_array = new Array('question_text','include_stats','required_question','error_message','question_type','option_list');
		for(var i in field_label_array){ clear_field_error(field_label_array[i]); }
	}
	// --------------------------------------------------------------------------
	// this function looks at the data stored in the survey details section of the form. This function
	// returns the number of invalid data fields found and marks these areas as invalid
	function validate_survey_details(){
		var error_count = 0;
		var s,t, val;
		var start_time_okay = 0;
		var end_time_okay = 0;

		// check the survey name
		t = document.getElementById('survey_name');
		val = t.value = trim(t.value);
		if(val.length == 0){ set_field_error('survey_name','A Survey Name must be provided so that\nyou may identify it in the Main Menu.'); error_count++; }

		// check the start time
		t = trim(start_time_hour.value);
		s = trim(start_time_min.value);
		// look for blank time fields
		if(t.length == 0 || s.length == 0){ set_field_error('start_date_time','A complete survey Start Time must be entered'); error_count++; }
		else{
			t = parseInt(t*1);
			s = parseInt(s*1);
			// look for well formatted time fields
			if(isNaN(t) || t > 12 || t < 1 || isNaN(s) || s > 59 || s < 0){ set_field_error('start_date_time','A valid survey Start Time must be entered'); error_count++; }
			else{
				// auto format the hour and minute fields 
				if(t < 10){ start_time_hour.value = '0' + t.toString(); }
				if(s < 10){ start_time_min.value = '0' + s.toString(); }
				start_time_okay = 1; // start time is okay
			}
		}

		// check the end time
		t = trim(end_time_hour.value);
		s = trim(end_time_min.value);
		// look for blank time fields
		if(t.length == 0 || s.length == 0){ set_field_error('end_date_time','A complete survey End Time must be entered'); error_count++; }
		else{
			t = parseInt(t*1);
			s = parseInt(s*1);
			// look for well formatted time fields
			if(isNaN(t) || t > 12 || t < 1 || isNaN(s) || s > 59 || s < 0){ set_field_error('end_date_time','A valid survey End Time must be entered'); error_count++; }
			else{
				// auto format the hour and minute fields 
				if(t < 10){ end_time_hour.value = '0' + t.toString(); }
				if(s < 10){ end_time_min.value = '0' + s.toString(); }
				end_time_okay = 1; // end time is okay
			}
		}

		// make sure the end date is after the start date
		if(start_time_okay && end_time_okay){
			// create the start/end timestamps
			extract_survey_times();
			if(end_timestamp <= start_timestamp){ set_field_error('end_date_time','A surveys End Date/Time must\noccur after its Start Date/Time.'); error_count++; }
		}

		// check the user instructions
		t = document.getElementById('user_instructions');
		val = t.innerHTML = trim(t.innerHTML);
		if(val.length == 0){ set_field_error('user_instructions','User Instructions must be provided\nso that people know why and how to\ncomplete your survey.'); error_count++; }

		// check the confirmation message 
		t = document.getElementById('confirmation_msg');
		val = t.innerHTML = trim(t.innerHTML);
		if(val.length == 0){ set_field_error('confirmation_msg','A Confirmation Message must be\nprovided to alert users that the survey\nhas been successfully completed.'); error_count++; }

		return error_count;
	}
	// --------------------------------------------------------------------------
	// this function looks at the data stored in the question details section of the form. This function
	// returns the number of invalid data fields found and marks these areas as invalid.
	function validate_question_details(){
		var f = document.forms['edit_survey_form'];
		var q_type = get_curr_question_type();
		var option_array = new Array();
		var error_count = 0;
		var i, t, val;

		// check the question text 
		t = document.getElementById('question_text');
		val = t.innerHTML = trim(t.innerHTML);
		if(val.length == 0){ set_field_error('question_text','You must provide this question\nwith instructional text so the user\nknows how to answer it.'); error_count++; }

		// make sure required questions have an error message
		if(f['required_question'][0].checked){
			t = document.getElementById('error_message');
			val = t.innerHTML = trim(t.innerHTML);
			if(val.length == 0){ set_field_error('error_message','This question is required. You must\nprovide a message to the user if\nthey fail to complete it.'); error_count++; }
		}

		// if the question type requires a list of options, we have to make sure
		// that some options have been specified in the list and that there aren't 
		// any duplicates in the option list. 
		if(q_type != 1 && q_type != 2){
			if(f.option_list.length == 0){
				set_field_error('option_list','This type of question requires at\nleast one entry in the option list.'); 
				error_count++;
			}
			if(f.option_list.length > 1){
				for(i = 0; i < f.option_list.length; i++){ option_array.push(f.option_list[i].text.toLowerCase()); }
				option_array.sort();
				for(i = 0; i < option_array.length - 1; i++){
					if(option_array[i] == option_array[i+1]){
						set_field_error('option_list','Your option list contains duplicates. Each\nentry in the option list must be unique.'); 
						error_count++;
						break;
					}
				}
			}
		}

		return error_count;
	}
	// --------------------------------------------------------------------------
	// this function looks at the question detail form and pulls out the
	// question_type id and returns it. Note, this is NOT the index of the
	// selected radio button.
	function get_curr_question_type(){
		var question_types = document.forms['edit_survey_form'].question_type;
		// find which radio button is checked
		for(var i = 0; i < question_types.length; i++){ if(question_types[i].checked){ break; } }
		return question_types[i].value;
	}
	// --------------------------------------------------------------------------
	// this function takes the name of a group of radio buttons, and then
	// attempts to check the one with the index passed 
	function select_radio_button(_name,_idx){
		var f = document.forms['edit_survey_form'];
		if(f[_name] && f[_name].length > _idx){ f[_name][_idx].checked = true; }
	}
	// --------------------------------------------------------------------------
	// this function resets the question details section of the form to its default state
	// note- this does not turn off errors. That is handled separately by the clear_question_details_errors() function
	function reset_question_details_form(){
		var f = document.forms['edit_survey_form'];
		f['include_stats_report'][0].checked = true;
		f['required_question'][0].checked = true;
		f['question_type'][0].checked = true;
		document.getElementById('question_text').innerHTML = '';
		document.getElementById('error_message').innerHTML = '';
		document.getElementById('new_option').value = '';
		for(var i = f['option_list'].length - 1; i >= 0; i--){
			f['option_list'][i] = null;
		}
	}
	// --------------------------------------------------------------------------
	// this function takes as inputs the character that was just entered and returns true if it was 
	// numeric or if it was a manipulation key (del, backspace, etc.)
	function validate_num_keystroke(nChar){
		// allow del, backspace, tab, arrow keys, numbers above the keyboard,
		// and the keyboards numeric keypad
		return (nChar == 46 || nChar == 8 || nChar == 9 || (nChar >= 37 && nChar <= 40) || (nChar >= 48 && nChar <= 57) || (nChar >= 96 && nChar <= 105));
	}
	// --------------------------------------------------------------------------
	// this function extracts form data and constructs the start and end
	// timestamps which are stored in the global variables start/end_timestamp
	// this functino assumes the form contains valid time data and is only called upon successful validation
	function extract_survey_times(){
		var year, mon, day, hour, min, sec, ampm;

		sec 	= 30;
		year 	= start_calendar.sel_year;
		mon 	= start_calendar.sel_mon - 1; // zero = January
		day 	= start_calendar.sel_day;
		hour 	= start_time_hour.value * 1;
		min 	= start_time_min.value * 1;
		ampm 	= document.getElementById('start_time_ampm').innerHTML;

		// adjust the hour to 0 - 23 range
		if(ampm == 'am' && hour == 12){ hour = 0; }
		else if(ampm == 'pm' && hour < 12){ hour += 12; }

		// store the timestamp in sections (remove ms by dividing by 1000)
		start_timestamp = Math.floor((new Date(year,mon,day,hour,min,sec).getTime()) / 1000);

		year 	= end_calendar.sel_year;
		mon 	= end_calendar.sel_mon - 1; // zero = January
		day 	= end_calendar.sel_day;
		hour 	= end_time_hour.value * 1;
		min 	= end_time_min.value * 1;
		ampm 	= document.getElementById('end_time_ampm').innerHTML;

		// adjust the hour to 0 - 23 range
		if(ampm == 'am' && hour == 12){ hour = 0; }
		else if(ampm == 'pm' && hour < 12){ hour += 12; }

		// store the timestamp in sections (remove ms by dividing by 1000)
		end_timestamp = Math.floor((new Date(year,mon,day,hour,min,sec).getTime()) / 1000);
	}
	// ==========================================================================
	// ||||||||||||||||||||||||| EVENT HANDLER FUNCTIONS ||||||||||||||||||||||||
	// ==========================================================================
	// actions to perform when a user clicks the "new question" button
	function new_question_onclick(){
		if(!is_busy){
			is_busy = 1;
			 
			clear_question_details_errors();
			// if the current question details are valid, proceed with the add
			if(validate_question_details() == 0){
				// place the CDL-List cursor on the active element and store the current questions data to our database
				get_ql_db_entry_by_idx(active_ql_entry);
				ql_database.getCursor().extract_page_data();

				// clear the form
				reset_question_details_form();

				// if all of the ql html entries are visible, then we have to add the additional html entry
				if(ql_entry_count == ql_entries_visible){ append_ql_html(); }
				else{
					document.getElementById('q'+ql_entries_visible+'_table').style.display = '';
					ql_entries_visible++;
				}

				// create a new survey question and add it to our ql database
				var new_question = new Survey_Question();
				new_question.question_text = 'Enter your question here';
				ql_database.push(new_question);

				// set the ql entries text to the default value
				set_ql_entry_text(ql_entry_count-1, new_question.question_text);

				// update the question list hilighting
				lolite_ql_entry(active_ql_entry);
				active_ql_entry = ql_entries_visible-1;
				hilite_ql_entry(active_ql_entry);

				// render the question details
				new_question.render_to_page();
					
				// update the display of the Question List
				render_ql_entries();

				// scroll the new ql entry into view
				var ql_area_div = document.getElementById('ql_area_div');
				ql_area_div.scrollTop = ql_area_div.scrollHeight;
			}
			is_busy = 0;
		}
	}
	// --------------------------------------------------------------------------
	function edit_question_onclick(_idx){
		if(!is_busy){
			is_busy = 1;

			clear_question_details_errors();
			// if the current question details are valid, proceed with the edit
			if(validate_question_details() == 0){
				// place the CDL-List cursor on the active element and store the current questions data to our database
				get_ql_db_entry_by_idx(active_ql_entry);
				ql_database.getCursor().extract_page_data();

				// clear the form
				reset_question_details_form();

				// render the selected question to the page
				get_ql_db_entry_by_idx(_idx);
				ql_database.getCursor().render_to_page();

				// update the question list hilighting
				lolite_ql_entry(active_ql_entry);
				active_ql_entry = _idx;
				hilite_ql_entry(active_ql_entry);
					
				// update the display of the Question List
				render_ql_entries();
			}
			is_busy = 0;
		}
	}
	// --------------------------------------------------------------------------
	function delete_question_onclick(_idx){
		if(!is_busy){
			is_busy = 1;

			// never delete the last entry
			if(ql_database.getLength() > 1){
				// if we're deleting the active entry, we'll have to display the entry that becomes hilited by default
				var load_question = (_idx == active_ql_entry) ? 1 : 0;
	
				// update which entry is hilited. The slot above the active entry is hilited if the slot being deleted is above the
				// active entry (everything shifts up), or if the active index is at the bottom and it is being deleted.
				if(_idx < active_ql_entry || (_idx == active_ql_entry && _idx == (ql_entries_visible-1))){
					lolite_ql_entry(active_ql_entry);
					active_ql_entry--;
					hilite_ql_entry(active_ql_entry);
				}

				// jump to the correct ql database entry and remove the unwanted question
				get_ql_db_entry_by_idx(_idx);
				ql_database.remove();
	
				// hide the last visible ql entry
				document.getElementById('q'+(ql_entries_visible-1)+'_table').style.display = 'none';
				ql_entries_visible--;
	
				if(load_question){
					// reset the question detail form and load the contents of the newly defaulted question
					clear_question_details_errors();
					reset_question_details_form();
					get_ql_db_entry_by_idx(active_ql_entry);
					ql_database.getCursor().render_to_page();
				}
	
				// update the display of the Question List
				render_ql_entries();
			}
			is_busy = 0;
		}
	}
	// --------------------------------------------------------------------------
	function move_question_up_onclick(_idx){
		if(!is_busy){
			is_busy = 1;

			// make sure there's enough entries to do a move
			if(ql_database.getLength() > 1){

				var new_active_idx = active_ql_entry;

				// find which entry is hilited. If the active entry or the top entry are moved up, then the active entry is moved up (index is decremented)
				// if the entry right below the active entry is moved up, then the active entry is shifted down (index is incremented)
				if(_idx == active_ql_entry+1){ new_active_idx++; } // swap
				else if(_idx == active_ql_entry && _idx == 0){ new_active_idx = ql_entries_visible-1; } // wrap
				else if((_idx == active_ql_entry && _idx != 0) || (_idx != active_ql_entry && _idx == 0)){ new_active_idx--; } // shift up

				// point the cursor to the correct node
				get_ql_db_entry_by_idx(_idx);

				// wrapping is easy. pull it off the head, and push it to the tail
				if(_idx == 0){ ql_database.push(ql_database.dequeue()); }
				// index 1 is easy too. we just remove it and stick it at the head
				else if(_idx == 1){ ql_database.enqueue(ql_database.remove()); }
				// otherwise, we have a little more work. we store and remove the node, move the cursor back twice and insert after it.
				else{
					var curr_question = ql_database.remove();
					ql_database.gotoPrev();
					ql_database.gotoPrev();
					ql_database.insert(curr_question);
				}

				// if the active entry changed positions, hilite it accordingly
				if(new_active_idx != active_ql_entry){
					lolite_ql_entry(active_ql_entry);
					active_ql_entry = new_active_idx;
					hilite_ql_entry(active_ql_entry);
				}

				// update the display of the Question List
				render_ql_entries();
			}
			is_busy = 0;
		}
	}
	// --------------------------------------------------------------------------
	function move_question_down_onclick(_idx){
		if(!is_busy){
			is_busy = 1;

			// make sure there's enough entries to do a move
			if(ql_database.getLength() > 1){
				var new_active_idx = active_ql_entry;

				if(_idx == active_ql_entry-1){ new_active_idx--; } // swap
				else if(_idx == active_ql_entry && _idx == ql_entries_visible-1){ new_active_idx = 0; } // wrap
				else if((_idx == active_ql_entry && _idx != ql_entries_visible-1) || (_idx != active_ql_entry && _idx == ql_entries_visible-1)){ new_active_idx++; } // shift down

				// point the cursor to the correct node
				get_ql_db_entry_by_idx(_idx);

				// wrapping is easy. pop off the tail and enqueue it to the head
				if(_idx == ql_entries_visible-1){ ql_database.enqueue(ql_database.pop()); }
				// the second to last is very easy too. just remove it and push it to the tail
				else if(_idx == ql_entries_visible-2){ ql_database.push(ql_database.remove()); }
				// otherwise, we remove it which sets the cursor to the next item. An insert that pastes the new node after the current node (effectively a swap)
				else{ ql_database.insert(ql_database.remove()); }

				// if the active entry changed positions, hilite it accordingly
				if(new_active_idx != active_ql_entry){
					lolite_ql_entry(active_ql_entry);
					active_ql_entry = new_active_idx;
					hilite_ql_entry(active_ql_entry);
				}

				// update the display of the Question List
				render_ql_entries();
			}
			is_busy = 0;
		}
	}
	// --------------------------------------------------------------------------
	// show or hide the option list depending on question type selected via the radio buttons
	function set_question_type_onclick(){
		var q_type = get_curr_question_type();
		if(q_type == 1 || q_type == 2){ document.getElementById('option_list_section').style.display = 'none'; }
		else{ document.getElementById('option_list_section').style.display = ''; }
	}
	// --------------------------------------------------------------------------
	// show or hide the error message field depending on whether the user has
	// checked the radio button that says if the question is required or not
	function set_req_question_onclick(){
		var f = document.forms['edit_survey_form'];
		if(f.required_question && f.required_question[0].checked){ document.getElementById('error_message_section').style.display = ''; }
		else{ document.getElementById('error_message_section').style.display = 'none'; }
	}
	// --------------------------------------------------------------------------
	// this function grabs the text from the Add Option text input, trims it, and then adds it to the multiselect
	// if it's not empty. If successfully added to the list, the text input is cleared.
	function add_option_onclick(){
		var option_list = document.forms['edit_survey_form'].option_list;
		var new_option = document.getElementById('new_option');
		var option_label = trim(new_option.value);
		var idx = option_list.length;
		if(option_label.length > 0){
			option_list[idx] = new Option(option_label,'');
			new_option.value = '';
			new_option.focus();
		}
	}
	// --------------------------------------------------------------------------
	// this function looks through the current Option List and deletes and entries that are selected
	function delete_options_onclick(){
		var option_list = document.forms['edit_survey_form'].option_list;
		for(var i = option_list.length - 1; i >= 0; i--){
			if(option_list[i].selected){ option_list[i] = null; }
		}
	}
	// --------------------------------------------------------------------------
	// this function looks through the current Option List and moves each
	// selected entry up one level if possible. This is not circular! An entry
	// at the top will not wrap around to the bottom
	function move_options_up_onclick(){
		var option_list = document.forms['edit_survey_form'].option_list;
		var tmp = new Object();
		if(option_list.length > 1){
			for(var i = 1; i < option_list.length; i++){
				if(option_list[i].selected){
					tmp.selected = option_list[i-1].selected;
					tmp.text = option_list[i-1].text;
					tmp.value = option_list[i-1].value;
					option_list[i-1].text = option_list[i].text;
					option_list[i-1].value = option_list[i].value;
					option_list[i-1].selected = option_list[i].selected;
					option_list[i].text = tmp.text;
					option_list[i].value = tmp.value;
					option_list[i].selected = tmp.selected;
				}
			}
		}
	}
	// --------------------------------------------------------------------------
	// this function looks through the current Option List and moves each
	// selected entry down one level if possible. This is not circular! An entry
	// at the bottom will not wrap around to the top 
	function move_options_down_onclick(){
		var option_list = document.forms['edit_survey_form'].option_list;
		var tmp = new Object();
		if(option_list.length > 1){
			for(var i = option_list.length-2; i >= 0; i--){
				if(option_list[i].selected){
					tmp.selected = option_list[i+1].selected;
					tmp.text = option_list[i+1].text;
					tmp.value = option_list[i+1].value;
					option_list[i+1].text = option_list[i].text;
					option_list[i+1].value = option_list[i].value;
					option_list[i+1].selected = option_list[i].selected;
					option_list[i].text = tmp.text;
					option_list[i].value = tmp.value;
					option_list[i].selected = tmp.selected;
				}
			}
		}
	}
	// --------------------------------------------------------------------------
	function save_survey_onclick(){
		var t,q,i,j;
		if(!is_busy){
			is_busy = 1;
			
			clear_survey_details_errors();
			clear_question_details_errors();

			var sd_errors = validate_survey_details();
			var sq_errors = validate_question_details();
			if(sd_errors == 0 && sq_errors == 0){

				// if no errors were found, start the busy animation
				start_busy_animation();

				// place the CDL-List cursor on the active element and store the current questions data to our database
				get_ql_db_entry_by_idx(active_ql_entry);
				ql_database.getCursor().extract_page_data();

				// grab all of the data from the form, and send it via the IO
				// API to have it stored to the database
				io_api.add_name_val_pair('survey_id',survey_id);
				io_api.add_name_val_pair('survey_name',document.getElementById('survey_name').value);

				extract_survey_times();
				io_api.add_name_val_pair('start_timestamp',start_timestamp);
				io_api.add_name_val_pair('end_timestamp',end_timestamp);

				// find which is_draft radio button is checked
				t = document.forms['edit_survey_form'].is_draft;
				for(i = 0; i < t.length; i++){ if(t[i].checked){ break; } }
				if(i == t.length){ i = 0; }
				io_api.add_name_val_pair('is_draft', t[i].value);

				io_api.add_name_val_pair('instructions',document.getElementById('user_instructions').innerHTML);
				io_api.add_name_val_pair('confirmation',document.getElementById('confirmation_msg').innerHTML);

				// go through the question list database and extract its data
				// into individual name value pairs for saving
				io_api.add_name_val_pair('question_count',ql_database.getLength());
				ql_database.gotoHead();
				i = 0;
				do{
					t = ql_database.getCursor();
					io_api.add_name_val_pair('q'+i+'_id',t.id);
					io_api.add_name_val_pair('q'+i+'_text',t.question_text);
					io_api.add_name_val_pair('q'+i+'_inc_stats',t.include_stats);
					io_api.add_name_val_pair('q'+i+'_required',t.req_question);
					io_api.add_name_val_pair('q'+i+'_err_msg',t.error_message);
					io_api.add_name_val_pair('q'+i+'_type',t.question_type);
					// if the question should have options associated with it,
					if(t.question_type > 2){
						io_api.add_name_val_pair('q'+i+'_opt_cnt',t.option_list.length);
						// go through the option list and extract its data into individual name value pairs for saving
						for(j = 0; j < t.option_list.length; j++){
							io_api.add_name_val_pair('q'+i+'_o'+j+'_id',t.option_list[j].option_id+'');
							io_api.add_name_val_pair('q'+i+'_o'+j+'_text',t.option_list[j].option_text+'');
						}
					}
					else{ io_api.add_name_val_pair('q'+i+'_opt_cnt',0); }

					ql_database.gotoNext();
					i++;
				}while(!ql_database.atHead());

				io_api.dispatch();
			}

			is_busy = 0;
		}
	}
	// --------------------------------------------------------------------------
	function start_cal_onmouseup(){
		start_calendar.view_mon = start_calendar.sel_mon;
		start_calendar.view_year = start_calendar.sel_year;
		start_calendar.display_month();
		start_calendar.show();
	}
	// --------------------------------------------------------------------------
	function start_cal_onmouseout(){
		start_calendar.hide();
		var mon_array = new Array('','Jan.','Feb.','Mar.','Apr.','May.','June','July','Aug.','Sept.','Oct.','Nov.','Dec.');
		var div = document.getElementById('start_date_text');
		div.innerHTML = mon_array[start_calendar.sel_mon] + ' ' + start_calendar.sel_day + ', ' + start_calendar.sel_year;
	}
	// --------------------------------------------------------------------------
	function end_cal_onmouseup(){
		end_calendar.view_mon = end_calendar.sel_mon;
		end_calendar.view_year = end_calendar.sel_year;
		end_calendar.display_month();
		end_calendar.show();
	}
	// --------------------------------------------------------------------------
	function end_cal_onmouseout(){
		end_calendar.hide();
		var mon_array = new Array('','Jan.','Feb.','Mar.','Apr.','May.','June','July','Aug.','Sept.','Oct.','Nov.','Dec.');
		var div = document.getElementById('end_date_text');
		div.innerHTML = mon_array[end_calendar.sel_mon] + ' ' + end_calendar.sel_day + ', ' + end_calendar.sel_year;
	}
	// --------------------------------------------------------------------------
	function calendar_ampm_onmouseup(_this){
		_this.innerHTML = (_this.innerHTML == 'pm') ? 'am' : 'pm';
		if(_this.blur){ _this.blur(); }
	}
	// --------------------------------------------------------------------------
	// this function filters out everything except valid numbers for the hour
	function cal_time_onkeydown(e){
		var jEvent = e ? e : event;
		var nChar = jEvent.which ? jEvent.which : jEvent.keyCode;
		return validate_num_keystroke(nChar);
	}
	// ==========================================================================
