	// ==========================================================================
	// ||||||||||||||||||||||||| GLOBAL VARIABLES |||||||||||||||||||||||||||||||
	// ==========================================================================
	var is_busy 			= 0; // prevent event functions from being called before other critical events are finished
	var dom_grid_ref 		= new Array(); // dom references to each slot in the summary grid
	var dom_sort_arrow_ref	= new Array(); // dom refs to each column's sort arrow image
	var dom_page_ref		= new Array(); // dom references to each pagination link
	var survey_db 			= new Array(); // holds all of the Survey_Summary objects for the tab
	var active_page 		= 0; // 0 based index of currently active page
	var item_count 			= 0; // total survey summaries loaded
	var page_count 			= 0; // total pages to manage
	var curr_sort_col		= -1; // the column index of the survey summary that is currently sorted on
	var sort_direction		= 1; // 1 or -1. 1 is sorting ascending alphanumerically (a..z)

	// prepare all of the page's rollover graphics
	if(document.images){
		var bttn_add_new_survey_off = new Image(); bttn_add_new_survey_off.src = './images/main/button/bttn_add_new_survey_off.gif';
		var bttn_add_new_survey_on = new Image(); bttn_add_new_survey_on.src = './images/main/button/bttn_add_new_survey_on.gif';
		var icon_sort_arrow_down_off = new Image(); icon_sort_arrow_down_off.src = './images/global/icon/icon_sort_arrow_down_off.gif';
		var icon_sort_arrow_up_off = new Image(); icon_sort_arrow_up_off.src = './images/global/icon/icon_sort_arrow_up_off.gif';
		var icon_sort_arrow_hidden_off = new Image(); icon_sort_arrow_hidden_off.src = './images/global/other/other_clear_spacer.gif';

		var icon_pencil_off = new Image(); icon_pencil_off.src = './images/global/icon/icon_pencil_off.gif';
		var icon_pencil_on = new Image(); icon_pencil_on.src = './images/global/icon/icon_pencil_on.gif';
		var icon_trash_can_off = new Image(); icon_trash_can_off.src = './images/global/icon/icon_trash_can_off.gif';
		var icon_trash_can_on = new Image(); icon_trash_can_on.src = './images/global/icon/icon_trash_can_on.gif';
		var icon_magnifying_glass_off = new Image(); icon_magnifying_glass_off.src = './images/global/icon/icon_magnifying_glass_off.gif';
		var icon_magnifying_glass_on = new Image(); icon_magnifying_glass_on.src = './images/global/icon/icon_magnifying_glass_on.gif';
		var icon_thumb_tac_off = new Image(); icon_thumb_tac_off.src = './images/global/icon/icon_thumb_tac_off.gif';
		var icon_thumb_tac_on = new Image(); icon_thumb_tac_on.src = './images/global/icon/icon_thumb_tac_on.gif';
		var icon_clone_papers_off = new Image(); icon_clone_papers_off.src = './images/global/icon/icon_clone_papers_off.gif';
		var icon_clone_papers_on = new Image(); icon_clone_papers_on.src = './images/global/icon/icon_clone_papers_on.gif';
		var icon_vert_bar_graph_off = new Image(); icon_vert_bar_graph_off.src = './images/global/icon/icon_vert_bar_graph_off.gif';
		var icon_vert_bar_graph_on = new Image(); icon_vert_bar_graph_on.src = './images/global/icon/icon_vert_bar_graph_on.gif';
	}
	// ==========================================================================
	// ||||||||||||||||||||||||| SURVEY SUMMARY CLASS |||||||||||||||||||||||||||
	// ==========================================================================
	function Survey_Summary(_survey_id, _survey_name, _start_timestamp, _end_timestamp, _responses){
		this.survey_id			= _survey_id;
		this.survey_name		= _survey_name;
		this.start_timestamp	= _start_timestamp;
		this.start_date_str		= '';
		this.end_timestamp		= _end_timestamp;
		this.end_date_str		= '';
		this.responses			= _responses;
	}
	// ==========================================================================
	// ||||||||||||||||||||||||| HELPER FUNCTIONS |||||||||||||||||||||||||||||||
	// ==========================================================================
	// This function looks at the active_page and uses the survey_db to render
	// it's contents into our html interface
	function render_summary(){
		var i,t = 0;
		var date_str = '';
		var start_idx = active_page * items_per_page;
		var stop_idx = start_idx + items_per_page;
		for(i = start_idx; i < stop_idx; i++){
			// render the current item to the interfac3
			if(item_count > 0 && i < item_count){	
				with(dom_grid_ref[i-start_idx].survey_name_div){
					innerHTML = title = survey_db[i].survey_name;
				}
				if(survey_db[i].start_date_str == ''){ survey_db[i].start_date_str = get_formatted_date_str(survey_db[i].start_timestamp * 1000); }
				dom_grid_ref[i-start_idx].start_time_div.innerHTML = survey_db[i].start_date_str;
				if(survey_db[i].end_date_str == ''){ survey_db[i].end_date_str = get_formatted_date_str(survey_db[i].end_timestamp * 1000); }
				dom_grid_ref[i-start_idx].end_time_div.innerHTML = survey_db[i].end_date_str;
				dom_grid_ref[i-start_idx].responses_div.innerHTML = survey_db[i].responses;
				dom_grid_ref[i-start_idx].icons_div.style.display = '';
			}
			// display a blank entry
			else{
				dom_grid_ref[i-start_idx].survey_name_div.innerHTML = '';
				dom_grid_ref[i-start_idx].start_time_div.innerHTML = '';
				dom_grid_ref[i-start_idx].end_time_div.innerHTML = '';
				dom_grid_ref[i-start_idx].responses_div.innerHTML = '';
				dom_grid_ref[i-start_idx].icons_div.style.display = 'none';
			}
		}
	}
	// --------------------------------------------------------------------------
	// This function takes a timestamp (in ms) and returns a date string
	// formatted like mm/dd/yyyy hh:mm am
	function get_formatted_date_str(_timestamp){
		var str = '';
		var t = new Date(_timestamp);
		var ampm = 'am';
		var i = '';
		i = t.getMonth() + 1;
		str = i;
		str += '/';
		i = t.getDate();
		str += i;
		str += '/';
		str += t.getYear();
		str += ' ';
		i = t.getHours();
		if(i >= 12){ ampm = 'pm'; } // hours 12-23 are in pm
		if(i == 0){ i = 12; } // 0 hour is 12 am
		if(i > 12){ i -= 12; } // hours 13-23 need 12 removed
		str += i;
		str += ':';
		i = t.getMinutes();
		str += (i < 10) ? ('0'+i) : i;
		str += ampm;
		return str;
	}
	// --------------------------------------------------------------------------
	// Perform all of the functions that initialize the interface after it's been loaded
	function init_survey_summary(){
		var i = 0;
		// store references to all of the major dom elements of the summary.
		// This allows us to avoid repeated getElementById calls.
		for(i = 0; i < items_per_page; i++){
			dom_grid_ref[i] = new Object();
			dom_grid_ref[i].survey_name_div = document.getElementById('survey_name_div_'+i);
			dom_grid_ref[i].start_time_div = document.getElementById('start_time_div_'+i);
			dom_grid_ref[i].end_time_div = document.getElementById('end_time_div_'+i);
			dom_grid_ref[i].responses_div = document.getElementById('responses_div_'+i);
			dom_grid_ref[i].icons_div = document.getElementById('icons_div_'+i);
		}	

		// store references to each pagination link
		for(i = 0; i < page_count; i++){
			dom_page_ref[i] = document.getElementById('page_link_'+i);
		}

		// store references to each column's sort arrow image
		for(i = 0; i < 4; i++){
			dom_sort_arrow_ref[i] = document.getElementById('sort_arrow_img_'+i);
		}

		if(page_count > 0){	
			// by default, sort the survey summaries by name
			sort_col_onmouseup(0);

			// render the summary to our html interface and set us at page 0
			goto_page_onmouseup(active_page); 
		}
		else{ render_summary(); } 
	}
	// --------------------------------------------------------------------------
	// this comparison function sorts Survey_Summary objects alphabetically by
	// survey_name (lower cased)
	function cmp_survey_names(_a,_b){
		_a = _a['survey_name'].toLowerCase();
		_b = _b['survey_name'].toLowerCase();
		return (_a == _b) ? 0 : ((_a < _b) ? -1 : 1);
	}
	// --------------------------------------------------------------------------
	// this comparison function sorts Survey_Summary objects by start timestamps
	function cmp_start_times(_a,_b){
		_a = _a['start_timestamp'] * 1;
		_b = _b['start_timestamp'] * 1;
		return (_a == _b) ? 0 : ((_a < _b) ? -1 : 1);
	}
	// --------------------------------------------------------------------------
	// this comparison function sorts Survey_Summary objects by end timestamps
	function cmp_end_times(_a,_b){
		_a = _a['end_timestamp'] * 1;
		_b = _b['end_timestamp'] * 1;
		return (_a == _b) ? 0 : ((_a < _b) ? -1 : 1);
	}
	// --------------------------------------------------------------------------
	// this comparison function sorts Survey_Summary objects by responses 
	function cmp_responses(_a,_b){
		_a = _a['responses'] * 1;
		_b = _b['responses'] * 1;
		return (_a == _b) ? 0 : ((_a < _b) ? -1 : 1);
	}
	// ==========================================================================
	// ||||||||||||||||||||||||| EVENT HANDLER FUNCTIONS ||||||||||||||||||||||||
	// ==========================================================================
	// This event handler takes a page index, modifies the active page, and
	// render's it to the interface
	function goto_page_onmouseup(_page){
		if(_page != active_page){
			with(dom_page_ref[active_page].style){
				textDecoration = 'none';
			}
			active_page = _page;
		}
		with(dom_page_ref[active_page].style){
			textDecoration = 'underline overline';
		}
		render_summary();
	}
	// --------------------------------------------------------------------------
	// This event takes a numeric direction (pos/neg) and moves that many pages
	// in the direction (-2 would move you to two pages before the currently
	// active page)
	function adjacent_page_onmouseup(_dir){
		var new_page = 0;
		// compute the new page index based on the location, and making sure it
		// doesn't go out of bounds
		if(_dir < 0){ new_page = ((active_page + _dir) >= 0) ? (active_page + _dir) : 0; }
		else{ new_page = ((active_page + _dir) < page_count) ? (active_page + _dir) : (page_count-1); }

		// render the newly selected page
		goto_page_onmouseup(new_page);
	}
	// --------------------------------------------------------------------------
	// This event takes a column number, and sorts the Survey_Summary data
	// structure accordingly. It also handles the display of the sorting arrows
	function sort_col_onmouseup(_col){
		// determine if simply reversing a sort
		var is_reversed = (_col == curr_sort_col) ? 1 : 0;
		// holds the sorting comparison function
		var sort_function = function(){ return 0; };

		// hide the current sort column arrow if necessary
		if(curr_sort_col != -1 && _col != curr_sort_col){ dom_sort_arrow_ref[curr_sort_col].src = icon_sort_arrow_hidden_off.src; }

		// perform a simple array reversal and track the new direction
		if(is_reversed){
			sort_direction *= -1;
			survey_db.reverse();
		}
		// otherwise, perform a quick sort using the appropriate column compare function
		else{
			sort_direction = 1;
			switch(_col){
				case 0: sort_function = cmp_survey_names; break;
				case 1: sort_function = cmp_start_times; break;
				case 2: sort_function = cmp_end_times; break;
				case 3: sort_function = cmp_responses; break;
				default: sort_function = cmp_survey_names; break;
			}
			survey_db = qsort_array(survey_db,0,survey_db.length-1,sort_function);
		}

		// update the current sort column arrow
		if(sort_direction == -1){ dom_sort_arrow_ref[_col].src = icon_sort_arrow_up_off.src; }
		else{ dom_sort_arrow_ref[_col].src = icon_sort_arrow_down_off.src; }

		// track the new sort column and render the results
		curr_sort_col = _col;
		render_summary();
	}
	// --------------------------------------------------------------------------
	// based on the index that was clicked and the current page information,
	// this event figures out the survey_id to use and redirects to the edit survey page
	function edit_survey_onmouseup(_idx){
		// determine the survey id of the entry clicked
		var survey_id = survey_db[(active_page * items_per_page + _idx)].survey_id;
		// redirect to the edit survey page passing along the survey_id
		var url = 'edit_survey.php?survey_id='+survey_id;
		// for some reason, we have to use a settimeout here. just setting the location silently fails.
		setTimeout('document.location = "'+url+'";', 1);
	}
	// --------------------------------------------------------------------------
	// based on the index that was clicked and the current page information,
	// this event figures out the survey_id and posts it to itself to remove the survey
	function delete_survey_onmouseup(_idx){
		var confirm_msg = "Are you sure you wish to permanently delete this survey?";
		if(confirm(confirm_msg)){
			var f = document.forms['survey_list_form'];
			// determine the survey id of the entry clicked
			var survey_id = survey_db[(active_page * items_per_page + _idx)].survey_id;

			if(f){
				// populate the form fields
				f['page_action'].value = 'delete_survey';
				f['survey_id'].value = survey_id;
				submit_form();
			}
		}
	}
	// --------------------------------------------------------------------------
	// based on the index that was clicked and the current page information,
	// this event figures out the survey_id posts it to itself so that it can
	// clone the survey
	function clone_survey_onmouseup(_idx){
		var f = document.forms['survey_list_form'];
		// determine the survey id of the entry clicked
		var survey_id = survey_db[(active_page * items_per_page + _idx)].survey_id;

		if(f){
			// populate the form fields
			f['page_action'].value = 'clone_survey';
			f['survey_id'].value = survey_id;
			submit_form();
		}
	}
	// --------------------------------------------------------------------------
	// based on the index that was clicked and the current page information,
	// this event figures out the survey_id and passeses it to our reports page
	// along with the survey tab that we're on (draft, etc.) 
	function view_report_onmouseup(_idx){
		// determine the survey id of the entry clicked
		var survey_id = survey_db[(active_page * items_per_page + _idx)].survey_id;

		// redirect to the clone survey process module page passing along the
		// survey_id, and our current url so it can redirect back here
		var url = 'reports.php?survey_tab='+survey_tab+'&survey_id='+survey_id;
		// for some reason, we have to use a settimeout here. just setting the location silently fails.
		setTimeout('document.location = "'+url+'";', 1);
	}
	// --------------------------------------------------------------------------
	// based on the index that was clicked and the current page information,
	// this event figures out the survey_id and pops open a window to pass the
	// information along to. The render survey code is used.
	var preview_win = null;
	function preview_survey_onmouseup(_idx){
		// determine the survey id of the entry clicked
		var survey_id = survey_db[(active_page * items_per_page + _idx)].survey_id;

		var cFeatures = 
			'width=640,' +
			'height=480,' +
			'scrollbars=yes,' +
			'resizable=yes,' +
			'location=no,' +
			'menubar=yes,' +
			'status=no,' +
			'titlebar=no,' +
			'toolbar=yes';

		preview_win = window.self.open('./client_modules/preview_survey.php?survey_id='+survey_id, 'preview_win', cFeatures);
	}
	// --------------------------------------------------------------------------
	// based on the index that was clicked and the current page information,
	// this event figures out the survey_id and passeses it to our insert survey page
	// along with the survey tab that we're on (draft, etc.) 
	function insert_survey_onmouseup(_idx){
		// determine the survey id of the entry clicked
		var survey_id = survey_db[(active_page * items_per_page + _idx)].survey_id;

		// redirect to the clone survey process module page passing along the
		// survey_id, and our current url so it can redirect back here
		var url = 'insert_survey.php?survey_tab='+survey_tab+'&survey_id='+survey_id;
		// for some reason, we have to use a settimeout here. just setting the location silently fails.
		setTimeout('document.location = "'+url+'";', 1);
	}
	// ---------------------------------------------------------------------------
	// this function simply submits the pages form and ensures that users don't
	// submit it multiple times while the page is attempting to load
	var is_submitting = 0;
	function submit_form(){
		if(!is_submitting){
			is_submitting = 1;
			setTimeout("document.forms['survey_list_form'].submit();",10);
		}
		return true;
	}
	// ==========================================================================
