	// ==========================================================================
	// ||||||||||||||||||||||||| GLOBAL VARIABLES |||||||||||||||||||||||||||||||
	// ==========================================================================
	var is_busy 			= 0; // prevent event functions from being called before other critical events are finished

	// prepare all of the page's rollover graphics
	if(document.images){
		var bttn_save_off = new Image(); bttn_save_off.src = './images/global/button/bttn_save_off.gif';
		var bttn_save_on = new Image(); bttn_save_on.src = './images/global/button/bttn_save_on.gif';
		var bttn_cancel_off = new Image(); bttn_cancel_off.src = './images/global/button/bttn_cancel_off.gif';
		var bttn_cancel_on = new Image(); bttn_cancel_on.src = './images/global/button/bttn_cancel_on.gif';
	}
	// ==========================================================================
	// ||||||||||||||||||||||||| HELPER FUNCTIONS |||||||||||||||||||||||||||||||
	// ==========================================================================
	// this function turns off all errors on the system optsion page
	function clear_all_errors(){
		var field_label_array = new Array('smtp_server','valid_file_ext');
		for(var i in field_label_array){ clear_field_error(field_label_array[i]); }
	}
	// --------------------------------------------------------------------------
	// this function looks at the data stored in the system options form. This function
	// returns the number of invalid data fields found and marks these areas as invalid
	function validate_system_options_form(){
		var error_count = 0;
		var i,s,t,r,val;
		var regex1, regex2 = '';
		var err_str = '';

		// trim the smtp server field 
		t = document.getElementById('smtp_server');
		t.value = trim(t.value);

		// check the format of the File Extensions field
		t = document.getElementById('valid_file_ext');
		val = t.value = trim(t.value);
		val = val.toLowerCase();
		// try to split the string into individual file extensions
		s = val.split(';');

		// remove any entries of zero length
		r = new Array();
		for(i=0; i < s.length; i++){ if(s[i].length > 0){ r.push(s[i]); } }
		s = r;

		// loop through all of the supplied file extensions
		for(i=0; i < s.length; i++){
			// trim it
			s[i] = trim(s[i]);
			// remove any leading period
			s[i] = s[i].replace(/^\./,'');

			// file extensions shouldn't be more than 8 characters long (and
			// even that's really long)
			if(s[i].length > 8){
				err_str += "* The file extension '"+s[i]+"' is longer than 8 characters.";
			}
		}

		// if errors were found,
		if(err_str.length > 0){ 
			// prepend the warning header
			err_str = '[ WARNING ]\n' + err_str; 
			// set the field error
			set_field_error('valid_file_ext', err_str); 
			error_count++;
		}

		// construct the prepped file extension string
		t.value = s.join(';');

		return error_count;
	}
	// ==========================================================================
	// ||||||||||||||||||||||||| EVENT HANDLER FUNCTIONS ||||||||||||||||||||||||
	// ==========================================================================
	function save_system_options_onmouseup(){
		is_busy = 1;
		var f = document.forms['system_options_form'];
		var ret_val = false;

		// hide any errors that might already be displayed
		clear_all_errors();

		// see if the form contains error and display them
		if(validate_system_options_form() == 0){
			f['page_action'].value = 'save_settings';
			// if no errors found, we submit our form
			setTimeout('document.forms["system_options_form"].submit();',10);
			ret_val = true;
		}
		else{ is_busy = 0; }
		return ret_val;
	}
	// --------------------------------------------------------------------------
