	// ==========================================================================
	// ||||||||||||||||||||||||| GLOBAL VARIABLES |||||||||||||||||||||||||||||||
	// ==========================================================================
	var is_busy 			= 0; // prevent event functions from being called before other critical events are finished

	// prepare all of the page's rollover graphics
	if(document.images){
		var bttn_save_off = new Image(); bttn_save_off.src = './images/global/button/bttn_save_off.gif';
		var bttn_save_on = new Image(); bttn_save_on.src = './images/global/button/bttn_save_on.gif';
		var bttn_cancel_off = new Image(); bttn_cancel_off.src = './images/global/button/bttn_cancel_off.gif';
		var bttn_cancel_on = new Image(); bttn_cancel_on.src = './images/global/button/bttn_cancel_on.gif';
		var bttn_new_publish_point_off = new Image(); bttn_new_publish_point_off.src = './images/system/button/bttn_new_publish_point_off.gif';
		var bttn_new_publish_point_on = new Image(); bttn_new_publish_point_on.src = './images/system/button/bttn_new_publish_point_on.gif';
		var bttn_test_connection_off = new Image(); bttn_test_connection_off.src = './images/system/button/bttn_test_connection_off.gif';
		var bttn_test_connection_on = new Image(); bttn_test_connection_on.src = './images/system/button/bttn_test_connection_on.gif';

		var icon_pencil_off = new Image(); icon_pencil_off.src = './images/global/icon/icon_pencil_off.gif';
		var icon_pencil_on = new Image(); icon_pencil_on.src = './images/global/icon/icon_pencil_on.gif';
		var icon_trash_can_off = new Image(); icon_trash_can_off.src = './images/global/icon/icon_trash_can_off.gif';
		var icon_trash_can_on = new Image(); icon_trash_can_on.src = './images/global/icon/icon_trash_can_on.gif';
		var icon_field_error_off = new Image(); icon_field_error_off.src = './images/global/icon/icon_field_error_off.gif';
		var icon_field_error_on = new Image(); icon_field_error_on.src = './images/global/icon/icon_field_error_on.gif';
		var icon_field_error_none = new Image(); icon_field_error_none.src = './images/global/other/other_clear_spacer.gif';
	}
	// ==========================================================================
	// ||||||||||||||||||||||||| HELPER FUNCTIONS |||||||||||||||||||||||||||||||
	// ==========================================================================
	// this function turns off all errors on the login page
	function clear_all_errors(){
		var field_label_array = new Array('ftp_server_name','ftp_user_name','ftp_user_password','ftp_user_password2','ftp_port_num','ftp_default_dir');
		for(var i in field_label_array){ clear_field_error(field_label_array[i]); }
	}
	// --------------------------------------------------------------------------
	// this function looks at the data stored in the publish point form. This function
	// returns the number of invalid data fields found and marks these areas as invalid
	function validate_pub_point_form(){
		var error_count = 0;
		var s,t, val;
		var regex = '';

		// check the ftp server name
		t = document.getElementById('ftp_server_name');
		// strip off any leading ftp protocol 'ftp://'
		t.value = trim(t.value);
		val = t.value = t.value.replace(/ftp:\/\//,'');
		if(val.length == 0){ set_field_error('ftp_server_name','[ WARNING ]\nThe URL/IP Address field cannot be empty.'); error_count++; }

		// check the ftp user name
		t = document.getElementById('ftp_user_name');
		val = t.value = trim(t.value);
		if(val.length == 0){ set_field_error('ftp_user_name','[ WARNING ]\nThe User Name field cannot be empty.'); error_count++; }

		// check the ftp user password 
		t = document.getElementById('ftp_user_password');
		val = t.value;
		if(val.length == 0){ set_field_error('ftp_user_password','[ WARNING ]\nThe Password field cannot be empty.'); error_count++; }

		// check the ftp user password 2
		t = document.getElementById('ftp_user_password2');
		val = t.value;
		if(val.length == 0){ set_field_error('ftp_user_password2','[ WARNING ]\nThe Retype Password field cannot be empty.'); error_count++; }

		// make sure the two passwords match
		t = document.getElementById('ftp_user_password');
		s = document.getElementById('ftp_user_password2');
		if(t.value.length > 0 && s.value.length > 0 && t.value != s.value){
			set_field_error('ftp_user_password2','[ WARNING ]\nThe Retype Password field does not match the Password field.\nPlease make sure you\'ve typed the password correctly.'); error_count++;
		}

		// check the validity of the port number
		t = document.getElementById('ftp_port_num');
		val = t.value = trim(t.value);
		if(val.length == 0){ set_field_error('ftp_port_num','[ WARNING ]\nThe Port # field cannot be empty.'); error_count++; }
		else{
			val = val * 1; // force the value to a number object
			regex = /^[0-9]+$/;
			if(!regex.test(val) || val < 1 || val > 65535){ 
				set_field_error('ftp_port_num','[ WARNING ]\nThe Port # field must be a number between 1 and 65535.'); error_count++; 
			}
		}

		// trim the default dir field
		t = document.getElementById('ftp_default_dir');
		val = t.value = trim(t.value);

		return error_count;
	}
	// ==========================================================================
	// ||||||||||||||||||||||||| EVENT HANDLER FUNCTIONS ||||||||||||||||||||||||
	// ==========================================================================
	// this function pops up an confirm box ensuring that the usesr wishes to
	// delete a publish point. If so, we redirect to ourselves and pass along
	// the proper page action and publish point id to trigger the deletion
	function delete_pub_point_onmouseup(_pub_point_id){
		if(confirm('Are you sure you wish to permanently delete this Publish Point?')){
			var redir_url = 'system_pub_points.php?page_action=delete_pub_point&publish_point_id='+_pub_point_id;
			document.location = redir_url;
		}
	}
	// ---------------------------------------------------------------------------
	function save_pub_point_onmouseup(){
		is_busy = 1;
		var f = document.forms['system_pub_point_form'];
		var ret_val = false;

		// hide any errors that might already be displayed
		clear_all_errors();

		// see if the form contains error and display them
		if(validate_pub_point_form() == 0){
			f['page_action'].value = 'save_pub_point';
			// if no errors found, we submit our form
			setTimeout('document.forms["system_pub_point_form"].submit();',10);
			ret_val = true;
		}
		else{ is_busy = 0; }
		return ret_val;
	}
	// --------------------------------------------------------------------------
	// this event handler first validates the publish point connections fields.
	// If everything checks out, then a popup window is created and the form
	// fields are passed to it via a query string that we construct
	function test_conn_onmouseup(){
		var f = document.forms['system_pub_point_form'];
		var win_url = '';
		var i;
		var test_win;
		var cFeatures;

		// hide any errors that might already be displayed
		clear_all_errors();

		// see if the form contains error and display them
		if(validate_pub_point_form() == 0){
			// create the popup window url with the necessary query string
			win_url = 'popup_test_pp_conn.php';
			win_url += '?ftp_server_name=' + urlencode(f['ftp_server_name'].value);
			win_url += '&ftp_username=' + urlencode(f['ftp_user_name'].value);
			win_url += '&ftp_password=' + urlencode(f['ftp_user_password'].value);
			win_url += '&ftp_port_num=' + urlencode(f['ftp_port_num'].value);
			win_url += '&ftp_default_dir=' + urlencode(f['ftp_default_dir'].value);
			win_url += '&ftp_passive_mode=' + (f['ftp_is_passive'][0].selected ? 0 : 1);

			cFeatures = 
				'width=320,' +
				'height=200,' +
				'scrollbars=no,' +
				'resizable=yes,' +
				'location=no,' +
				'menubar=no,' +
				'status=no,' +
				'titlebar=no,' +
				'toolbar=no';

			// open the connection testing popup window
			test_win = window.self.open(win_url, 'test_win', cFeatures);
		}
	}
	// --------------------------------------------------------------------------
