	// ==========================================================================
	// ||||||||||||||||||||||||| GLOBAL VARIABLES |||||||||||||||||||||||||||||||
	// ==========================================================================
	var is_busy 			= 0; // prevent event functions from being called before other critical events are finished

	// prepare all of the page's rollover graphics
	if(document.images){
		var bttn_save_off = new Image(); bttn_save_off.src = './images/global/button/bttn_save_off.gif';
		var bttn_save_on = new Image(); bttn_save_on.src = './images/global/button/bttn_save_on.gif';
		var bttn_cancel_off = new Image(); bttn_cancel_off.src = './images/global/button/bttn_cancel_off.gif';
		var bttn_cancel_on = new Image(); bttn_cancel_on.src = './images/global/button/bttn_cancel_on.gif';
		var bttn_create_new_user_off = new Image(); bttn_create_new_user_off.src = './images/system/button/bttn_create_new_user_off.gif';
		var bttn_create_new_user_on = new Image(); bttn_create_new_user_on.src = './images/system/button/bttn_create_new_user_on.gif';

		var icon_pencil_off = new Image(); icon_pencil_off.src = './images/global/icon/icon_pencil_off.gif';
		var icon_pencil_on = new Image(); icon_pencil_on.src = './images/global/icon/icon_pencil_on.gif';
		var icon_trash_can_off = new Image(); icon_trash_can_off.src = './images/global/icon/icon_trash_can_off.gif';
		var icon_trash_can_on = new Image(); icon_trash_can_on.src = './images/global/icon/icon_trash_can_on.gif';
		var icon_field_error_off = new Image(); icon_field_error_off.src = './images/global/icon/icon_field_error_off.gif';
		var icon_field_error_on = new Image(); icon_field_error_on.src = './images/global/icon/icon_field_error_on.gif';
		var icon_field_error_none = new Image(); icon_field_error_none.src = './images/global/other/other_clear_spacer.gif';
	}
	// ==========================================================================
	// ||||||||||||||||||||||||| HELPER FUNCTIONS |||||||||||||||||||||||||||||||
	// ==========================================================================
	// this function turns off all errors on the login page
	function clear_all_errors(){
		var field_label_array = new Array('mgt_user_id','mgt_user_name','mgt_full_name','mgt_user_password','mgt_user_password2','mgt_email_address');
		for(var i in field_label_array){ clear_field_error(field_label_array[i]); }
	}
	// --------------------------------------------------------------------------
	// this function looks at the data stored in the user form. This function
	// returns the number of invalid data fields found and marks these areas as invalid
	function validate_users_form(){
		var error_count = 0;
		var s,t, val;
		var regex1, regex2 = '';

		// check the user name
		t = document.getElementById('mgt_user_name');
		val = t.value;
		if(val.length == 0){ set_field_error('mgt_user_name','[ WARNING ]\nThe User Name field cannot be empty.'); error_count++; }
		else if(val.length < 3){ set_field_error('mgt_user_name','[ WARNING ]\nThe User Name field must be at least 3 characters long.'); error_count++; }
		else{
			regex1 = /^[a-zA-Z0-9_]+$/;
			if(!regex1.test(val)){ set_field_error('mgt_user_name','[ WARNING ]\nThe User Name field contains invalid characters.\nPlease use letters, numbers, and underscores only.'); error_count++; }
		}

		// check the full name
		t = document.getElementById('mgt_full_name');
		val = t.value = trim(t.value);
		if(val.length == 0){ set_field_error('mgt_full_name','[ WARNING ]\nThe Full Name field cannot be empty.'); error_count++; }

		// check the email address 
		t = document.getElementById('mgt_email_address');
		val = t.value = trim(t.value);
		if(val.length == 0){ set_field_error('mgt_email_address','[ WARNING ]\nThe Email Address field cannot be empty.'); error_count++; }
		else{
			regex1 = /(@.*@)|(\.\.)|(@\.)|(\.@)|(^\.)/; // not valid
			regex2 = /^.+\@(\[?)[a-zA-Z0-9\-\.]+\.([a-zA-Z]{2,3}|[0-9]{1,3})(\]?)$/; // valid
			if(!(!regex1.test(val) && regex2.test(val))) { // if syntax is not valid
				set_field_error('mgt_email_address','[ WARNING ]\nThe Email Address is not in a valid format.'); error_count++;
			}
		}

		t = document.getElementById('mgt_user_password');
		s = document.getElementById('mgt_user_password2');

		// check the passwords are blank
		if(t.value.length == 0){ set_field_error('mgt_user_password','[ WARNING ]\nThe Password field cannot be empty.'); error_count++; }
		if(s.value.length == 0){ set_field_error('mgt_user_password2','[ WARNING ]\nThe Retype Password field cannot be empty.'); error_count++; }

		// the passwords should be at least 4 characters long
		if(t.value.length > 0 && t.value.length < 4){ set_field_error('mgt_user_password','[ WARNING ]\nThe Password field must be at least 4 characters long.'); error_count++; }
		if(s.value.length > 0 && s.value.length < 4){ set_field_error('mgt_user_password2','[ WARNING ]\nThe Retype Password field must be at least 4 characters long.'); error_count++; }

		// make sure the two passwords match
		if(t.value.length > 0 && s.value.length > 0 && t.value != s.value){
			set_field_error('mgt_user_password2','[ WARNING ]\nThe Retype Password field does not match the Password field.\nPlease make sure you\'ve typed the password correctly.'); error_count++;
		}

		// make sure the passwords contain valid characters
		regex1 = /^[a-zA-Z0-9_]+$/;
		if(t.value.length > 0 && !regex1.test(t.value)){
			set_field_error('mgt_user_password','[ WARNING ]\nThe Password field contains invalid characters.\nPlease use letters, numbers, and underscores only.'); error_count++;
		}
		if(s.value.length > 0 && !regex1.test(s.value)){
			set_field_error('mgt_user_password2','[ WARNING ]\nThe Retype Password field contains invalid characters.\nPlease use letters, numbers, and underscores only.'); error_count++;
		}

		return error_count;
	}
	// ==========================================================================
	// ||||||||||||||||||||||||| EVENT HANDLER FUNCTIONS ||||||||||||||||||||||||
	// ==========================================================================
	// this function pops up a confirm box ensuring that the usesr wishes to
	// delete a user. If so, we redirect to ourselves and pass along
	// the proper page action and user id to trigger the deletion
	function delete_user_onmouseup(_user_id){
		if(confirm('Are you sure you wish to permanently delete this User?')){
			var redir_url = 'system_user_management.php?page_action=delete_user&mgt_user_id='+_user_id;
			document.location = redir_url;
		}
	}
	// ---------------------------------------------------------------------------
	function save_user_onmouseup(){
		is_busy = 1;
		var f = document.forms['system_users_form'];
		var ret_val = false;

		// hide any errors that might already be displayed
		clear_all_errors();

		// see if the form contains error and display them
		if(validate_users_form() == 0){
			f['page_action'].value = 'save_user';
			// if no errors found, we submit our form
			setTimeout('document.forms["system_users_form"].submit();',10);
			ret_val = true;
		}
		else{ is_busy = 0; }
		return ret_val;
	}
	// --------------------------------------------------------------------------
