<?php
	require_once('./pear/DB.php');
	include_once('./settings/settings.php');
	include_once('./include/globals.php');
	include_once('./include/loader.php');
	include_once('./include/login_functions.php');
	// make sure the user has logged in before accessing this page
	if(($user_struct = get_login_status()) === FALSE){ header("Location: login.php"); exit(0); }

	include_once('./include/functions.php');
	include_once('./include/ftp_functions.php');

	// define some template specific variables
	$PAGE_TITLE = "";
	include_once('./include/popup_header.php'); 

	// we only pass around the publish point id, so that the ftp server's
	// sensitive login info isn't travelling over the network
	$publish_point_id = isset($_REQUEST['publish_point_id']) ? $_REQUEST['publish_point_id'] : '';

	// make sure all variables that may be passed in get declared
	$curr_path = isset($_REQUEST['curr_path']) ? $_REQUEST['curr_path'] : '';
	$append_path = isset($_REQUEST['append_path']) ? $_REQUEST['append_path'] : '';
	$page_action = isset($_REQUEST['page_action']) ? $_REQUEST['page_action'] : '';
	$filename = isset($_REQUEST['filename']) ? $_REQUEST['filename'] : '';

	// place to store our error messages
	$error_log = Array();
?>
<!-- MAIN PAGE CONTENT [start] -->				
<style type='text/css'>
	.l_ftp_error {
		font: normal normal bold 10px Verdana,Tahoma,Arial,Helvetica,Sans-serif,sans-serif;
		line-height: 12px;
		color: #ff0000;
		padding: 8px;
		background-color: #ffffff;
	}
	.l_folder_div {
		width: 310px;
		height: 20px;
		white-space: nowrap;
		background-repeat: no-repeat;
		background-position: 12px 4px;
		overflow: hidden;
		text-overflow: ellipsis;
	}
	.l_folder_up_icon {
		background-image: url(./images/global/icon/icon_folder_up_off.gif);
	}
	.l_folder_icon {
		background-image: url(./images/global/icon/icon_folder_off.gif);
	}
	.l_symlink_icon {
		background-image: url(./images/global/icon/icon_symlink_off.gif);
	}
	.l_folder_link {
		width: 100%;
		font: normal normal bold 9px Verdana,Tahoma,Arial,Helvetica,Sans-serif,sans-serif;
		line-height: 20px;
		color: #000000;
		text-decoration: none;
		padding: 0px 0px 0px 30px;
	}
	.l_folder_link:hover {
		width: 100%;
		font: normal normal bold 9px Verdana,Tahoma,Arial,Helvetica,Sans-serif,sans-serif;
		line-height: 20px;
		color: #000000;
		text-decoration: underline;
		padding: 0px 0px 0px 30px;
	}
	.l_file_div {
		width: 100%;
		height: 20px;
		background-image: url(./images/global/icon/icon_generic_file_off.gif);
		background-repeat: no-repeat;
		background-position: 12px 4px;
	}
	.l_file_link {
		width: 100%;
		font: normal normal normal 9px Verdana,Tahoma,Arial,Helvetica,Sans-serif,sans-serif;
		line-height: 20px;
		color: #000000;
		text-decoration: none;
		padding: 0px 0px 0px 26px;
	}
	.l_file_link:hover {
		width: 100%;
		font: normal normal normal 9px Verdana,Tahoma,Arial,Helvetica,Sans-serif,sans-serif;
		line-height: 20px;
		color: #297181;
		text-decoration: underline;
		padding: 0px 0px 0px 26px;
	}
</style>
<script language='JavaScript' src='./js/page_specific/pub_point_file_list.js' ></script>

<table width='100%' height='100%' cellspacing='0' cellpadding='0' border='0' bgcolor='#cfe1e5'>
<tr>
	<td width='100%' height='100%' align='left' valign='top'>
	<form name='file_browser_form' id='file_browser_form' method='POST' action='<?php echo $_SERVER['PHP_SELF']; ?>'>
<?php
	// try to get the details about the publish point
	$pub_point_struct = get_pub_point_struct($publish_point_id);
	if($pub_point_struct !== FALSE){

		// load it's data into our variables
		$ftp_server_name 	= $pub_point_struct['server_name'];
		$ftp_username 		= $pub_point_struct['user_name'];
		$ftp_password 		= $pub_point_struct['password'];
		$ftp_port_num 		= $pub_point_struct['port_num'];
		$ftp_passive_mode 	= $pub_point_struct['is_passive'];
		$ftp_default_dir	= $pub_point_struct['default_dir'];

		$ftp_handle = get_ftp_connection($ftp_server_name, $ftp_username, $ftp_password, $ftp_port_num, $ftp_passive_mode);

		// if we couldn't connect, display the error message(s)
		if(is_array($ftp_handle)){
			foreach($ftp_handle as $idx => $error_msg){ echo "<div class='l_ftp_error'><li>${error_msg}<br></li></div>\n"; }
		}
		// attempt to read the contents of the directory
		else{

			// if no page action has been given, assume this is the first load,
			// so set the default directory
			if($page_action == ''){
				$curr_path = "/".trim_dir_slashes($ftp_default_dir);
			}
			// the user has requested a directory change, so do it
			if($page_action == 'chdir'){
				// try to go up to the parent directory
				if($append_path == '..'){
					$curr_path = get_parent_path($curr_path);
				}
				// some symlinks might point to the root directory
				elseif($append_path == "/"){
					$curr_path = "/";
				}
				// otherwise append the new directory level
				elseif(strlen($append_path) > 0 && $append_path != '.'){
					$seperator = ($curr_path == "/") ? "" : "/";
					$curr_path = "${curr_path}${seperator}${append_path}";
				}
			} // end if

			// get the system type in case we need it
			$ftp_system_type = get_ftp_system_type($ftp_handle);

			$ftp_list_results = get_ftp_list($ftp_handle, $curr_path);

			// close the ftp connection
			@ftp_close($ftp_handle);

			// get the actual directory we're browsing
			$ftp_default_dir = $ftp_list_results['ftp_directory'];

			// only update our current path name if it's actually different from what was supplied
			if($curr_path != $ftp_default_dir){ $curr_path = $ftp_default_dir; }

			// get the contents of the dir listing
			$ftp_dirs = $ftp_list_results['ftp_dirs'];
			$ftp_files = $ftp_list_results['ftp_files'];
			$ftp_symlinks = $ftp_list_results['ftp_symlinks'];

			// get a list of valid file extensions
			$valid_file_extensions = get_valid_file_extensions();

			$entry_rgb = Array('#e2edef','#ffffff');
			$rgb_idx = 0;

			// display directory up link
			echo "<div class='l_folder_div l_folder_up_icon' style='background-color: ".$entry_rgb[$rgb_idx].";'><a onmouseup='directory_onmouseup(\"..\");' href='javascript:void(0);' class='l_folder_link'>..</a></div>\n";
			$rgb_idx = ($rgb_idx == count($entry_rgb)-1 ) ? 0 : ++$rgb_idx;

			// generate the html for the directories
			foreach($ftp_dirs as $idx => $rawlist_struct){
				echo "<div class='l_folder_div l_folder_icon' style='background-color: ".$entry_rgb[$rgb_idx].";'><a onmouseup='directory_onmouseup(\"".to_html_attrib_str($rawlist_struct['name'])."\");' href='javascript:void(0);' class='l_folder_link'>".$rawlist_struct['name']."</a></div>\n";
				$rgb_idx = ($rgb_idx == count($entry_rgb)-1 ) ? 0 : ++$rgb_idx;
			}
			// generate the html for the symlinks 
			foreach($ftp_symlinks as $idx => $rawlist_struct){
				$symlink_struct = parse_symlink_name($rawlist_struct['name']);
				echo "<div class='l_folder_div l_symlink_icon' style='background-color: ".$entry_rgb[$rgb_idx].";'><a onmouseup='directory_onmouseup(\"".to_html_attrib_str(trim_dir_slashes($symlink_struct['symlink_real_path']))."\");' href='javascript:void(0);' class='l_folder_link'>".$rawlist_struct['name']."</a></div>\n";
				$rgb_idx = ($rgb_idx == count($entry_rgb)-1 ) ? 0 : ++$rgb_idx;
			}
			// generate the html for the files
			$seperator = ($curr_path == "/") ? "" : "/";
			foreach($ftp_files as $idx => $rawlist_struct){
				// if the file has a valid file extension, display it
				$file_ext = get_filename_extension($rawlist_struct['name']);
				if((count($valid_file_extensions) == 0) || (count($valid_file_extensions) > 0 && in_array($file_ext, $valid_file_extensions))){
					// construct the remote filename
					$remote_file = "${curr_path}${seperator}".$rawlist_struct['name'];
					echo "<div class='l_file_div'><a onmouseup='file_onmouseup($publish_point_id, \"".to_html_attrib_str(to_js_str($remote_file))."\");' href='javascript:void(0);' class='l_file_link'>".$rawlist_struct['name']."</a></div>\n";
				}
			} 
		} // end else
	} // end if

	// pass our data back to ourselves with hidden fields
	echo "
		<input type='hidden' name='publish_point_id' value='${publish_point_id}'>
		<input type='hidden' name='curr_path' value='".to_html_attrib_str($curr_path)."'>
		<input type='hidden' name='append_path' value=''>
		<input type='hidden' name='filename' value=''>
		<input type='hidden' name='page_action' value=''>
	";
?>
	</form>
	</td>
</tr>
</table>
<!-- MAIN PAGE CONTENT [end] -->				
<?php include_once('./include/popup_footer.php'); ?>

<script language='JavaScript'>
<!--
	// try to turn off the busy bar animation
	if(top.window && top.window.stop_busy_animation){ top.window.stop_busy_animation(); }
//-->
</script>
