<?php 
	require_once('./pear/DB.php');
	include_once('./settings/settings.php');
	include_once('./include/globals.php');
	include_once('./include/loader.php');
	include_once('./include/login_functions.php');
	// make sure the user has logged in before accessing this page
	if(($user_struct = get_login_status()) === FALSE){ header("Location: login.php"); exit(0); }

	include_once('./include/functions.php');

	$page_action = isset($_REQUEST['page_action']) ? $_REQUEST['page_action'] : '';
	$survey_id = isset($_REQUEST['survey_id']) ? $_REQUEST['survey_id'] : '';

	// perform state specific actions
	// clone a survey
	if($page_action == 'clone_survey'){
		$cloned_survey_name = "";
		// clone the survey
		$cloned_survey_id = clone_survey($survey_id);
		if($cloned_survey_id !== FALSE){
			// if the survey was successfully cloned, get it's new name
			$survey_struct = get_survey_data_struct($cloned_survey_id);
			if(isset($survey_struct['survey_name'])){
				$cloned_survey_name = $survey_struct['survey_name'];
			}
		} // end if
	} // end if
	// delete a survey
	if($page_action == 'delete_survey'){
		delete_survey($survey_id);
	} // end if

	$active_tab_idx = isset($_GET['active_tab_idx']) ? $_GET['active_tab_idx'] : '';
	// if we still don't have the tab index, default it to 0
	if(strlen($active_tab_idx) == 0 || !is_numeric($active_tab_idx) || $active_tab_idx < 0 || $active_tab_idx > 3){ $active_tab_idx = 0; }

	$active_tab_rgb_map = Array('#cce1f2','#f3f1cf','#d0eeca','#f3d0cd');
	$active_tab_rgb = $active_tab_rgb_map[$active_tab_idx];

	// see how many survey's fall under each tab category
	$num_survey_drafts = get_survey_drafts_count();
	$num_survey_waiting = get_survey_waiting_count();
	$num_survey_running = get_survey_running_count();
	$num_survey_completed = get_survey_completed_count();

	// set the pagination data
	$page_count = 0;
	$item_count = 0;
	$items_per_page = 6;

	// define some template specific variables
	$PAGE_TITLE = "Webupdate | eSurvey 2.0 :: Survey List";
	$PAGE_HEADER_TEXT = "SURVEY LIST";
	include_once('./include/header.php'); 
	include_once('./include/section_header.php'); 
?>
<!-- MAIN PAGE CONTENT [start] -->				
					<style type='text/css'>
					<!--
						.l_tab_label{
							font: normal normal normal 9px Verdana,Tahoma,Arial,Helvetica,Sans-serif,sans-serif;
							color: #4f5161;
							line-height: 11px;
							text-decoration: none;
						}
						.l_tab_label:hover {
							font: normal normal normal 9px Verdana,Tahoma,Arial,Helvetica,Sans-serif,sans-serif;
							color: #4f5161;
							line-height: 11px;
							text-decoration: underline;
						}
						.l_paging_link {
							font: normal normal bold 9px Verdana,Tahoma,Arial,Helvetica,Sans-serif,sans-serif;
							color: #4f5161;
							line-height: 11px;
							text-decoration: none;
							padding: 0px 2px 0px 2px;
						}
						.l_paging_link:hover {
							font: normal normal bold 9px Verdana,Tahoma,Arial,Helvetica,Sans-serif,sans-serif;
							color: #000000;
							line-height: 11px;
							text-decoration: none;
							padding: 0px 2px 0px 2px;
						}
						.l_table_header_link {
							font: normal normal normal 9px Verdana,Tahoma,Arial,Helvetica,Sans-serif,sans-serif;
							color: #ffffff;
							line-height: 11px;
							text-decoration: none;
						}
						.l_table_header_link:hover {
							font: normal normal normal 9px Verdana,Tahoma,Arial,Helvetica,Sans-serif,sans-serif;
							color: #ffffff;
							line-height: 11px;
							text-decoration: underline;
						}
						.l_table_data {
							font: normal normal normal 9px Verdana,Tahoma,Arial,Helvetica,Sans-serif,sans-serif;
							color: #000000;
							line-height: 11px;
							padding: 0px 0px 0px 5px;
							cursor: default;
							overflow: hidden;
							text-overflow: ellipsis;
						}
					-->
					</style>
					<script language='JavaScript' src='./js/utils.js'></script>
					<script language='JavaScript' src='./js/page_specific/survey_list.js'></script>
					<script language='JavaScript'>
					<!--
<?php
						// store the url encoded version of the currently active
						// page so that process modules will know where to return to
						echo "var curr_url = \"".to_js_str(urlencode(get_curr_url()))."\";\n";

						echo "var items_per_page = $items_per_page;\n";
						echo "var survey_tab = $active_tab_idx;\n";

						// based on the active tab index, select the approprate surveys from the database
						switch($active_tab_idx){
							case 0: $query = 'SELECT * FROM esy_surveys WHERE is_draft = 1 AND rec_status_id = 1;'; break; // Draft Surveys
							case 1: $query = 'SELECT * FROM esy_surveys WHERE is_draft = 0 AND start_timestamp > '.time().' AND rec_status_id = 1;'; break; // Awaiting Launch
							case 2: $query = 'SELECT * FROM esy_surveys WHERE is_draft = 0 AND start_timestamp < '.time().' AND end_timestamp > '.time().' AND rec_status_id = 1;'; break; // Currently Running
							case 3: $query = 'SELECT * FROM esy_surveys WHERE is_draft = 0 AND end_timestamp < '.time().' AND rec_status_id = 1;'; break; // Completed Surveys
						}

						// transfer the data from the database into our javascript objects for display/sorting, etc.
						$db_result = $DBH->query($query);
						if(!DB::isError($db_result)){ 
							$item_count = $db_result->numRows();
							$page_count = ceil($item_count / $items_per_page);
							echo "item_count = $item_count;\n";
							echo "page_count = $page_count;\n";
							while($db_row = $db_result->fetchRow()){
								// extract each column as it's own variable and formatted as a JS string
								foreach($db_row as $key => $val){ $$key = to_js_str($val); }
								echo 'survey_db.push(new Survey_Summary('.$survey_id.',"'.$survey_name.'",'.$start_timestamp.','.$end_timestamp.','.get_response_count($survey_id).'));'."\n";
							}
						}
?>
					//-->
					</script>
					<center>
					<table cellspacing='0' cellpadding='0' border='0'>
					<tr>
						<td width='696' height='29' align='right' valign='bottom'>
							<a href='edit_survey.php'><img onmouseover='this.src=bttn_add_new_survey_on.src;' onmouseout='this.src=bttn_add_new_survey_off.src;' width='85' height='19' src='./images/main/button/bttn_add_new_survey_off.gif' alt='Add New Survey' title='Add New Survey' hspace='0' vspace='2' border='0'></a><br>
						</td>
					</tr>
					<tr>
						<td width='696' align='center' valign='top' background='./images/main/other/other_grey_section_bg.gif'>
							<img width='1' height='11' src='./images/global/other/other_clear_spacer.gif' hspace='0' vspace='0' border='0'><br>
							<!-- ACTIVITY HEADER [start] -->
							<table cellspacing='0' cellpadding='0' border='0'>
							<tr>
								<td colspan='2' height='1' bgcolor='#9596a0'><img width='1' height='1' src='./images/global/other/other_clear_spacer.gif' hspace='0' vspace='0' border='0'><br></td>
								<td colspan='2' height='1' bgcolor='#7b7c88'><img width='1' height='1' src='./images/global/other/other_clear_spacer.gif' hspace='0' vspace='0' border='0'><br></td>
							</tr>
							<tr>
								<td width='1' height='17' bgcolor='#9596a0'><img width='1' height='1' src='./images/global/other/other_clear_spacer.gif' hspace='0' vspace='0' border='0'><br></td>
								<td width='167' height='17' bgcolor='#eeeeef' align='center' valign='middle' class='g_form_static_value'><b>INACTIVE</b><br></td>
								<td width='506' height='17' bgcolor='#d3d4d8' align='center' valign='middle' class='g_form_static_value'><b>ACTIVE</b><br></td>
								<td width='1' height='17' bgcolor='#9596a0'><img width='1' height='1' src='./images/global/other/other_clear_spacer.gif' hspace='0' vspace='0' border='0'><br></td>
							</tr>
							<tr>
								<td colspan='2' height='1' bgcolor='#9596a0'><img width='1' height='1' src='./images/global/other/other_clear_spacer.gif' hspace='0' vspace='0' border='0'><br></td>
								<td colspan='2' height='1' bgcolor='#7b7c88'><img width='1' height='1' src='./images/global/other/other_clear_spacer.gif' hspace='0' vspace='0' border='0'><br></td>
							</tr>
							</table>
							<!-- ACTIVITY HEADER [end] -->
							<img width='1' height='12' src='./images/global/other/other_clear_spacer.gif' hspace='0' vspace='0' border='0'><br>
							<!-- SECTION TABS [start] -->
							<table cellspacing='0' cellpadding='0' border='0'>
							<tr>
								<td width='166' height='30' align='center' valign='middle' background='./images/main/other/other_tab_light_side_bg_<?php echo ($active_tab_idx == 0) ? 'on' : 'off'; ?>.gif' bgcolor='#cce1f2'><a href='survey_list.php?active_tab_idx=0' class='l_tab_label'>DRAFTS (<?php echo $num_survey_drafts; ?>)</a><br></td>
								<td width='4' height='30'><img width='4' height='30' src='./images/main/other/other_tab_divider.gif' hspace='0' vspace='0' border='0'><br></td>
								<td width='166' height='30' align='center' valign='middle' background='./images/main/other/other_tab_dark_side_bg_<?php echo ($active_tab_idx == 1) ? 'on' : 'off'; ?>.gif' bgcolor='#f3f1cf'><a href='survey_list.php?active_tab_idx=1' class='l_tab_label'>WAITING (<?php echo $num_survey_waiting; ?>)</a><br></td>
								<td width='4' height='30'><img width='4' height='30' src='./images/main/other/other_tab_divider.gif' hspace='0' vspace='0' border='0'><br></td>
								<td width='166' height='30' align='center' valign='middle' background='./images/main/other/other_tab_dark_side_bg_<?php echo ($active_tab_idx == 2) ? 'on' : 'off'; ?>.gif' bgcolor='#d0eeca'><a href='survey_list.php?active_tab_idx=2' class='l_tab_label'>RUNNING (<?php echo $num_survey_running; ?>)</a><br></td>
								<td width='4' height='30'><img width='4' height='30' src='./images/main/other/other_tab_divider.gif' hspace='0' vspace='0' border='0'><br></td>
								<td width='166' height='30' align='center' valign='middle' background='./images/main/other/other_tab_dark_side_bg_<?php echo ($active_tab_idx == 3) ? 'on' : 'off'; ?>.gif' bgcolor='#f3d0cd'><a href='survey_list.php?active_tab_idx=3' class='l_tab_label'>COMPLETED (<?php echo $num_survey_completed; ?>)</a><br></td>
							</tr>
							</table>
							<table cellspacing='0' cellpadding='0' border='0'>
							<tr>
								<td width='1' bgcolor='#4f5161'><img width='1' height='1' src='./images/global/other/other_clear_spacer.gif' hspace='0' vspace='0' border='0'><br></td>
								<td width='674' align='center' valign='top' bgcolor='<?php echo $active_tab_rgb; ?>'>
									<!-- PAGINATION NAV [start] -->
									<table cellspacing='0' cellpadding='0' border='0'>
									<tr>
										<td width='660' height='22' align='right' valign='middle' class='l_page_link'>
											<div <?php echo ($page_count <= 1) ? "style='display:none;'" : ''; ?>>
												<a href='JavaScript:void(0);' onmouseup='adjacent_page_onmouseup(-1); this.blur();' class='l_paging_link'>&lt; back</a>
<?php
	// output the pagination links. may be hidden if there's one or fewer pages
	for($i = 0; $i < $page_count; $i++){
		echo "<a id='page_link_$i' href='JavaScript:void(0);' onmouseup='goto_page_onmouseup($i); this.blur();' class='l_paging_link'>".($i+1)."</a>";
	}
?>
												<a href='JavaScript:void(0);' onmouseup='adjacent_page_onmouseup(1); this.blur();' class='l_paging_link'>next &gt;</a><br>
											</div>
										</td>
									</tr>
									</table>
									<!-- PAGINATION NAV [end] -->
									<table cellspacing='2' cellpadding='0' border='0'>
									<!-- SURVEY LIST TABLE HEADER [start] -->
									<tr>
										<td width='180' height='25' align='center' valign='middle' bgcolor='#4f5161'>
											<table cellspacing='0' cellpadding='0' border='0'>
											<tr>
												<td valign='middle'><a href='JavaScript:void(0);' onmouseup='sort_col_onmouseup(0); this.blur();' class='l_table_header_link'>Survey Name</a><br></td>
												<td valign='middle'><img id='sort_arrow_img_0' width='11' height='10' src='./images/global/other/other_clear_spacer.gif' hspace='2' vspace='0' border='0'><br></td>
											</tr>
											</table>
										</td>
										<td width='131' height='25' align='center' valign='middle' bgcolor='#4f5161'>
											<table cellspacing='0' cellpadding='0' border='0'>
											<tr>
												<td valign='middle'><a href='JavaScript:void(0);' onmouseup='sort_col_onmouseup(1); this.blur();' class='l_table_header_link'>Start Date / Time</a><br></td>
												<td valign='middle'><img id='sort_arrow_img_1' width='11' height='10' src='./images/global/other/other_clear_spacer.gif' hspace='2' vspace='0' border='0'><br></td>
											</tr>
											</table>
										</td>
										<td width='130' height='25' align='center' valign='middle' bgcolor='#4f5161'>
											<table cellspacing='0' cellpadding='0' border='0'>
											<tr>
												<td valign='middle'><a href='JavaScript:void(0);' onmouseup='sort_col_onmouseup(2); this.blur();' class='l_table_header_link'>End Date / Time</a><br></td>
												<td valign='middle'><img id='sort_arrow_img_2' width='11' height='10' src='./images/global/other/other_clear_spacer.gif' hspace='2' vspace='0' border='0'><br></td>
											</tr>
											</table>
										</td>
										<td width='81' height='25' align='center' valign='middle' bgcolor='#4f5161'>
											<table cellspacing='0' cellpadding='0' border='0'>
											<tr>
												<td valign='middle'><a href='JavaScript:void(0);' onmouseup='sort_col_onmouseup(3); this.blur();' class='l_table_header_link'>Responses</a><br></td>
												<td valign='middle'><img id='sort_arrow_img_3' width='11' height='10' src='./images/global/other/other_clear_spacer.gif' hspace='2' vspace='0' border='0'><br></td>
											</tr>
											</table>
										</td>
										<td width='130' height='25' align='center' valign='middle' bgcolor='#4f5161'><span class='l_table_header_link'>Action</span><br></td>
									</tr>
									<!-- SURVEY LIST TABLE HEADER [end] -->
<?php 
	// select the appropriate color scheme for the survey summary
	switch($active_tab_idx){
		case 0: $rgb_map = Array('#ffffff','#f0f6fb'); break;
		case 1: $rgb_map = Array('#ffffff','#fbfbf1'); break;
		case 2: $rgb_map = Array('#ffffff','#f1faef'); break;
		case 3: $rgb_map = Array('#ffffff','#fbf1f0'); break;
		default: $rgb_map = Array('#ffffff','#f0f6fb'); break;
	}
	
	$rgb_idx = 0;
	for($i = 0; $i < 6; $i++){
		$row_rgb = $rgb_map[$rgb_idx];

		$insert_icon = '';
		// insertion is not allowed on completed surveys, so disable the icon
		if($active_tab_idx == 3){ $insert_icon = "<img width='17' height='17' src='./images/global/icon/icon_thumb_tac_null.gif' alt='Insert' title='Insert' hspace='0' vspace='0' border='0'>"; }
		else{ $insert_icon = "<a href='JavaScript:void(0);' onmouseup='insert_survey_onmouseup($i); this.blur();'><img onmouseover='this.src=icon_thumb_tac_on.src;' onmouseout='this.src=icon_thumb_tac_off.src;' width='17' height='17' src='./images/global/icon/icon_thumb_tac_off.gif' alt='Insert' title='Insert' hspace='0' vspace='0' border='0'></a>"; }

		echo "
									<tr>
										<td width='180' height='30' align='left' valign='middle' bgcolor='$row_rgb'><div id='survey_name_div_$i' nowrap class='l_table_data' style='width:180px;'></div></td>
										<td width='131' height='30' align='center' valign='middle' bgcolor='$row_rgb'><div id='start_time_div_$i' nowrap class='l_table_data' style='width:131px;'></div></td>
										<td width='130' height='30' align='center' valign='middle' bgcolor='$row_rgb'><div id='end_time_div_$i' nowrap class='l_table_data' style='width:130px;'></div></td>
										<td width='81' height='30' align='center' valign='middle' bgcolor='$row_rgb'><div id='responses_div_$i' nowrap class='l_table_data' style='width:81px;'></div></td>
										<td width='130' height='30' align='center' valign='middle' bgcolor='$row_rgb'>
											<div id='icons_div_$i' nowrap class='l_table_data' style='width:130px;'>
												<a href='JavaScript:void(0);' onmouseup='edit_survey_onmouseup($i); this.blur();'><img onmouseover='this.src=icon_pencil_on.src;' onmouseout='this.src=icon_pencil_off.src;' width='17' height='17' src='./images/global/icon/icon_pencil_off.gif' alt='Edit' title='Edit' hspace='0' vspace='0' border='0'></a>
												<a href='JavaScript:void(0);' onmouseup='preview_survey_onmouseup($i); this.blur();'><img onmouseover='this.src=icon_magnifying_glass_on.src;' onmouseout='this.src=icon_magnifying_glass_off.src;' width='17' height='17' src='./images/global/icon/icon_magnifying_glass_off.gif' alt='Preview' title='Preview' hspace='0' vspace='0' border='0'></a>
												<a href='JavaScript:void(0);' onmouseup='delete_survey_onmouseup($i); this.blur();'><img onmouseover='this.src=icon_trash_can_on.src;' onmouseout='this.src=icon_trash_can_off.src;' width='17' height='17' src='./images/global/icon/icon_trash_can_off.gif' alt='Delete' title='Delete' hspace='0' vspace='0' border='0'></a>
												$insert_icon
												<a href='JavaScript:void(0);' onmouseup='clone_survey_onmouseup($i); this.blur();'><img onmouseover='this.src=icon_clone_papers_on.src;' onmouseout='this.src=icon_clone_papers_off.src;' width='17' height='17' src='./images/global/icon/icon_clone_papers_off.gif' alt='Clone Survey' title='Clone Survey' hspace='0' vspace='0' border='0'></a>
												<a href='JavaScript:void(0);' onmouseup='view_report_onmouseup($i); this.blur();'><img onmouseover='this.src=icon_vert_bar_graph_on.src;' onmouseout='this.src=icon_vert_bar_graph_off.src;' width='17' height='17' src='./images/global/icon/icon_vert_bar_graph_off.gif' alt='Reports' title='Reports' hspace='0' vspace='0' border='0'></a>
											</div>
										</td>
									</tr>
		";
		$rgb_idx = ($rgb_idx == (count($rgb_map)-1)) ? 0 : ($rgb_idx+1);
	}
?>
									</table>
									<img width='1' height='5' src='./images/global/other/other_clear_spacer.gif' hspace='0' vspace='0' border='0'><br>
								</td>
								<td width='1' bgcolor='#4f5161'><img width='1' height='1' src='./images/global/other/other_clear_spacer.gif' hspace='0' vspace='0' border='0'><br></td>
							</tr>
							<tr>
								<td colspan='3' height='1' bgcolor='#4f5161'><img width='1' height='1' src='./images/global/other/other_clear_spacer.gif' hspace='0' vspace='0' border='0'><br></td>
							</tr>
							</table>
							<img width='1' height='10' src='./images/global/other/other_clear_spacer.gif' hspace='0' vspace='0' border='0'><br>
							<!-- SECTION TABS [end] -->
						</td>
					</tr>
					</table>
					<img width='1' height='48' src='./images/global/other/other_clear_spacer.gif' hspace='0' vspace='0' border='0'><br>
					<form name='survey_list_form' id='survey_list_form' method='POST' action=''>
						<input type='hidden' name='page_action' value=''>
						<input type='hidden' name='survey_id' value=''>
					</form>
					</center>
					<script language='JavaScript'> init_survey_summary(); </script>
<!-- MAIN PAGE CONTENT [end] -->				
<?php include_once('./include/footer.php'); ?>
					<script language='JavaScript'>
<?php
					// alert the user if the clone action completed successfully
					if($page_action == 'clone_survey' && strlen($cloned_survey_name) > 0){
						echo "alert(\"[ SUCCESS ]\\nSurvey has been cloned and is now under the DRAFTS tab.\\nThe name of the cloned survey is '".to_js_str($cloned_survey_name)."'.\");\n";
					}
?>
					</script>
