<?php 
	require_once('./pear/DB.php');
	include_once('./settings/settings.php');
	include_once('./include/globals.php');
	include_once('./include/loader.php');
	include_once('./include/login_functions.php');
	// make sure the user has logged in before accessing this page
	if(($user_struct = get_login_status()) === FALSE){ header("Location: login.php"); exit(0); }
	// make sure the user is an administrator. if not, redirect to the survey list page
	if($user_struct['user_type_id'] != $UID_ADMIN){ header("Location: survey_list.php"); exit(0); }

	include_once('./include/functions.php');
	include_once('./include/page_specific/system_options.php');

	// place to store all error messages
	$error_log = Array();
	$info_log = Array();

	// make sure all variables that may be passed in get declared
	$page_action = isset($_REQUEST['page_action']) ? $_REQUEST['page_action'] : 'load_settings';
	$smtp_server = isset($_REQUEST['smtp_server']) ? $_REQUEST['smtp_server'] : '';
	$valid_file_ext = isset($_REQUEST['valid_file_ext']) ? $_REQUEST['valid_file_ext'] : '';

	// do some state specific actions 
	if($page_action == 'save_settings'){
		save_settings($smtp_server,$valid_file_ext);
	}
	if($page_action == 'load_settings'){
		$settings_struct = get_settings_struct();
		$valid_file_ext = isset($settings_struct['pub_point_file_ext']) ? $settings_struct['pub_point_file_ext'] : '';
		$smtp_server = isset($settings_struct['smtp_server']) ? $settings_struct['smtp_server'] : '';
	} // end if

	// define some template specific variables
	$PAGE_TITLE = "Webupdate | eSurvey 2.0 :: System :: Options";
	$PAGE_HEADER_TEXT = "SYSTEM &#160;<span style='font-size:10px;'>[SYSTEM OPTIONS]</span>";
	include_once('./include/header.php'); 
	include_once('./include/section_header.php'); 
?>
<!-- MAIN PAGE CONTENT [start] -->				
					<style type='text/css'>
					<!--
						.l_tab_label{
							font: normal normal normal 9px Verdana,Tahoma,Arial,Helvetica,Sans-serif,sans-serif;
							color: #4f5161;
							line-height: 11px;
							text-decoration: none;
						}
						.l_tab_label:hover {
							font: normal normal normal 9px Verdana,Tahoma,Arial,Helvetica,Sans-serif,sans-serif;
							color: #4f5161;
							line-height: 11px;
							text-decoration: underline;
						}
					-->
					</style>
					<script language='JavaScript' src='./js/form_utils.js'></script>
					<script language='JavaScript' src='./js/page_specific/system_options.js'></script>

					<img width='1' height='8' src='./images/global/other/other_clear_spacer.gif' hspace='0' vspace='0' border='0'><br>
					<center>
					<form name='system_options_form' id='system_options_form' method='POST' action='<?php echo $_SERVER['PHP_SELF']; ?>'>

					<table cellspacing='0' cellpadding='0' border='0'>
					<tr>
						<td width='696' align='center' valign='top' bgcolor='#dcdcdf'>
							<img width='1' height='8' src='./images/global/other/other_clear_spacer.gif' hspace='0' vspace='0' border='0'><br>
							<table cellspacing='0' cellpadding='0' border='0'>
							<tr>
								<td colspan='3' width='676' height='30' align='left' valign='bottom' background='./images/system/other/other_tab_area_bg.gif'>
									<table cellspacing='0' cellpadding='0' border='0'>
									<tr>
										<td width='146' height='30' align='center' valign='middle' bgcolor='#91b6be' background='./images/system/other/other_tab_bg_off.gif'><a href='system_user_management.php' class='l_tab_label'>USER MANAGEMENT</a><br></td>
										<td width='4' height='30'><img width='1' height='1' src='./images/global/other/other_clear_spacer.gif' hspace='0' vspace='0' border='0'><br></td>
										<td width='146' height='30' align='center' valign='middle' bgcolor='#cfe1e5' background='./images/system/other/other_tab_bg_on.gif'><span class='l_tab_label'>SYSTEM OPTIONS</span><br></td>
										<td width='4' height='30'><img width='1' height='1' src='./images/global/other/other_clear_spacer.gif' hspace='0' vspace='0' border='0'><br></td>
										<td width='146' height='30' align='center' valign='middle' bgcolor='#91b6be' background='./images/system/other/other_tab_bg_off.gif'><a href='system_pub_points.php' class='l_tab_label'>PUBLISH POINTS</a><br></td>
									</tr>
									</table>
								</td>
							</tr>
							<tr>
								<td width='1' bgcolor='#4f5161'><img width='1' height='1' src='./images/global/other/other_clear_spacer.gif' hspace='0' vspace='0' border='0'><br></td>
								<td width='674' align='center' valign='top' bgcolor='#cfe1e5'>
									<img width='1' height='8' src='./images/global/other/other_clear_spacer.gif' hspace='0' vspace='0' border='0'><br>
									<table cellspacing='0' cellpadding='0' border='0'>
									<tr>
										<td width='327' align='left' valign='top'>
<!-- USER DETAILS [start] -->
											<table cellspacing='0' cellpadding='0' border='0'>
											<tr>
												<td width='327' colspan='3' height='20' align='left' valign='middle' bgcolor='#4f5161'>
													<table cellspacing='0' cellpadding='0' border='0'>
													<tr>
														<td width='239'>
															<table cellspacing='0' cellpadding='0' border='0'>
															<tr>
																<td><span class='g_sub_section_header'><b>Database Details</b></span></td>
																<td><a href='JavaScript:void(0);' onclick='popup_context_help("./help/system_options.html#DatabaseDetails");'><img onmouseover='this.src=icon_context_help_on.src;' onmouseout='this.src=icon_context_help_off.src;' width='13' height='13' src='./images/global/icon/icon_context_help_off.gif' alt='Help' title='Help' hspace='0' vspace='0' border='0'></a><br></td>
															</tr>
															</table>
														</td>
													</tr>
													</table>
												</td>
											</tr>
											<tr>
												<td width='1' bgcolor='#4f5161'><img width='1' height='1' src='./images/global/other/other_clear_spacer.gif' hspace='0' vspace='0' border='0'><br></td>
												<td width='325' height='194' align='left' valign='top' bgcolor='#ffffff' background='./images/system/other/other_pp_form_bg.gif'>
													<img width='1' height='3' src='./images/global/other/other_clear_spacer.gif' hspace='0' vspace='0' border='0'><br>
													<input type='hidden' id='page_action' name='page_action' value=''>
													<table cellspacing='0' cellpadding='0' border='0'>
													<tr>
														<td width='18' height='23' align='center' valign='middle'><img id='db_server_name_err_img' width='14' height='14' src='./images/global/other/other_clear_spacer.gif' hspace='0' vspace='0' border='0'><br></td>
														<td id='db_server_name_label' width='100' height='23' align='right' valign='middle' class='g_form_field_label'>Server Name: &#160;<br></td>
														<td width='207' height='23' align='left' valign='middle'><input readonly type='text' id='db_server_name' name='db_server_name' value='<?php echo to_html_attrib_str($DB_SERVER_NAME); ?>' class='g_form_text_input_disabled' style='width:196px; margin-left:5px;'></td>
													</tr>
													<tr>
														<td width='18' height='23' align='center' valign='middle'><img id='db_database_name_err_img' width='14' height='14' src='./images/global/other/other_clear_spacer.gif' hspace='0' vspace='0' border='0'><br></td>
														<td id='db_database_name_label' width='100' height='23' align='right' valign='middle' class='g_form_field_label'>Database Name: &#160;<br></td>
														<td width='207' height='23' align='left' valign='middle'><input readonly type='text' id='db_database_name' name='db_database_name' value='<?php echo to_html_attrib_str($DB_NAME); ?>' class='g_form_text_input_disabled' style='width:196px; margin-left:5px;'></td>
													</tr>
													<tr>
														<td width='18' height='23' align='center' valign='middle'><img id='db_user_name_err_img' width='14' height='14' src='./images/global/other/other_clear_spacer.gif' hspace='0' vspace='0' border='0'><br></td>
														<td id='db_user_name_label' width='100' height='23' align='right' valign='middle' class='g_form_field_label'>User Name: &#160;<br></td>
														<td width='207' height='23' align='left' valign='middle'><input readonly type='text' id='db_user_name' name='db_user_name' value='<?php echo to_html_attrib_str($DB_USER_NAME); ?>' class='g_form_text_input_disabled' style='width:196px; margin-left:5px;'></td>
													</tr>
													</table>
												</td>
												<td width='1' bgcolor='#4f5161'><img width='1' height='1' src='./images/global/other/other_clear_spacer.gif' hspace='0' vspace='0' border='0'><br></td>
											</tr>
											<tr>
												<td colspan='3' width='327' height='1' bgcolor='#4f5161'><img width='1' height='1' src='./images/global/other/other_clear_spacer.gif' hspace='0' vspace='0' border='0'><br></td>
											</tr>
											</table>
<!-- SYSTEM DETAILS [end] -->
										</td>
										<td width='7'><img width='1' height='1' src='./images/global/other/other_clear_spacer.gif' hspace='0' vspace='0' border='0'><br></td>
										<td width='327' align='left' valign='top'>
<!-- DATABASE DETAILS [start] -->
											<table cellspacing='0' cellpadding='0' border='0'>
											<tr>
												<td width='327' colspan='3' height='20' align='left' valign='middle' bgcolor='#4f5161'>
													<table cellspacing='0' cellpadding='0' border='0'>
													<tr>
														<td width='239'>
															<table cellspacing='0' cellpadding='0' border='0'>
															<tr>
																<td><span class='g_sub_section_header'><b>Misc. Details</b></span></td>
																<td><a href='JavaScript:void(0);' onclick='popup_context_help("./help/system_options.html#MiscDetails");'><img onmouseover='this.src=icon_context_help_on.src;' onmouseout='this.src=icon_context_help_off.src;' width='13' height='13' src='./images/global/icon/icon_context_help_off.gif' alt='Help' title='Help' hspace='0' vspace='0' border='0'></a><br></td>
															</tr>
															</table>
														</td>
													</tr>
													</table>
												</td>
											</tr>
											<tr>
												<td width='1' bgcolor='#4f5161'><img width='1' height='1' src='./images/global/other/other_clear_spacer.gif' hspace='0' vspace='0' border='0'><br></td>
												<td width='325' height='194' align='left' valign='top' bgcolor='#ffffff' background='./images/system/other/other_pp_form_bg.gif'>
													<img width='1' height='3' src='./images/global/other/other_clear_spacer.gif' hspace='0' vspace='0' border='0'><br>
													<table cellspacing='0' cellpadding='0' border='0'>
													<tr>
														<td width='18' height='23' align='center' valign='middle'><img id='smtp_server_err_img' width='14' height='14' src='./images/global/other/other_clear_spacer.gif' hspace='0' vspace='0' border='0'><br></td>
														<td id='smtp_server_label' width='100' height='23' align='right' valign='middle' class='g_form_field_label'>SMTP Server: &#160;<br></td>
														<td width='207' height='23' align='left' valign='middle'><input type='text' id='smtp_server' name='smtp_server' value='<?php echo to_html_attrib_str($smtp_server); ?>' maxlength='256' class='g_form_text_input' style='width:196px; margin-left:5px;'></td>
													</tr>
													<tr>
														<td width='18' height='23' align='center' valign='middle'><img id='valid_file_ext_err_img' width='14' height='14' src='./images/global/other/other_clear_spacer.gif' hspace='0' vspace='0' border='0'><br></td>
														<td id='valid_file_ext_label' width='100' height='23' align='right' valign='middle' class='g_form_field_label'>File Extensions: &#160;<br></td>
														<td width='207' height='23' align='left' valign='middle'><input type='text' id='valid_file_ext' name='valid_file_ext' value='<?php echo to_html_attrib_str($valid_file_ext); ?>' class='g_form_text_input' style='width:196px; margin-left:5px;'></td>
													</tr>
													</table>
												</td>
												<td width='1' bgcolor='#4f5161'><img width='1' height='1' src='./images/global/other/other_clear_spacer.gif' hspace='0' vspace='0' border='0'><br></td>
											</tr>
											<tr>
												<td colspan='3' width='327' height='1' bgcolor='#4f5161'><img width='1' height='1' src='./images/global/other/other_clear_spacer.gif' hspace='0' vspace='0' border='0'><br></td>
											</tr>
											</table>

<!-- DATABASE DETAILS [end] -->
										</td>
									</tr>
									</table>
									<img width='1' height='8' src='./images/global/other/other_clear_spacer.gif' hspace='0' vspace='0' border='0'><br>
								</td>
								<td width='1' bgcolor='#4f5161'><img width='1' height='1' src='./images/global/other/other_clear_spacer.gif' hspace='0' vspace='0' border='0'><br></td>
							</tr>
							<tr>
								<td colspan='3' width='676' height='1' bgcolor='#4f5161'><img width='1' height='1' src='./images/global/other/other_clear_spacer.gif' hspace='0' vspace='0' border='0'><br></td>
							</tr>
							</table>
							<img width='1' height='8' src='./images/global/other/other_clear_spacer.gif' hspace='0' vspace='0' border='0'><br>
						</td>
					</tr>
					<tr>
						<td height='30' align='right' valign='bottom'>
							<a align='right' href='survey_list.php'><img width='73' height='19' onmouseover='this.src=bttn_cancel_on.src;' onmouseout='this.src=bttn_cancel_off.src;' src='./images/global/button/bttn_cancel_off.gif' alt='Cancel' title='Cancel' hspace='2' vspace='0' border='0'></a>
							<a align='right' href='JavaScript:void(0);' onmouseup='save_system_options_onmouseup();'><img width='73' height='19' onmouseover='this.src=bttn_save_on.src;' onmouseout='this.src=bttn_save_off.src;' src='./images/global/button/bttn_save_off.gif' alt='Save' title='Save' hspace='0' vspace='0' border='0'></a><br>
						</td>
					</tr>
					</table>

					</form>
					</center>
					<img width='1' height='5' src='./images/global/other/other_clear_spacer.gif' hspace='0' vspace='0' border='0'><br>

<!-- MAIN PAGE CONTENT [end] -->				
<?php include_once('./include/footer.php'); ?>
