<?php 
	require_once('./pear/DB.php');
	include_once('./settings/settings.php');
	include_once('./include/globals.php');
	include_once('./include/loader.php');
	include_once('./include/login_functions.php');
	// make sure the user has logged in before accessing this page
	if(($user_struct = get_login_status()) === FALSE){ header("Location: login.php"); exit(0); }
	// make sure the user is an administrator. if not, redirect to the survey list page
	if($user_struct['user_type_id'] != $UID_ADMIN){ header("Location: survey_list.php"); exit(0); }

	include_once('./include/functions.php');
	include_once('./include/page_specific/system_pub_points.php');

	// place to store all error messages
	$error_log = Array();
	$info_log = Array();

	// make sure all variables that may be passed in get declared
	$page_action = isset($_REQUEST['page_action']) ? $_REQUEST['page_action'] : '';
	$publish_point_id = isset($_REQUEST['publish_point_id']) ? $_REQUEST['publish_point_id'] : '';
	$ftp_server_name = isset($_REQUEST['ftp_server_name']) ? $_REQUEST['ftp_server_name'] : '';
	$ftp_user_name = isset($_REQUEST['ftp_user_name']) ? $_REQUEST['ftp_user_name'] : '';
	$ftp_user_password = isset($_REQUEST['ftp_user_password']) ? $_REQUEST['ftp_user_password'] : '';
	$ftp_user_password2 = isset($_REQUEST['ftp_user_password2']) ? $_REQUEST['ftp_user_password2'] : '';
	$ftp_port_num = isset($_REQUEST['ftp_port_num']) ? $_REQUEST['ftp_port_num'] : '21';
	$ftp_is_passive = isset($_REQUEST['ftp_is_passive']) ? $_REQUEST['ftp_is_passive'] : 0;
	$ftp_default_dir = isset($_REQUEST['ftp_default_dir']) ? $_REQUEST['ftp_default_dir'] : '';

	// perform some state specific actions
	if($page_action == 'save_pub_point'){
		// strip of any leading 'ftp://' string from server name
		$ftp_server_name = preg_replace("/^ftp:\/\//","",trim($ftp_server_name));
		// remove tailing slashes
		$ftp_server_name = preg_replace("/\/$/","",$ftp_server_name);
		$ftp_server_name = preg_replace("/\\\\$/","",$ftp_server_name);

		// attempt to save the publish point data to the DB.
		$publish_point_id = save_publish_point($publish_point_id,$ftp_server_name,$ftp_user_name,$ftp_user_password,$ftp_port_num,$ftp_is_passive,$ftp_default_dir);
	}
	elseif($page_action == 'load_pub_point'){
		// get the details about the publish point
		$pub_point_struct = get_pub_point_struct($publish_point_id);
		if($pub_point_struct !== FALSE){
			// populate our form variables with this info
			$ftp_server_name = $pub_point_struct['server_name'];
			$ftp_user_name = $pub_point_struct['user_name'];
			$ftp_user_password = $ftp_user_password2 = $pub_point_struct['password'];
			$ftp_port_num = $pub_point_struct['port_num'];
			$ftp_is_passive = $pub_point_struct['is_passive'];
			$ftp_default_dir = $pub_point_struct['default_dir'];
		} // end if
	} // end if
	elseif($page_action == 'delete_pub_point'){
		if(strlen($publish_point_id) > 0 && is_numeric($publish_point_id)){
			$query = "UPDATE esy_publish_points SET rec_status_id = 0 WHERE publish_point_id = ${publish_point_id} AND rec_status_id = 1";
			$db_result = $DBH->query($query);
			if(DB::isError($db_result)){ die($db_result->message.'<br>'.$db_result->userinfo); }
		}
	} // end elseif

	// define some template specific variables
	$PAGE_TITLE = "Webupdate | eSurvey 2.0 :: System :: Publish Points";
	$PAGE_HEADER_TEXT = "SYSTEM &#160;<span style='font-size:10px;'>[PUBLISH POINTS]</span>";
	include_once('./include/header.php'); 
	include_once('./include/section_header.php'); 
?>
<!-- MAIN PAGE CONTENT [start] -->				
					<style type='text/css'>
					<!--
						.l_tab_label{
							font: normal normal normal 9px Verdana,Tahoma,Arial,Helvetica,Sans-serif,sans-serif;
							color: #4f5161;
							line-height: 11px;
							text-decoration: none;
						}
						.l_tab_label:hover {
							font: normal normal normal 9px Verdana,Tahoma,Arial,Helvetica,Sans-serif,sans-serif;
							color: #4f5161;
							line-height: 11px;
							text-decoration: underline;
						}
						.l_pp_list_area {
							width: 323px;
							height: 194px;
							background-color: #cfe1e5;
							overflow: scroll;
							overflow-x: hidden;
							overflow-y: scroll;
						}
						.l_pp_item {
							width: 263px;
							font: normal normal normal 9px Verdana,Tahoma,Arial,Helvetica,Sans-serif,sans-serif;
							color: #000000;
							line-height: 11px;
							overflow: hidden;
							text-overflow: ellipsis;
						}
						.l_pp_link {
							color: #000000;
							text-decoration: none;
						}
						.l_pp_link:hover {
							color: #000000;
							text-decoration: underline;
						}
						.l_pp_active_link {
							font-weight: bold;
							color: #297181;
							text-decoration: none;
						}
						.l_pp_active_link:hover {
							font-weight: bold;
							color: #297181;
							text-decoration: underline;
						}

					-->
					</style>
					<script language='JavaScript' src='./js/form_utils.js'></script>
					<script language='JavaScript' src='./js/page_specific/system_pub_points.js'></script>

					<img width='1' height='8' src='./images/global/other/other_clear_spacer.gif' hspace='0' vspace='0' border='0'><br>
					<center>
					<form name='system_pub_point_form' id='system_pub_point_form' method='POST' action='<?php echo $_SERVER['PHP_SELF']; ?>'>

					<table cellspacing='0' cellpadding='0' border='0'>
					<tr>
						<td width='696' align='center' valign='top' bgcolor='#dcdcdf'>
							<img width='1' height='8' src='./images/global/other/other_clear_spacer.gif' hspace='0' vspace='0' border='0'><br>
							<table cellspacing='0' cellpadding='0' border='0'>
							<tr>
								<td colspan='3' width='676' height='30' align='left' valign='bottom' background='./images/system/other/other_tab_area_bg.gif'>
									<table cellspacing='0' cellpadding='0' border='0'>
									<tr>
										<td width='146' height='30' align='center' valign='middle' bgcolor='#91b6be' background='./images/system/other/other_tab_bg_off.gif'><a href='system_user_management.php' class='l_tab_label'>USER MANAGEMENT</a><br></td>
										<td width='4' height='30'><img width='1' height='1' src='./images/global/other/other_clear_spacer.gif' hspace='0' vspace='0' border='0'><br></td>
										<td width='146' height='30' align='center' valign='middle' bgcolor='#91b6be' background='./images/system/other/other_tab_bg_off.gif'><a href='system_options.php' class='l_tab_label'>SYSTEM OPTIONS</a><br></td>
										<td width='4' height='30'><img width='1' height='1' src='./images/global/other/other_clear_spacer.gif' hspace='0' vspace='0' border='0'><br></td>
										<td width='146' height='30' align='center' valign='middle' bgcolor='#cfe1e5' background='./images/system/other/other_tab_bg_on.gif'><span class='l_tab_label'>PUBLISH POINTS</span><br></td>
									</tr>
									</table>
								</td>
							</tr>
							<tr>
								<td width='1' bgcolor='#4f5161'><img width='1' height='1' src='./images/global/other/other_clear_spacer.gif' hspace='0' vspace='0' border='0'><br></td>
								<td width='674' align='center' valign='top' bgcolor='#cfe1e5'>

									<img width='1' height='8' src='./images/global/other/other_clear_spacer.gif' hspace='0' vspace='0' border='0'><br>
									<table cellspacing='0' cellpadding='0' border='0'>
									<tr>
										<td width='328' align='left' valign='top'>
<!-- PUBLISH POINT DETAILS [start] -->
											<table cellspacing='0' cellpadding='0' border='0'>
											<tr>
												<td width='328' colspan='3' height='20' align='left' valign='middle' bgcolor='#4f5161'>
													<table cellspacing='0' cellpadding='0' border='0'>
													<tr>
														<td width='255'>
															<table cellspacing='0' cellpadding='0' border='0'>
															<tr>
																<td><span class='g_sub_section_header'><b>Publish Point Details</b></span></td>
																<td><a href='JavaScript:void(0);' onclick='popup_context_help("./help/publish_points.html#PublishPointDetails");'><img onmouseover='this.src=icon_context_help_on.src;' onmouseout='this.src=icon_context_help_off.src;' width='13' height='13' src='./images/global/icon/icon_context_help_off.gif' alt='Help' title='Help' hspace='0' vspace='0' border='0'></a><br></td>
															</tr>
															</table>
														</td>
														<td width='73' align='right'><a href='system_pub_points.php'><img onmouseover='this.src=bttn_new_publish_point_on.src;' onmouseout='this.src=bttn_new_publish_point_off.src;' align='right' width='94' height='19' src='./images/system/button/bttn_new_publish_point_off.gif' alt='New Publish Point' title='New Publish Point' hspace='0' vspace='0' border='0'></a></td>
													</tr>
													</table>
												</td>
											</tr>
											<tr>
												<td width='1' bgcolor='#4f5161'><img width='1' height='1' src='./images/global/other/other_clear_spacer.gif' hspace='0' vspace='0' border='0'><br></td>
												<td width='326' height='194' align='left' valign='top' bgcolor='#ffffff' background='./images/system/other/other_pp_form_bg.gif'>
													<img width='1' height='3' src='./images/global/other/other_clear_spacer.gif' hspace='0' vspace='0' border='0'><br>
													<input type='hidden' id='publish_point_id' name='publish_point_id' value='<?php echo to_html_attrib_str($publish_point_id); ?>'>
													<input type='hidden' id='page_action' name='page_action' value=''>
													<table cellspacing='0' cellpadding='0' border='0'>
													<tr>
														<td width='18' height='23' align='center' valign='middle'><img id='ftp_server_name_err_img' width='14' height='14' src='./images/global/other/other_clear_spacer.gif' hspace='0' vspace='0' border='0'><br></td>
														<td id='ftp_server_name_label' width='100' height='23' align='right' valign='middle' class='g_form_field_label'>URL/IP Address: &#160;<br></td>
														<td width='208' height='23' align='left' valign='middle'><input type='text' id='ftp_server_name' name='ftp_server_name' value='<?php echo to_html_attrib_str($ftp_server_name); ?>' maxlength='512' class='g_form_text_input' style='width:196px; margin-left:5px;'></td>
													</tr>
													<tr>
														<td width='18' height='23' align='center' valign='middle'><img id='ftp_user_name_err_img' width='14' height='14' src='./images/global/other/other_clear_spacer.gif' hspace='0' vspace='0' border='0'><br></td>
														<td id='ftp_user_name_label' width='100' height='23' align='right' valign='middle' class='g_form_field_label'>User Name: &#160;<br></td>
														<td width='208' height='23' align='left' valign='middle'><input type='text' id='ftp_user_name' name='ftp_user_name' value='<?php echo to_html_attrib_str($ftp_user_name); ?>' maxlength='256' class='g_form_text_input' style='width:196px; margin-left:5px;'></td>
													</tr>
													<tr>
														<td width='18' height='23' align='center' valign='middle'><img id='ftp_user_password_err_img' width='14' height='14' src='./images/global/other/other_clear_spacer.gif' hspace='0' vspace='0' border='0'><br></td>
														<td id='ftp_user_password_label' width='100' height='23' align='right' valign='middle' class='g_form_field_label'>Password: &#160;<br></td>
														<td width='208' height='23' align='left' valign='middle'><input type='password' id='ftp_user_password' name='ftp_user_password' value='<?php echo to_html_attrib_str($ftp_user_password); ?>' maxlength='256' class='g_form_text_input' style='width:196px; margin-left:5px;'></td>
													</tr>
													<tr>
														<td width='18' height='23' align='center' valign='middle'><img id='ftp_user_password2_err_img' width='14' height='14' src='./images/global/other/other_clear_spacer.gif' hspace='0' vspace='0' border='0'><br></td>
														<td id='ftp_user_password2_label' width='100' height='23' align='right' valign='middle' class='g_form_field_label'>Retype Password: &#160;<br></td>
														<td width='208' height='23' align='left' valign='middle'><input type='password' id='ftp_user_password2' name='ftp_user_password2' value='<?php echo to_html_attrib_str($ftp_user_password2); ?>' maxlength='256' class='g_form_text_input' style='width:196px; margin-left:5px;'></td>
													</tr>
													<tr>
														<td width='18' height='23' align='center' valign='middle'><img id='ftp_port_num_err_img' width='14' height='14' src='./images/global/other/other_clear_spacer.gif' hspace='0' vspace='0' border='0'><br></td>
														<td id='ftp_port_num_label' width='100' height='23' align='right' valign='middle' class='g_form_field_label'>Port #: &#160;<br></td>
														<td width='208' height='23' align='left' valign='middle'><input type='text' id='ftp_port_num' name='ftp_port_num' value='<?php echo to_html_attrib_str($ftp_port_num); ?>' maxlength='5' class='g_form_text_input' style='width:196px; margin-left:5px;'></td>
													</tr>
													<tr>
														<td width='18' height='23' align='center' valign='middle'><img id='ftp_is_passive_err_img' width='14' height='14' src='./images/global/other/other_clear_spacer.gif' hspace='0' vspace='0' border='0'><br></td>
														<td id='ftp_is_passive_label' width='100' height='23' align='right' valign='middle' class='g_form_field_label'>Passive Mode: &#160;<br></td>
														<td width='208' height='23' align='left' valign='middle'>
															<select id='ftp_is_passive' name='ftp_is_passive' size='1' class='g_form_select' style='width:196px; margin-left:5px;'>
																<option class='g_form_select_option' value='0' <?php echo ($ftp_is_passive == 0) ? 'selected' : ''; ?>>No</option>
																<option class='g_form_select_option' value='1' <?php echo ($ftp_is_passive == 1) ? 'selected' : ''; ?>>Yes</option>
															</select>
														</td>
													</tr>
													<tr>
														<td width='18' height='23' align='center' valign='middle'><img id='ftp_default_dir_err_img' width='14' height='14' src='./images/global/other/other_clear_spacer.gif' hspace='0' vspace='0' border='0'><br></td>
														<td id='ftp_default_dir_label' width='100' height='23' align='right' valign='middle' class='g_form_field_label'>Default Path: &#160;<br></td>
														<td width='208' height='23' align='left' valign='middle'><input type='text' id='ftp_default_dir' name='ftp_default_dir' value='<?php echo to_html_attrib_str($ftp_default_dir); ?>' class='g_form_text_input' style='width:196px; margin-left:5px;'></td>
													</tr>
													<tr>
														<td colspan='3' width='328' height='23' align='right' valign='bottom'><a href='JavaScript:void(0);' onmouseup='test_conn_onmouseup();'><img onmouseover='this.src=bttn_test_connection_on.src;' onmouseout='this.src=bttn_test_connection_off.src;' align='right' width='94' height='19' src='./images/system/button/bttn_test_connection_off.gif' alt='Test Connection' title='Test Connection' hspace='8' vspace='0' border='0'></a></td>
													</tr>
													</table>
												</td>
												<td width='1' bgcolor='#4f5161'><img width='1' height='1' src='./images/global/other/other_clear_spacer.gif' hspace='0' vspace='0' border='0'><br></td>
											</tr>
											<tr>
												<td colspan='3' width='328' height='1' bgcolor='#4f5161'><img width='1' height='1' src='./images/global/other/other_clear_spacer.gif' hspace='0' vspace='0' border='0'><br></td>
											</tr>
											</table>
<!-- PUBLISH POINT DETAILS [end] -->
										</td>
										<td width='8'><img width='1' height='1' src='./images/global/other/other_clear_spacer.gif' hspace='0' vspace='0' border='0'><br></td>
										<td width='325' align='left' valign='top'>
<!-- PUBLISH POINT LIST [start] -->
											<table cellspacing='0' cellpadding='0' border='0'>
											<tr>
												<td width='325' colspan='3' height='20' align='left' valign='middle' bgcolor='#4f5161'>
													<table cellspacing='0' cellpadding='0' border='0'>
													<tr>
														<td><span class='g_sub_section_header'><b>Publish Point List</b></span></td>
														<td><a href='JavaScript:void(0);' onclick='popup_context_help("./help/publish_points.html#PublishPointsList");'><img onmouseover='this.src=icon_context_help_on.src;' onmouseout='this.src=icon_context_help_off.src;' width='13' height='13' src='./images/global/icon/icon_context_help_off.gif' alt='Help' title='Help' hspace='0' vspace='0' border='0'></a><br></td>
													</tr>
													</table>
												</td>
											</tr>
											<tr>
												<td width='1' bgcolor='#4f5161'><img width='1' height='1' src='./images/global/other/other_clear_spacer.gif' hspace='0' vspace='0' border='0'><br></td>
												<td width='323' align='left' valign='top' bgcolor='#ffffff'>
													<div class='l_pp_list_area'>
														<?php echo get_pub_point_list_html($publish_point_id); ?>
													</div>
												</td>
												<td width='1' bgcolor='#4f5161'><img width='1' height='1' src='./images/global/other/other_clear_spacer.gif' hspace='0' vspace='0' border='0'><br></td>
											</tr>
											<tr>
												<td colspan='3' width='328' height='1' bgcolor='#4f5161'><img width='1' height='1' src='./images/global/other/other_clear_spacer.gif' hspace='0' vspace='0' border='0'><br></td>
											</tr>
											</table>
<!-- PUBLISH POINT LIST [end] -->
										</td>
									</tr>
									</table>
									<img width='1' height='8' src='./images/global/other/other_clear_spacer.gif' hspace='0' vspace='0' border='0'><br>
								</td>
								<td width='1' bgcolor='#4f5161'><img width='1' height='1' src='./images/global/other/other_clear_spacer.gif' hspace='0' vspace='0' border='0'><br></td>
							</tr>
							<tr>
								<td colspan='3' width='676' height='1' bgcolor='#4f5161'><img width='1' height='1' src='./images/global/other/other_clear_spacer.gif' hspace='0' vspace='0' border='0'><br></td>
							</tr>
							</table>
							<img width='1' height='8' src='./images/global/other/other_clear_spacer.gif' hspace='0' vspace='0' border='0'><br>
						</td>
					</tr>
					<tr>
						<td height='30' align='right' valign='bottom'>
							<a align='right' href='survey_list.php'><img width='73' height='19' onmouseover='this.src=bttn_cancel_on.src;' onmouseout='this.src=bttn_cancel_off.src;' src='./images/global/button/bttn_cancel_off.gif' alt='Cancel' title='Cancel' hspace='2' vspace='0' border='0'></a>
							<a align='right' href='JavaScript:void(0);' onmouseup='save_pub_point_onmouseup();'><img width='73' height='19' onmouseover='this.src=bttn_save_on.src;' onmouseout='this.src=bttn_save_off.src;' src='./images/global/button/bttn_save_off.gif' alt='Save' title='Save' hspace='0' vspace='0' border='0'></a><br>
						</td>
					</tr>
					</table>

					</form>
					</center>
					<img width='1' height='5' src='./images/global/other/other_clear_spacer.gif' hspace='0' vspace='0' border='0'><br>

<!-- MAIN PAGE CONTENT [end] -->				
<?php include_once('./include/footer.php'); ?>
